<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/tracker/lib/Tracker.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerPeer.php';
 

// (on-demand) include_once 'core/MyReport.php';
// (on-demand) include_once 'core/MyReportPeer.php';

include_once 'core/MyReportTrackerPeer.php';

/**
 * Base class that represents a row from the 'my_report_tracker' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to MyReportTracker class. 
 * 
 * @package core 
 */
abstract class BaseMyReportTracker extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var MyReportTrackerPeer
	 */
	protected static $peer;

	/**
	 * The value for the my_report_id field.
	 * @var int	  
	 */
	protected $my_report_id;	

	/**
	 * The value for the tracker_id field.
	 * @var int	  
	 */
	protected $tracker_id;	
  
	/**
	 * Get the MyReportId column value.
	 *  
	 * @return int	  
	 */
	public function getMyReportId()
	{
		return $this->my_report_id;
	}


	/**
	 * Set the value of `my_report_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setMyReportId($v)
	{
		if ($this->my_report_id !== $v) {
			$this->my_report_id = $v;
			$this->modifiedColumns[] = MyReportTrackerPeer::MY_REPORT_ID;
		}
			
		if ($this->aMyReport !== null && $this->aMyReport->getMyReportId() !== $v) {
			$this->aMyReport = null;
		}
			
	}

  
	/**
	 * Get the TrackerId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerId()
	{
		return $this->tracker_id;
	}


	/**
	 * Set the value of `tracker_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerId($v)
	{
		if ($this->tracker_id !== $v) {
			$this->tracker_id = $v;
			$this->modifiedColumns[] = MyReportTrackerPeer::TRACKER_ID;
		}
			
		if ($this->aTracker !== null && $this->aTracker->getTrackerId() !== $v) {
			$this->aTracker = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->my_report_id = $rs->getInt($startcol + 0);					
			$this->tracker_id = $rs->getInt($startcol + 1);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating MyReportTracker object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(MyReportTrackerPeer::DATABASE_NAME);
		$criteria->add(MyReportTrackerPeer::MY_REPORT_ID, $this->my_report_id);
		$criteria->add(MyReportTrackerPeer::TRACKER_ID, $this->tracker_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(MyReportTrackerPeer::DATABASE_NAME);
		if ($this->isColumnModified(MyReportTrackerPeer::MY_REPORT_ID)) $criteria->add(MyReportTrackerPeer::MY_REPORT_ID, $this->my_report_id);
		if ($this->isColumnModified(MyReportTrackerPeer::TRACKER_ID)) $criteria->add(MyReportTrackerPeer::TRACKER_ID, $this->tracker_id);
		return $criteria;			
	}
	
	

	/**
	 * @var Tracker	  
	 */
	protected $aTracker;

	/**
	 * Declares an association between this object and a Tracker object
	 *
	 * @param Tracker $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTracker($v)
	{
			
		if ($v === null) {
			$this->setTrackerId(NULL);
		} else {
			$this->setTrackerId($v->getTrackerId());
		}
   
		$this->aTracker = $v;
	}


	/**
	 * Get the associated Tracker object
	 *
	 * @param Connection Optional Connection object.
	 * @return Tracker The associated Tracker object.
	 * @throws PropelException
	 */
	public function getTracker($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerPeer.php';

		if ($this->aTracker === null && ($this->tracker_id !== null)) {
	
			$this->aTracker = TrackerPeer::retrieveByPK($this->tracker_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerPeer::retrieveByPK($this->tracker_id, $con);
			   $obj->addMyReportTrackers($this);
			 */
		}
		return $this->aTracker;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerKey($key)
	{

		$this->setTrackerId( (int) $key);			
		
	}

	/**
	 * @var MyReport	  
	 */
	protected $aMyReport;

	/**
	 * Declares an association between this object and a MyReport object
	 *
	 * @param MyReport $v
	 * @return void
	 * @throws PropelException
	 */
	public function setMyReport($v)
	{
			
		if ($v === null) {
			$this->setMyReportId(NULL);
		} else {
			$this->setMyReportId($v->getMyReportId());
		}
   
		$this->aMyReport = $v;
	}


	/**
	 * Get the associated MyReport object
	 *
	 * @param Connection Optional Connection object.
	 * @return MyReport The associated MyReport object.
	 * @throws PropelException
	 */
	public function getMyReport($con = null)
	{
		// include the Peer class
		include_once 'core/MyReportPeer.php';

		if ($this->aMyReport === null && ($this->my_report_id !== null)) {
	
			$this->aMyReport = MyReportPeer::retrieveByPK($this->my_report_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = MyReportPeer::retrieveByPK($this->my_report_id, $con);
			   $obj->addMyReportTrackers($this);
			 */
		}
		return $this->aMyReport;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setMyReportKey($key)
	{

		$this->setMyReportId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("my_report_id", "tracker_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case MyReportTrackerPeer::MY_REPORT_ID:
				return $this->getMyReportId();
				break;
		  
			case MyReportTrackerPeer::TRACKER_ID:
				return $this->getTrackerId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getMyReportId();
				break;
  
			case 1:
				return $this->getTrackerId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(MyReportTrackerPeer::MY_REPORT_ID, $arr)) $this->setMyReportId($arr[MyReportTrackerPeer::MY_REPORT_ID]);
  
		if (array_key_exists(MyReportTrackerPeer::TRACKER_ID, $arr)) $this->setTrackerId($arr[MyReportTrackerPeer::TRACKER_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case MyReportTrackerPeer::MY_REPORT_ID:
				$this->setMyReportId($value);
				break;
	  
			case MyReportTrackerPeer::TRACKER_ID:
				$this->setTrackerId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setMyReportId($value);
				break;
  
			case 1:
				$this->setTrackerId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(MyReportTrackerPeer::DATABASE_NAME);

		try {
			$con->begin();
			MyReportTrackerPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(MyReportTrackerPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aTracker !== null) {
				if ($this->aTracker->isModified()) $this->aTracker->save($con);
				$this->setTracker($this->aTracker);
			}
 
			if ($this->aMyReport !== null) {
				if ($this->aMyReport->isModified()) $this->aMyReport->save($con);
				$this->setMyReport($this->aMyReport);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = MyReportTrackerPeer::doInsert($this, $con);
					$this->setNew(false);
				} else {
					MyReportTrackerPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return MyReportTrackerPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aTracker !== null) {
				if (($retval = $this->aTracker->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aMyReport !== null) {
				if (($retval = $this->aMyReport->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = MyReportTrackerPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  


	private $pks = array();
	
	/**
	 * Set the PrimaryKey.
	 *
	 * @param array $keys The elements of the composite key (order must match the order in XML file).
	 * @return void
	 * @throws PropelException
	 */
	public function setPrimaryKey($keys)
	{						

		$this->setMyReportId($keys[0]);

		$this->setTrackerId($keys[1]);

	}


	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return array 
	 */
	public function getPrimaryKey()
	{
		$this->pks[0] = $this->getMyReportId();
		$this->pks[1] = $this->getTrackerId();
		return $this->pks;

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return MyReportTracker Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new MyReportTracker();
		
		$copyObj->setNew(true);
		
		$copyObj->setMyReportId(NULL); // this is a pkey column, so set to default value
		$copyObj->setTrackerId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return MyReportTrackerPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new MyReportTrackerPeer();
		}
		return self::$peer;
	}

}
