<?php
require_once 'propel/util/BasePeer.php';

// The object class -- needed for instanceof checks in this class.
// actual class may be a subclass -- as returned by ProjectPeer::getOMClass()
include_once 'core/Project.php';

/**
 * Base static class for performing query and update operations on the 'project' table.
 *
 *  
 *
 * @package core 
 */
abstract class BaseProjectPeer
{

	/** the default database name for this class */
	const DATABASE_NAME = "gf5";

	/** the table name for this class */
	const TABLE_NAME = "project";

 
	/** the column name for the PROJECT_ID field */
	const PROJECT_ID = "project.PROJECT_ID";
 
	/** the column name for the PROJECT_NAME field */
	const PROJECT_NAME = "project.PROJECT_NAME";
 
	/** the column name for the UNIX_NAME field */
	const UNIX_NAME = "project.UNIX_NAME";
 
	/** the column name for the HOMEPAGE_URL field */
	const HOMEPAGE_URL = "project.HOMEPAGE_URL";
 
	/** the column name for the IS_PUBLIC field */
	const IS_PUBLIC = "project.IS_PUBLIC";
 
	/** the column name for the STATUS field */
	const STATUS = "project.STATUS";
 
	/** the column name for the DESCRIPTION field */
	const DESCRIPTION = "project.DESCRIPTION";
 
	/** the column name for the REGISTER_PURPOSE field */
	const REGISTER_PURPOSE = "project.REGISTER_PURPOSE";
 
	/** the column name for the REGISTER_LICENSE_OTHER field */
	const REGISTER_LICENSE_OTHER = "project.REGISTER_LICENSE_OTHER";
 
	/** the column name for the CREATE_DATE field */
	const CREATE_DATE = "project.CREATE_DATE";
 
	/** the column name for the TEMPLATE_PROJECT_ID field */
	const TEMPLATE_PROJECT_ID = "project.TEMPLATE_PROJECT_ID";
 
	/** the column name for the IS_TEMPLATE field */
	const IS_TEMPLATE = "project.IS_TEMPLATE";
 
	/** the column name for the PARENT_PROJECT_ID field */
	const PARENT_PROJECT_ID = "project.PARENT_PROJECT_ID";
 
	/** the column name for the ROOT_PARENT_PROJECT_ID field */
	const ROOT_PARENT_PROJECT_ID = "project.ROOT_PARENT_PROJECT_ID";
 
	/** the column name for the ROOT_PATH field */
	const ROOT_PATH = "project.ROOT_PATH";
 
	/** the column name for the PROJECT_TEXT1 field */
	const PROJECT_TEXT1 = "project.PROJECT_TEXT1";
 
	/** the column name for the PROJECT_TEXT2 field */
	const PROJECT_TEXT2 = "project.PROJECT_TEXT2";
 
	/** the column name for the PROJECT_TEXT3 field */
	const PROJECT_TEXT3 = "project.PROJECT_TEXT3";
 
	/** the column name for the PROJECT_TEXT4 field */
	const PROJECT_TEXT4 = "project.PROJECT_TEXT4";
 
	/** the column name for the PROJECT_TEXT5 field */
	const PROJECT_TEXT5 = "project.PROJECT_TEXT5";
 
	/** the column name for the PROJECT_TEXT6 field */
	const PROJECT_TEXT6 = "project.PROJECT_TEXT6";
 
	/** the column name for the IS_LISTED field */
	const IS_LISTED = "project.IS_LISTED";

	

	/** number of columns for this peer */
	public static $numColumns = 22;
	
	/** number of lazy load columns for this peer */
	public static $numLazyLoadColumns = 0;
	
	/** A class that can be returned by this peer. */
	const CLASS_DEFAULT = "core.Project";

	/** The PHP to DB Name Mapping */
	private static $phpNameMap = null;

	/**
	 * @return MapBuilder the map builder for this peer
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function getMapBuilder()		
	{
		include_once 'core/map/ProjectMapBuilder.php';
		return BasePeer::getMapBuilder(ProjectMapBuilder::CLASS_NAME);
	}

	/**
	 * Gets a map (hash) of PHP names to DB column names.
	 *
	 * @return array The PHP to DB name map for this peer
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 * @todo Consider having template build the array rather than doing it at runtime.
	 */
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = ProjectPeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	
	/**
	 * Convenience method which changes table.column to alias.column.
	 *
	 * Using this method you can maintain SQL abstraction while using column aliases.
	 * <code>
	 *		$c->addAlias("alias1", TablePeer::TABLE_NAME);
	 *		$c->addJoin(TablePeer::alias("alias1", TablePeer::PRIMARY_KEY_COLUMN), TablePeer::PRIMARY_KEY_COLUMN);
	 * </code>
	 * @param string $alias The alias for the current table.
	 * @param string $column The column name for current table. (i.e. ProjectPeer::COLUMN_NAME).
	 * @return string
	 */
	public static function alias($alias, $column)
	{
		return $alias . substr($column, strlen(self::TABLE_NAME));
	}
	
	/**
	 * Add all the columns needed to create a new object.
	 * 
	 * Note: any columns that were marked with lazyLoad="true" in the
	 * XML schema will not be added to the select list and only loaded
	 * on demand.
	 *
	 * @param criteria object containing the columns to add.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function addSelectColumns(Criteria $criteria)
	{
		$criteria->addSelectColumn(self::PROJECT_ID);
		$criteria->addSelectColumn(self::PROJECT_NAME);
		$criteria->addSelectColumn(self::UNIX_NAME);
		$criteria->addSelectColumn(self::HOMEPAGE_URL);
		$criteria->addSelectColumn(self::IS_PUBLIC);
		$criteria->addSelectColumn(self::STATUS);
		$criteria->addSelectColumn(self::DESCRIPTION);
		$criteria->addSelectColumn(self::REGISTER_PURPOSE);
		$criteria->addSelectColumn(self::REGISTER_LICENSE_OTHER);
		$criteria->addSelectColumn(self::CREATE_DATE);
		$criteria->addSelectColumn(self::TEMPLATE_PROJECT_ID);
		$criteria->addSelectColumn(self::IS_TEMPLATE);
		$criteria->addSelectColumn(self::PARENT_PROJECT_ID);
		$criteria->addSelectColumn(self::ROOT_PARENT_PROJECT_ID);
		$criteria->addSelectColumn(self::ROOT_PATH);
		$criteria->addSelectColumn(self::PROJECT_TEXT1);
		$criteria->addSelectColumn(self::PROJECT_TEXT2);
		$criteria->addSelectColumn(self::PROJECT_TEXT3);
		$criteria->addSelectColumn(self::PROJECT_TEXT4);
		$criteria->addSelectColumn(self::PROJECT_TEXT5);
		$criteria->addSelectColumn(self::PROJECT_TEXT6);
		$criteria->addSelectColumn(self::IS_LISTED);
	}
	
	const COUNT = "COUNT(project.PROJECT_ID)";
	const COUNT_DISTINCT = "COUNT(DISTINCT project.PROJECT_ID)";
  
	/**
	 * Returns the number of rows matching criteria.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct Whether to select only distinct columns.
	 * @param Connection $con
	 * @return int Number of matching rows.
	 */
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{   
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;
		
		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(ProjectPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(ProjectPeer::COUNT);	
		}
		
		$rs = ProjectPeer::doSelectRS($criteria, $con);		
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}
  
	/**
	 * Method to select one object from the DB.
	 *
	 * @param Criteria $criteria object used to create the SELECT statement.
	 * @param Connection $con
	 * @return Project	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = ProjectPeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}

	/**
	 * Method to do selects.
	 *
	 * @param Criteria $criteria The Criteria object used to build the SELECT statement.
	 * @param Connection $con
	 * @return array Array of selected Objects
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return ProjectPeer::populateObjects(ProjectPeer::doSelectRS($criteria, $con));
	}
	
	/**
	 * Prepares the Criteria object and uses the parent doSelect()
	 * method to get a ResultSet.
	 * 
	 * Use this method directly if you want to just get the resultset
	 * (instead of an array of objects).
	 *
	 * @param Criteria $criteria The Criteria object used to build the SELECT statement.
	 * @param Connection $con the connection to use
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 * @return ResultSet The resultset object with numerically-indexed fields.
	 * @see BasePeer::doSelect()
	 */
	public static function doSelectRS(Criteria $criteria, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}				

		if (!$criteria->getSelectColumns()) {
			ProjectPeer::addSelectColumns($criteria);
		}
	
		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);
		
		// BasePeer returns a Creole ResultSet, set to return
		// rows indexed numerically.		   
		return BasePeer::doSelect($criteria, $con);
	}

	/**
	 * The returned array will contain objects of the default type or
	 * objects that inherit from the default.
	 *
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
		
		// set the class once to avoid overhead in the loop
		$cls = ProjectPeer::getOMClass();
		$cls = Propel::import($cls);

		// populate the object(s)
		while($rs->next()) {
			
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
		}
		return $results;
	}



	/**
	 * The class that the Peer will make instances of.
	 * If the BO is abstract then you must implement this method
	 * in the BO.
	 *
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function getOMClass()
	{ 
		return self::CLASS_DEFAULT;
		 
	}
 

	/**
	 * Method perform an INSERT on the database, given a Project or Criteria object.
	 *
	 * @param mixed $values Criteria or Project object containing data that is used to create the INSERT statement.
	 * @param Connection $con the connection to use
	 * @return mixed The new primary key.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doInsert($values, $con = null)
	{		
		if ($con === null)
			$con = Propel::getConnection(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = $values;
		} else {
			$criteria = $values->buildCriteria();
		}
		
		
		$criteria->remove(self::PROJECT_ID); // remove pkey col since this table uses auto-increment
		 
		
		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);
		
		try {
			// use transaction because $criteria could contain info
			// for more than one table (I guess, conceivably)
			$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}
		
		return $pk;		
	}

	/**
	 * Method perform an UPDATE on the database, given a Project or Criteria object.
	 *
	 * @param mixed $values Criteria or Project object containing data that is used to create the UPDATE statement.
	 * @param Connection $con The connection to use (specify Connection object to exert more control over transactions).
	 * @return int The number of affected rows (if supported by underlying database driver).
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doUpdate($values, $con = null)
	{			
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		
		$selectCriteria = new Criteria(self::DATABASE_NAME);
				
		if ($values instanceof Criteria) {
			$criteria = $values;
			$selectCriteria->put(self::PROJECT_ID, $criteria->remove(self::PROJECT_ID));
 
		} else { // $values is Project object
			$criteria = $values->buildCriteria(); // gets full criteria
			$selectCriteria = $values->buildPkeyCriteria(); // gets criteria w/ primary key(s)			
		}	
		
		// set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);
		
		return BasePeer::doUpdate($selectCriteria, $criteria, $con);		
	}   
	
	/**
	 * Method to DELETE all rows from the project table.
	 *
	 * @return int The number of affected rows (if supported by underlying database driver).
	 */
	public static function doDeleteAll($con = null) 
	{
		if ($con === null) $con = Propel::getConnection(self::DATABASE_NAME);
		$affectedRows = 0; // initialize var to track total num of affected rows		
		try {
			// use transaction because $criteria could contain info
			// for more than one table or we could emulating ON DELETE CASCADE, etc.
			$con->begin();
			 
			$affectedRows += BasePeer::doDeleteAll(self::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	
	/**
	 * Method perform a DELETE on the database, given a Project or Criteria object OR a primary key value.
	 *
	 * @param mixed $values Criteria or Project object or primary key which is used to create the DELETE statement 
	 * @param Connection $con the connection to use
	 * @return int 	The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
	 *				if supported by native driver or if emulated using Propel.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	 public static function doDelete($values, $con = null)
	 {		
		if ($con === null)
			$con = Propel::getConnection(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = $values;
		} elseif ($values instanceof Project) {
			$criteria = $values->buildPkeyCriteria();
		} else {
			// it must be the primary key
			$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(self::PROJECT_ID, $values);
		}
			 
		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);
		
		$affectedRows = 0; // initialize var to track total num of affected rows		
		
		try {
			// use transaction because $criteria could contain info
			// for more than one table or we could emulating ON DELETE CASCADE, etc.
			$con->begin();
			 
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}		
	}	

	
	/**
	 * Validates all modified columns of given Project object.
	 * If parameter $columns is either a single column name or an array of column names
	 * than only those columns are validated.
	 *
	 * NOTICE: This does not apply to primary or foreign keys for now.
	 *
	 * @param Project $obj The object to validate.
	 * @param mixed $cols Column name or array of column names.
	 *
	 * @return mixed TRUE if all columns are valid or the error message of the first invalid column.
	 */
	public static function doValidate(Project $obj, $cols = null)
	{
		$columns = array();

		if ($cols)
		{
		  $dbMap = Propel::getDatabaseMap(self::DATABASE_NAME);
		  $tableMap = $dbMap->getTable(self::TABLE_NAME);

		  if (! is_array($cols)) {
			$cols = array($cols);
		  }

		  foreach($cols as $colName)
		  {
			if ($tableMap->containsColumn($colName))
			{
			  $get = 'get' . $tableMap->getColumn($colName)->getPhpName();
			  $columns[$colName] = $obj->$get();
			}
		  }
		}
		else
		{
		}

		return BasePeer::doValidate(self::DATABASE_NAME, self::TABLE_NAME, $columns);
	}
	  


	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 *
	 * @param mixed $pk the primary key.
	 * @param Connection $con the connection to use
         * @return Project
	 */
	public static function retrieveByPK($pk, $con = null)
	{		
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		
		$criteria = new Criteria(self::DATABASE_NAME);
		$criteria->add(self::PROJECT_ID, $pk);
						
		$v = ProjectPeer::doSelect($criteria, $con);
        return count($v) > 0 ? $v[0] : null;
	}

	/**
	 * Retrieve multiple objects by pkey.
	 *
	 * @param array $pks List of primary keys
	 * @param Connection $con the connection to use
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		
		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(self::PROJECT_ID, $pks, Criteria::IN);
  
			$objs = ProjectPeer::doSelect($criteria, $con);
		}
		return $objs;
	}

 

	/**
	 * Returns the TableMap related to this peer.  This method is not
	 * needed for general use but a specific application could have a need.
	 * @return TableMap
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	protected static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}
	
}

// static code to register the map builder for this Peer with the main Propel class
if (Propel::isInit()) {
	// the MapBuilder classes register themselves with Propel during initialization
	// so we need to load them here.
	try {		
		BaseProjectPeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log("Could not initialize Peer: " . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
	// even if Propel is not yet initialized, the map builder class can be registered
	// now and then it will be loaded when Propel initializes.
	require_once 'core/map/ProjectMapBuilder.php';
	Propel::registerMapBuilder(ProjectMapBuilder::CLASS_NAME);
}
