<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');

class ProjectTemplate extends SiteTemplate {

	function header($params) {
		$params['selectedtoptab']='project';
		$Lang = Session::getSession()->getLanguage();
		if (isset($params['project']) || is_object($params['project'])) {
			//don't let regular users access non-active projects & protect access to private projects
			if ((!$params['project']->isActive())	|| !$params['project']->userCanRead()) {
				require_once('exceptions/PermissionDeniedException.php');
				throw new PermissionDeniedException();
			}

			if (!isset($params['title'])) {
				Throw new exception('Missing title in project template');
			}
			$params['title']=$Lang->getText('Tabs.Projects').' > '.$params['project']->getProjectName().' > '.$params['title'];
		} else {
			Throw new exception('Missing project object in project template');
		}

		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project']).'">'.$params['project']->getProjectName().'</a>');
		$this->addBreadCrumb('<a href="/gf/project/">'.$Lang->getText('Tabs.Projects').'</a>');
		return parent::header($params);

	}
	/**
	 *	secondTabs() - Prints out the project tabs, contained here in case
	 *		we want to allow it to be overriden
	 *
	 *	@param	array	project, selected tab
	 * /
	function secondTabs($params) {

//		echo $this->renderTabs($TABS_DIRS,$TABS_TITLES,true,$selected,'white','100%');

		if (array_key_exists('selectedbottomtab', $params)) {
			$selectedTab = $params['selectedbottomtab'];
		} else {
			$selectedTab = false;
		}
		
		$project = GFUrl::getUrl()->getProject();
		
		$tabs = array();
		// "Summary" tab
		$tabs[] = array(
				'text'	=>	Language::getSessText('Tabs.Summary'),
				'id'	=>	'summary',
				'action'	=> 	GFUrl::getUrl()->projectURL($project)
			);
		// "Admin" tab
		if ($project->userIsAdmin()) {
			$tabs[] = array(
					'text'	=>	Language::getSessText('Tabs.ProjectAdmin'),
					'id'	=>	'project_admin',
					'action'	=> 	GFUrl::getUrl()->projectURL($project, '', 'admin')
				);
		}
		// "Reporting" tab
		$tabs[] = array(
				'text'	=>	Language::getSessText('Tabs.ProjectReporting'),
				'id'	=>	'reporting',
				'action'	=> 	GFUrl::getUrl()->projectURL($project, '', 'reporting')
			);
		// "Search" tab
		$tabs[] = array(
				'text'	=>	Language::getSessText('Tabs.Search'),
				'id'	=>	'search',
				'action'	=> 	GFUrl::getUrl()->projectURL($project, 'index.php', '','search',array('project_id'=>$project->getProjectId()))
			);			
		
		$prs = ActionManager::notify("BUILD_PROJECT_TABS",$params);
		foreach ($prs as $result) {
			$val = $result->getResult();
			if (array_key_exists(0, $val)) {
				// Plugin returned several tabs
				foreach ($val as $tab) {
					$tabs[] = $tab;
				}
			} else {
				// Plugin returned a single tab
				$tabs[] = $result->getResult();
			}
		}
		
		echo $this->renderTabs($tabs, $selectedTab, true, $params);
	}
*/
	function generateRSSLinks() {
		$out = array();
                $url = GFUrl::getUrl();
                $project = $url->getProject();
                $project_id = $project->getProjectId();
	
//		if (is_object($project) && $project->isPublic()) {
			$out['activity']['title'] = GFConf::get('system.name').' - '.$project->getName().' - Activity';
			$out['activity']['url'] = $url->getFullURL($url->baseURL('Rss', '', '', array('section' => 'activity', 'project_id' => $project_id)));
//		}

		return $out;
	}

}

?>
