<?php

/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/Filesystem.php');
require_once('lib/core/FilesystemPeer.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('plugins/docman/lib/DocmanFileVersion.php');
require_once('plugins/docman/lib/DocmanFileVersionPeer.php');
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('lib/exceptions/PermissionDeniedException.php');
require_once('Validator.php');

$project = GFUrl::getUrl()->getProject();

if (!Session::getSession()->isLoggedIn()) {
	throw new PermissionDeniedException();
}

$dfv = DocmanFileVersionPeer::retrieveByPK($_REQUEST['docman_file_version_id']);
if (!is_object($dfv) 
	|| $dfv->getDocmanFile()->getDocmanFolder()->getProjectId()!=$project->getProjectId()
	|| !$dfv->userCanUpdate()) {
	throw new PermissionDeniedException();
}

$fileid=$dfv->getDocmanFile()->getDocmanFileId();
//delete just this version
$dfv->setIsApproved(true);
$dfv->save();
GFUrl::redirect(GFUrl::getUrl()->projectURL($project,'DocmanFileEdit','docman','admin',array('id'=>$fileid,'feedback'=>'Successfully Approved')));

?>
