<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/docman/lib/html/DocmanAdminTemplate.php');
require_once('plugins/docman/lib/InfoParser.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');

$theme = new DocmanAdminTemplate();

$folder_order = $_POST['folder_order'];
$subdir = Validator::sanitizeInt($_POST['subdir']);

if(isset($_POST['newParent'])) {
	foreach ($_POST['newParent'] as $folder_id => $new_parent_id) {
		$folder_id = Validator::sanitizeInt($folder_id);
		$new_parent_id = Validator::sanitizeInt($new_parent_id);
		$DocmanFolder = DocmanFolderPeer::retrieveByPk($folder_id);
		$parentFolder = DocmanFolderPeer::retrieveByPk($new_parent_id);
		$project = GFUrl::getUrl()->getProject();
		if (($new_parent_id==0 || $parentFolder->getProjectId() == $project->getProjectId()) && $DocmanFolder->getProjectId() == $project->getProjectId()) {
			$DocmanFolder->setParentFolderId($new_parent_id);
			$DocmanFolder->save();
		}
	}
}

foreach ($folder_order as $folder_id => $order) {
	$DocmanFolder = DocmanFolderPeer::retrieveByPk(Validator::sanitizeInt($folder_id));
	$DocmanFolder->setSortOrder(Validator::sanitizeInt($order));
	try {
		$DocmanFolder->save();
	} catch (InvalidDataException $ex) {
		$feedback = implode('<br />', $ex->getErrors());
		GFUrl::redirect($url->currentBaseURL('', array('subdir'=>$subdir)), array('feedback' => $feedback));
		exit();
	}
}
$feedback = $Lang->getText('Docman.FoldersUpdated');
GFUrl::redirect($url->currentBaseURL('',array('subdir'=>$subdir)), array('feedback' => $feedback));
?>
