<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';

include_once 'plugins/forum/lib/ForumPeer.php';

/**
 * Base class that represents a row from the 'forum' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Forum class. 
 * 
 * @package plugins.forum.lib 
 */
abstract class BaseForum extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var ForumPeer
	 */
	protected static $peer;

	/**
	 * The value for the forum_id field.
	 * @var int	  
	 */
	protected $forum_id;	

	/**
	 * The value for the section field.
	 * @var string	  
	 */
	protected $section;	

	/**
	 * The value for the ref_id field.
	 * @var int	  
	 */
	protected $ref_id;	

	/**
	 * The value for the forum_name field.
	 * @var string	  
	 */
	protected $forum_name;	

	/**
	 * The value for the is_public field.
	 * @var boolean	  
	 */
	protected $is_public = true;	

	/**
	 * The value for the description field.
	 * @var string	  
	 */
	protected $description;	

	/**
	 * The value for the send_all_posts_to field.
	 * @var string	  
	 */
	protected $send_all_posts_to;	

	/**
	 * The value for the thread_count field.
	 * @var int	  
	 */
	protected $thread_count = 0;	

	/**
	 * The value for the message_count field.
	 * @var int	  
	 */
	protected $message_count = 0;	

	/**
	 * The value for the most_recent_date field.
	 * @var int	  
	 */
	protected $most_recent_date = -1;	

	/**
	 * The value for the moderation_level field.
	 * @var int	  
	 */
	protected $moderation_level = 0;	

	/**
	 * The value for the show_associations_tab field.
	 * @var boolean	  
	 */
	protected $show_associations_tab = true;	

	/**
	 * The value for the show_tags_tab field.
	 * @var boolean	  
	 */
	protected $show_tags_tab = true;	
  
	/**
	 * Get the ForumId column value.
	 *  
	 * @return int	  
	 */
	public function getForumId()
	{
		return $this->forum_id;
	}


	/**
	 * Set the value of `forum_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setForumId($v)
	{
		if ($this->forum_id !== $v) {
			$this->forum_id = $v;
			$this->modifiedColumns[] = ForumPeer::FORUM_ID;
		}
			
		  // update associated ForumThread		  
		  if ($this->collForumThreads !== null) {
			  for ($i=0,$size=count($this->collForumThreads); $i < $size; $i++) {
				  $this->collForumThreads[$i]->setForumId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the Section column value.
	 *  
	 * @return string	  
	 */
	public function getSection()
	{
		return $this->section;
	}


	/**
	 * Set the value of `section` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSection($v)
	{
		if ($this->section !== $v) {
			$this->section = $v;
			$this->modifiedColumns[] = ForumPeer::SECTION;
		}
				
	}

  
	/**
	 * Get the RefId column value.
	 *  
	 * @return int	  
	 */
	public function getRefId()
	{
		return $this->ref_id;
	}


	/**
	 * Set the value of `ref_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setRefId($v)
	{
		if ($this->ref_id !== $v) {
			$this->ref_id = $v;
			$this->modifiedColumns[] = ForumPeer::REF_ID;
		}
				
	}

  
	/**
	 * Get the ForumName column value.
	 *  
	 * @return string	  
	 */
	public function getForumName()
	{
		return $this->forum_name;
	}


	/**
	 * Set the value of `forum_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setForumName($v)
	{
		if ($this->forum_name !== $v) {
			$this->forum_name = $v;
			$this->modifiedColumns[] = ForumPeer::FORUM_NAME;
		}
				
	}

  
	/**
	 * Get the IsPublic column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsPublic()
	{
		return $this->is_public;
	}


	/**
	 * Set the value of `is_public` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsPublic($v)
	{
		if ($this->is_public !== $v || $v === true) {
			$this->is_public = $v;
			$this->modifiedColumns[] = ForumPeer::IS_PUBLIC;
		}
				
	}

  
	/**
	 * Get the Description column value.
	 *  
	 * @return string	  
	 */
	public function getDescription()
	{
		return $this->description;
	}


	/**
	 * Set the value of `description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDescription($v)
	{
		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = ForumPeer::DESCRIPTION;
		}
				
	}

  
	/**
	 * Get the SendAllPostsTo column value.
	 *  
	 * @return string	  
	 */
	public function getSendAllPostsTo()
	{
		return $this->send_all_posts_to;
	}


	/**
	 * Set the value of `send_all_posts_to` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSendAllPostsTo($v)
	{
		if ($this->send_all_posts_to !== $v) {
			$this->send_all_posts_to = $v;
			$this->modifiedColumns[] = ForumPeer::SEND_ALL_POSTS_TO;
		}
				
	}

  
	/**
	 * Get the ThreadCount column value.
	 *  
	 * @return int	  
	 */
	public function getThreadCount()
	{
		return $this->thread_count;
	}


	/**
	 * Set the value of `thread_count` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setThreadCount($v)
	{
		if ($this->thread_count !== $v || $v === 0) {
			$this->thread_count = $v;
			$this->modifiedColumns[] = ForumPeer::THREAD_COUNT;
		}
				
	}

  
	/**
	 * Get the MessageCount column value.
	 *  
	 * @return int	  
	 */
	public function getMessageCount()
	{
		return $this->message_count;
	}


	/**
	 * Set the value of `message_count` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setMessageCount($v)
	{
		if ($this->message_count !== $v || $v === 0) {
			$this->message_count = $v;
			$this->modifiedColumns[] = ForumPeer::MESSAGE_COUNT;
		}
				
	}


	/**
	 * Get the [optionally formatted] `most_recent_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getMostRecentDate($format = 'Y-m-d H:i:s')
	{
		if ($this->most_recent_date === null || $this->most_recent_date === '') {
			return null;
		} elseif (!is_int($this->most_recent_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->most_recent_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of most_recent_date as date/time value: " . var_export($this->most_recent_date, true));
			}
		} else {
			$ts = $this->most_recent_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `most_recent_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setMostRecentDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for most_recent_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->most_recent_date !== $ts || $ts === -1) {
			$this->most_recent_date = $ts;
			$this->modifiedColumns[] = ForumPeer::MOST_RECENT_DATE;
		}
		
	}

  
	/**
	 * Get the ModerationLevel column value.
	 *  
	 * @return int	  
	 */
	public function getModerationLevel()
	{
		return $this->moderation_level;
	}


	/**
	 * Set the value of `moderation_level` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setModerationLevel($v)
	{
		if ($this->moderation_level !== $v || $v === 0) {
			$this->moderation_level = $v;
			$this->modifiedColumns[] = ForumPeer::MODERATION_LEVEL;
		}
				
	}

  
	/**
	 * Get the ShowAssociationsTab column value.
	 *  
	 * @return boolean	  
	 */
	public function getShowAssociationsTab()
	{
		return $this->show_associations_tab;
	}


	/**
	 * Set the value of `show_associations_tab` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setShowAssociationsTab($v)
	{
		if ($this->show_associations_tab !== $v || $v === true) {
			$this->show_associations_tab = $v;
			$this->modifiedColumns[] = ForumPeer::SHOW_ASSOCIATIONS_TAB;
		}
				
	}

  
	/**
	 * Get the ShowTagsTab column value.
	 *  
	 * @return boolean	  
	 */
	public function getShowTagsTab()
	{
		return $this->show_tags_tab;
	}


	/**
	 * Set the value of `show_tags_tab` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setShowTagsTab($v)
	{
		if ($this->show_tags_tab !== $v || $v === true) {
			$this->show_tags_tab = $v;
			$this->modifiedColumns[] = ForumPeer::SHOW_TAGS_TAB;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->forum_id = $rs->getInt($startcol + 0);					
			$this->section = $rs->getString($startcol + 1);					
			$this->ref_id = $rs->getInt($startcol + 2);					
			$this->forum_name = $rs->getString($startcol + 3);					
			$this->is_public = $rs->getBoolean($startcol + 4);					
			$this->description = $rs->getString($startcol + 5);					
			$this->send_all_posts_to = $rs->getString($startcol + 6);					
			$this->thread_count = $rs->getInt($startcol + 7);					
			$this->message_count = $rs->getInt($startcol + 8);					
			$this->most_recent_date = $rs->getTimestamp($startcol + 9, null);
			$this->moderation_level = $rs->getInt($startcol + 10);					
			$this->show_associations_tab = $rs->getBoolean($startcol + 11);					
			$this->show_tags_tab = $rs->getBoolean($startcol + 12);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Forum object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(ForumPeer::DATABASE_NAME);
		$criteria->add(ForumPeer::FORUM_ID, $this->forum_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(ForumPeer::DATABASE_NAME);
		if ($this->isColumnModified(ForumPeer::FORUM_ID)) $criteria->add(ForumPeer::FORUM_ID, $this->forum_id);
		if ($this->isColumnModified(ForumPeer::SECTION)) $criteria->add(ForumPeer::SECTION, $this->section);
		if ($this->isColumnModified(ForumPeer::REF_ID)) $criteria->add(ForumPeer::REF_ID, $this->ref_id);
		if ($this->isColumnModified(ForumPeer::FORUM_NAME)) $criteria->add(ForumPeer::FORUM_NAME, $this->forum_name);
		if ($this->isColumnModified(ForumPeer::IS_PUBLIC)) $criteria->add(ForumPeer::IS_PUBLIC, $this->is_public);
		if ($this->isColumnModified(ForumPeer::DESCRIPTION)) $criteria->add(ForumPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(ForumPeer::SEND_ALL_POSTS_TO)) $criteria->add(ForumPeer::SEND_ALL_POSTS_TO, $this->send_all_posts_to);
		if ($this->isColumnModified(ForumPeer::THREAD_COUNT)) $criteria->add(ForumPeer::THREAD_COUNT, $this->thread_count);
		if ($this->isColumnModified(ForumPeer::MESSAGE_COUNT)) $criteria->add(ForumPeer::MESSAGE_COUNT, $this->message_count);
		if ($this->isColumnModified(ForumPeer::MOST_RECENT_DATE)) $criteria->add(ForumPeer::MOST_RECENT_DATE, $this->most_recent_date);
		if ($this->isColumnModified(ForumPeer::MODERATION_LEVEL)) $criteria->add(ForumPeer::MODERATION_LEVEL, $this->moderation_level);
		if ($this->isColumnModified(ForumPeer::SHOW_ASSOCIATIONS_TAB)) $criteria->add(ForumPeer::SHOW_ASSOCIATIONS_TAB, $this->show_associations_tab);
		if ($this->isColumnModified(ForumPeer::SHOW_TAGS_TAB)) $criteria->add(ForumPeer::SHOW_TAGS_TAB, $this->show_tags_tab);
		return $criteria;			
	}
	
	

	/**
	 * Collection to store aggregation of collForumThreads	  
	 * @var array
	 */
	protected $collForumThreads; 

	/**
	 * Temporary storage of collForumThreads to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initForumThreads()
	{
		if ($this->collForumThreads === null) {
			$this->collForumThreads = array();
		}
	}

	/**
	 * Method called to associate a ForumThread object to this object
	 * through the ForumThread foreign key attribute
	 *
	 * @param ForumThread $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addForumThread(ForumThread $l)
	{
		$this->collForumThreads[] = $l;
		$l->setForum($this);
	}

	/**
	 * The criteria used to select the current contents of collForumThreads.
	 * @var Criteria
	 */
	private $lastForumThreadsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Forum has previously
	 * been saved, it will retrieve related ForumThreads from storage.
	 * If this Forum is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getForumThreads($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumThreadPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collForumThreads === null) {
			if ($this->isNew()) {
			   $this->collForumThreads = array();
			} else {
	
				$criteria->add(ForumThreadPeer::FORUM_ID, $this->getForumId() );

				$this->collForumThreads = ForumThreadPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ForumThreadPeer::FORUM_ID, $this->getForumId());

				if (!isset($this->lastForumThreadsCriteria) || !$this->lastForumThreadsCriteria->equals($criteria)) {
					$this->collForumThreads = ForumThreadPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastForumThreadsCriteria = $criteria;

		return $this->collForumThreads;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Forum is new, it will return
	 * an empty collection; or if this Forum has previously
	 * been saved, it will retrieve related ForumThreads from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Forum.
	 */
	public function getForumThreadsJoinForum($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumThreadPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collForumThreads === null) {
			if ($this->isNew()) {
			   $this->collForumThreads = array();
			} else {
	   
				$criteria->add(ForumThreadPeer::FORUM_ID, $this->getForumId());
				$this->collForumThreads = ForumThreadPeer::doSelectJoinForum($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ForumThreadPeer::FORUM_ID, $this->getForumId());
			if (!isset($this->lastForumThreadsCriteria) || !$this->lastForumThreadsCriteria->equals($criteria)) {
				$this->collForumThreads = ForumThreadPeer::doSelectJoinForum($criteria, $con);
			}
		}
		$this->lastForumThreadsCriteria = $criteria;

		return $this->collForumThreads;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Forum is new, it will return
	 * an empty collection; or if this Forum has previously
	 * been saved, it will retrieve related ForumThreads from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Forum.
	 */
	public function getForumThreadsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumThreadPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collForumThreads === null) {
			if ($this->isNew()) {
			   $this->collForumThreads = array();
			} else {
	   
				$criteria->add(ForumThreadPeer::FORUM_ID, $this->getForumId());
				$this->collForumThreads = ForumThreadPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ForumThreadPeer::FORUM_ID, $this->getForumId());
			if (!isset($this->lastForumThreadsCriteria) || !$this->lastForumThreadsCriteria->equals($criteria)) {
				$this->collForumThreads = ForumThreadPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastForumThreadsCriteria = $criteria;

		return $this->collForumThreads;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("forum_id", "section", "ref_id", "forum_name", "is_public", "description", "send_all_posts_to", "thread_count", "message_count", "most_recent_date", "moderation_level", "show_associations_tab", "show_tags_tab", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case ForumPeer::FORUM_ID:
				return $this->getForumId();
				break;
		  
			case ForumPeer::SECTION:
				return $this->getSection();
				break;
		  
			case ForumPeer::REF_ID:
				return $this->getRefId();
				break;
		  
			case ForumPeer::FORUM_NAME:
				return $this->getForumName();
				break;
		  
			case ForumPeer::IS_PUBLIC:
				return $this->getIsPublic();
				break;
		  
			case ForumPeer::DESCRIPTION:
				return $this->getDescription();
				break;
		  
			case ForumPeer::SEND_ALL_POSTS_TO:
				return $this->getSendAllPostsTo();
				break;
		  
			case ForumPeer::THREAD_COUNT:
				return $this->getThreadCount();
				break;
		  
			case ForumPeer::MESSAGE_COUNT:
				return $this->getMessageCount();
				break;
		  
			case ForumPeer::MOST_RECENT_DATE:
				return $this->getMostRecentDate();
				break;
		  
			case ForumPeer::MODERATION_LEVEL:
				return $this->getModerationLevel();
				break;
		  
			case ForumPeer::SHOW_ASSOCIATIONS_TAB:
				return $this->getShowAssociationsTab();
				break;
		  
			case ForumPeer::SHOW_TAGS_TAB:
				return $this->getShowTagsTab();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getForumId();
				break;
  
			case 1:
				return $this->getSection();
				break;
  
			case 2:
				return $this->getRefId();
				break;
  
			case 3:
				return $this->getForumName();
				break;
  
			case 4:
				return $this->getIsPublic();
				break;
  
			case 5:
				return $this->getDescription();
				break;
  
			case 6:
				return $this->getSendAllPostsTo();
				break;
  
			case 7:
				return $this->getThreadCount();
				break;
  
			case 8:
				return $this->getMessageCount();
				break;
  
			case 9:
				return $this->getMostRecentDate();
				break;
  
			case 10:
				return $this->getModerationLevel();
				break;
  
			case 11:
				return $this->getShowAssociationsTab();
				break;
  
			case 12:
				return $this->getShowTagsTab();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(ForumPeer::FORUM_ID, $arr)) $this->setForumId($arr[ForumPeer::FORUM_ID]);
  
		if (array_key_exists(ForumPeer::SECTION, $arr)) $this->setSection($arr[ForumPeer::SECTION]);
  
		if (array_key_exists(ForumPeer::REF_ID, $arr)) $this->setRefId($arr[ForumPeer::REF_ID]);
  
		if (array_key_exists(ForumPeer::FORUM_NAME, $arr)) $this->setForumName($arr[ForumPeer::FORUM_NAME]);
  
		if (array_key_exists(ForumPeer::IS_PUBLIC, $arr)) $this->setIsPublic($arr[ForumPeer::IS_PUBLIC]);
  
		if (array_key_exists(ForumPeer::DESCRIPTION, $arr)) $this->setDescription($arr[ForumPeer::DESCRIPTION]);
  
		if (array_key_exists(ForumPeer::SEND_ALL_POSTS_TO, $arr)) $this->setSendAllPostsTo($arr[ForumPeer::SEND_ALL_POSTS_TO]);
  
		if (array_key_exists(ForumPeer::THREAD_COUNT, $arr)) $this->setThreadCount($arr[ForumPeer::THREAD_COUNT]);
  
		if (array_key_exists(ForumPeer::MESSAGE_COUNT, $arr)) $this->setMessageCount($arr[ForumPeer::MESSAGE_COUNT]);
  
		if (array_key_exists(ForumPeer::MOST_RECENT_DATE, $arr)) $this->setMostRecentDate($arr[ForumPeer::MOST_RECENT_DATE]);
  
		if (array_key_exists(ForumPeer::MODERATION_LEVEL, $arr)) $this->setModerationLevel($arr[ForumPeer::MODERATION_LEVEL]);
  
		if (array_key_exists(ForumPeer::SHOW_ASSOCIATIONS_TAB, $arr)) $this->setShowAssociationsTab($arr[ForumPeer::SHOW_ASSOCIATIONS_TAB]);
  
		if (array_key_exists(ForumPeer::SHOW_TAGS_TAB, $arr)) $this->setShowTagsTab($arr[ForumPeer::SHOW_TAGS_TAB]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case ForumPeer::FORUM_ID:
				$this->setForumId($value);
				break;
	  
			case ForumPeer::SECTION:
				$this->setSection($value);
				break;
	  
			case ForumPeer::REF_ID:
				$this->setRefId($value);
				break;
	  
			case ForumPeer::FORUM_NAME:
				$this->setForumName($value);
				break;
	  
			case ForumPeer::IS_PUBLIC:
				$this->setIsPublic($value);
				break;
	  
			case ForumPeer::DESCRIPTION:
				$this->setDescription($value);
				break;
	  
			case ForumPeer::SEND_ALL_POSTS_TO:
				$this->setSendAllPostsTo($value);
				break;
	  
			case ForumPeer::THREAD_COUNT:
				$this->setThreadCount($value);
				break;
	  
			case ForumPeer::MESSAGE_COUNT:
				$this->setMessageCount($value);
				break;
	  
			case ForumPeer::MOST_RECENT_DATE:
				$this->setMostRecentDate($value);
				break;
	  
			case ForumPeer::MODERATION_LEVEL:
				$this->setModerationLevel($value);
				break;
	  
			case ForumPeer::SHOW_ASSOCIATIONS_TAB:
				$this->setShowAssociationsTab($value);
				break;
	  
			case ForumPeer::SHOW_TAGS_TAB:
				$this->setShowTagsTab($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setForumId($value);
				break;
  
			case 1:
				$this->setSection($value);
				break;
  
			case 2:
				$this->setRefId($value);
				break;
  
			case 3:
				$this->setForumName($value);
				break;
  
			case 4:
				$this->setIsPublic($value);
				break;
  
			case 5:
				$this->setDescription($value);
				break;
  
			case 6:
				$this->setSendAllPostsTo($value);
				break;
  
			case 7:
				$this->setThreadCount($value);
				break;
  
			case 8:
				$this->setMessageCount($value);
				break;
  
			case 9:
				$this->setMostRecentDate($value);
				break;
  
			case 10:
				$this->setModerationLevel($value);
				break;
  
			case 11:
				$this->setShowAssociationsTab($value);
				break;
  
			case 12:
				$this->setShowTagsTab($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(ForumPeer::DATABASE_NAME);

		try {
			$con->begin();
			ForumPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(ForumPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ForumPeer::doInsert($this, $con);
					$this->setForumId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					ForumPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collForumThreads !== null) {
				for ($i=0,$size=count($this->collForumThreads); $i < $size; $i++) {
					$this->collForumThreads[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return ForumPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  

			if (($retval = ForumPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collForumThreads !== null) {
				for ($i=0,$size=count($this->collForumThreads); $i < $size; $i++) {
					if (($retval = $this->collForumThreads[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed forum_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setForumId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getForumId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Forum Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Forum();
		$copyObj->setSection($this->section);
		$copyObj->setRefId($this->ref_id);
		$copyObj->setForumName($this->forum_name);
		$copyObj->setIsPublic($this->is_public);
		$copyObj->setDescription($this->description);
		$copyObj->setSendAllPostsTo($this->send_all_posts_to);
		$copyObj->setThreadCount($this->thread_count);
		$copyObj->setMessageCount($this->message_count);
		$copyObj->setMostRecentDate($this->most_recent_date);
		$copyObj->setModerationLevel($this->moderation_level);
		$copyObj->setShowAssociationsTab($this->show_associations_tab);
		$copyObj->setShowTagsTab($this->show_tags_tab);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getForumThreads() as $relObj) {
				$copyObj->addForumThread($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setForumId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return ForumPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ForumPeer();
		}
		return self::$peer;
	}

}
