<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists FrsRelease
//
require_once('plugins/frs/lib/FrsReleasePeer.php');
require_once('plugins/frs/lib/FrsRelease.php');
require_once('lib/ExcelXML.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/frs/lib/html/FrsTemplate.php');
$theme = new FrsTemplate();

$Project = GFUrl::getUrl()->getProject();

$FrsRelease = FrsReleasePeer::retrieveByPk($_REQUEST['release_id']);
$type = (isset($_REQUEST['type'])) ? $_REQUEST['type'] : 'xls';
if (!$FrsRelease->userCanRead()) {
	throw new PermissionDeniedException();
}

$separator = ',';
$filename = 'FrsRelease_' . StringUtils::removeInvalidChars(str_replace(' ', '_', $FrsRelease->getReleaseName()));

// here we get all the related tracker items
$sql = "SELECT t.tracker_id, t.tracker_name, tef.field_name, ti.tracker_item_id, ti.summary, ti.open_date
FROM tracker t, tracker_item ti, tracker_extra_field tef
WHERE t.tracker_id = ti.tracker_id
AND tef.field_type=".TrackerExtraField::TYPE_RELEASE."
AND t.project_id=".$Project->getProjectId()."
AND tef.tracker_extra_field_id IN (
	SELECT tracker_extra_field_id
	FROM tracker_extra_field_data
	WHERE tracker_item_id = ti.tracker_item_id
	AND tracker_extra_field_id=tef.tracker_extra_field_id
	AND field_data <> 100 AND field_data = ".$FrsRelease->getPrimaryKey().")";

$theader = array($Lang->getText('Tracker.TrackerNameName'),
			$Lang->getText('TrackerExtraField.FieldNameName'),
			$Lang->getText('TrackerItemRelation.TrackerItemIdName'),
			$Lang->getText('TrackerItem.SummaryName'),
			$Lang->getText('TrackerItem.OpenDateName'));


if ($type == 'csv') {
	header("Content-Type: application/force-download\n");
	header("Expires: 0");
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("content-disposition: attachment;filename=$filename.csv");
	echo implode($separator, cleanForCSV($theader, $separator)) . "\r\n";
} else {
	header("Content-Type: application/vnd.ms-excel");
	header("Expires: 0");
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("content-disposition: attachment;filename=$filename.xls");
	$excel = new ExcelXML($filename);
	$excel->setHeader($theader);
}

$con = Propel::getConnection(TrackerPeer::DATABASE_NAME);
$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);


if (!function_exists('htmlspecialchars_decode')) {
	function htmlspecialchars_decode($text) {
		return strtr($text, array_flip(get_html_translation_table(HTML_SPECIALCHARS)));
	}
}

$data = array();
while($rs != null && $rs->getRecordCount() > 0 && $rs->next()) {
	$data[$rs->getInt('tracker_id')][] = array('tracker_id'=>$rs->getInt('tracker_id'),
										'tracker_name'=>$rs->getString('tracker_name'),
										'field_name'=>$rs->getString('field_name'),
										'tracker_item_id'=>$rs->getString('tracker_item_id'),
										'summary'=>htmlspecialchars_decode($rs->getString('summary')),
										'open_date'=>$rs->getString('open_date'));
}
$lastTracker = 0;
$itemscount = 0;
foreach ($data as $tracker) {
	$count = count($tracker);
	foreach ($tracker as $item) {
		$row = array();
		if ($lastTracker != $item['tracker_id']) {
			$row[] = $item['tracker_name'];
			$lastTracker=$item['tracker_id'];
		} else {
			if ($type == 'csv') {
				$row[] = $item['tracker_name'];
			} else {
				$row[] = '';
			}
		}
		$row[] = $item['field_name'];
		$row[] = '#'.$item['tracker_item_id'];
		$row[] = $item['summary'];
		$date = explode('.', $item['open_date']);
		$row[] = $date[0];
		$itemscount++;
		
		if ($type == 'csv') {
			echo implode($separator, cleanForCSV($row, $separator)) . "\r\n";
		} else {
			$excel->openRow();
			foreach ($row as $r) {
				$excel->setCellString($r);
			}
			$excel->closeRow();
		}
	}
}

if ($type != 'csv') {
	echo $excel->getXML();
}

function cleanForCSV($str, $separator) {
	$arrRemove = array("\r\n", "\n", "\r", $separator);
	return str_replace($arrRemove, ' ', $str);
}
?>
