<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing Mailman
//
require_once('plugins/mailman/lib/MailmanPeer.php');
require_once('plugins/mailman/lib/Mailman.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/mailman/lib/html/MailmanAdminTemplate.php');
$theme = new MailmanAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$Mailman = MailmanPeer::retrieveByPk($_GET['id']);
/*if (!is_object($Mailman) || !$Mailman->userCanUpdate()) {   missing userCanUpdate
	throw new PermissionDeniedException();
}*/
$obj = $Mailman;

$params = array(
		'project' => $Project,
		'mailman' => $Mailman,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('Mailman.EditPageTitle'),
		'list' => $Mailman
		);

$list_name = ( (isset($_POST) && isset($_POST['list_name'])) ? htmlspecialchars($_POST['list_name']) : $obj->getListName() );
$is_public = ( (isset($_POST) && isset($_POST['is_public'])) ? htmlspecialchars($_POST['is_public']) : $obj->getIsPublic() );
$description = ( (isset($_POST) && isset($_POST['description'])) ? htmlspecialchars($_POST['description']) : $obj->getListDescription() );

include ('forms/MailmanEdit-tpl.php');

?>
