<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/news/lib/html/NewsTemplate.php');
require_once('lib/plugin/PluginResult.php');

class NewsAdminTemplate extends NewsTemplate {

	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array array of parameters
	 */
	function header($params) {
		$params['selectedbottomtab']='news';
		$Lang = Session::getSession()->getLanguage();		

		if(!isset($params['project']) || !is_object($params['project'])) {
			Throw new exception('Missing project object in news template');
		} 
		if (!Session::getSession()->isLoggedIn()) {
			Throw new PermissionDeniedException();
		}
		if( (!$params['project']->getPermission()->isAdmin())) {
			Throw new PermissionDeniedException();
		}
		if (!isset($params['title'])) {
			Throw new exception('Missing title in news template');
		}
		$params['title']=$Lang->getText('Tabs.Admin').' > '.$params['title'];
		
		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','news','admin').'">'.$Lang->getText('Tabs.Admin').'</a>');		
		return parent::header($params);
	}

	/**
	 *	getPluginNavElements - this overrides parent class and adds its own 
	 *	plugin listener
	 *	@return	PluginResultSet
	 */
	function getPluginNavElements($params) {
		$prs = parent::getPluginNavElements($params);
	       	$tprs = ActionManager::Notify('GET_NEWS_NAV_ELEMENTS',$params);
		foreach ($tprs as $pr) {
			$prs->addResult($pr);
		}
		return $prs;
	}

	/**
	 * getTemplateNavElements - this function can be overridden
	 * by subclasses so you can add navigation entries
	 * @return array - complex array of data.
	 * /
	function getTemplateNavElements($params) {
		$pine = $this->getPluginNavElements($params);
		$ret = array();
		foreach ($pine as $result) {
			$ret[]=$result->getResult();
		}
		if (isset($params['news']) && is_object($params['news'])) {
			$news = $params['news'];
			if (!isset($params['project'])) {
echo 'missing project param';
			}
			$ret[] = array(
				'title'=>$news->getnewsName(). ' Admin',
				'elements'=> array(
				array('link'=>'/gf/project/'.$params['project']->getUnixName().'/news/admin/?news_id='.$news->getNewsId(),
					'description'=>'news')				
					)
				);
		}
		return $ret;
	}
	*/
}

?>
