<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Marcelo Mottalli	<marcelo@gforgegroup.com>
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('GFUrl.php');
require_once('plugins/scmperforce/lib/html/PerforceTemplate.php');
require_once('plugins/scmperforce/lib/PerforceRepository.php');


$project = GFUrl::getUrl()->getProject();
$perforceplugin = $project->getPluginByName('scmperforce');
if (is_null($perforceplugin)) {
	throw new InvalidPluginException('scmperforce');
}

$session = Session::getSession();
$lang = $session->getLanguage();

$template = new PerforceTemplate();

$params = array(
	'selectedbottomtab'	=> 'scmperforce',
	'project' => $project,
	'action' => isset($action) ? $action : '',
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'title' => $lang->getText('Perforce.AccessInfo')
	);

$template->header($params);

// See if SCM is configured for this project
$repos = new PerforceRepository($project);
if ($repos->isConfigured()) {
	$projectScm = $repos->getScmConfiguration();

	if (!$projectScm->getControlled()) {
		//@todo	This will be used when we add support for external SCM
		//die("UNSUPPORTED");
	}
	
	if (GFConf::get('system.splitScmServers')) {
		$hostname = $projectScm->getScmServer()->getHostname();
	} else {
		$hostname = GFConf::get('system.hostName');
	}

	$custom_access_text = $projectScm->getAccessText();
	if (!empty($custom_access_text)) {
?>
<p>
	<h3><?php echo $lang->getText('Perforce.AccessTextTitle') ?></h3>
</p>
<p>
	<?php echo $custom_access_text ?>
</p>
<?php
	}
	
	if ($projectScm->getControlled()) {		// Only display the access info if access is controlled
		if ($project->getIsPublic() && $projectScm->getEnableAnonread()) {
?>
<p>
	<h3><?php echo $lang->getText('Perforce.AnonymousAccess'); ?></h3>
</p>
<p>
	<?php echo $lang->getText('Perforce.AnonymousAccessDescription'); ?>
</p>

<?php } /*if ($projectScm->getEnableAnonread()) */ ?>
<p>
	<h3><?php echo $lang->getText('Perforce.DeveloperAccess'); ?></h3>
	<?php echo $lang->getText('Perforce.DeveloperAccessDescription'); ?>
</p>
<br /> <br />

<?php
	}	/* $projectScm->getControlled() */
} else {		// SCM is not configured for this project
?>
	<a href="<?php echo GFUrl::getUrl()->projectURL($project, '', 'scmperforce', 'admin'); ?>"><?php echo $lang->getText('Scm.Admin'); ?></a>
	
	<p><h3><?php echo $lang->getText('Scm.AdminTitle'); ?></h3></p>
	
	<p><?php echo $lang->getText('Scm.NotConfigured') ?></p>

<?php
}
$template->footer($params);
?>
