<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-07-20
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once 'plugins/tracker/lib/om/BaseTrackerExtraFieldElementTransition.php';
require_once("plugin/ActionManager.php");
require_once('lib/SystemUtils.php');

/** 
 * The skeleton for this class was autogenerated by Propel  * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package plugins.tracker.lib 
 */
class TrackerExtraFieldElementTransition extends BaseTrackerExtraFieldElementTransition {
	/**
	 * Removes this object from datastore and sets delete attribute. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see TrackerExtraFieldElementTransition::setDeleted()
	 * @see TrackerExtraFieldElementTransition::isDeleted()
	 */
	function delete($con = null) {
		if (!$this->getTrackerExtraFieldElementRelatedByElementId()->getTrackerExtraField()->getTracker()->userIsAdmin()) {
			throw new PermissionDeniedException();
		}
		ActionManager::notify("TRACKER_EXTRA_FIELD_ELEMENT_TRANSITION_DELETE", $this);
		parent::delete($con);		
	}

	/**
	 * Stores the object in the database using the Propel methods. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	function save($con = null) {
		if (!$this->getTrackerExtraFieldElementRelatedByElementId()->getTrackerExtraField()->getTracker()->userIsAdmin()) {
			throw new PermissionDeniedException();
		}
		parent::save($con);
		ActionManager::notify("TRACKER_EXTRA_FIELD_ELEMENT_TRANSITION_SAVE", $this);
	}


	function notify($TrackerItem) {
		// Get all the email addresses that need notification
		$sql = 'SELECT DISTINCT email FROM "user", user_project, user_project_role, tracker_extra_field_element_transition_notify 
				WHERE user_project_role.user_project_id=user_project.user_project_id 
					AND user_project_role.role_id=tracker_extra_field_element_transition_notify.role_id 
					AND "user".user_id=user_project.user_id 
					AND tracker_extra_field_element_transition_notify.tracker_extra_field_element_transition_id='.$this->getTrackerExtraFieldElementTransitionId();
		$rs=Propel::getConnection()->createStatement()->executeQuery($sql);
		$emails=array();
		while ($rs->next()) {
			$emails[]=$rs->getString('email');
		}
		
		if (count($emails) == 0 || strlen($this->getNotificationMessage()) == 0) {
			// Don't send any mail if no recipient or no message specified
			return;
		}

		$subject='Tracker Item #'.$TrackerItem->getTrackerItemId().' Was Modified';
		$body=$this->getNotificationMessage();
		
		// URL for the link
		$url = GFUrl::getURL()->projectURL($TrackerItem->getTracker()->getProject(), 'TrackerItemEdit', 'tracker', '', array('tracker_item_id'=>$TrackerItem->getTrackerItemId()));
		$url = GFUrl::getFullUrl($url, true);
		
		// Since the email is not in HTML, we have to replace the "&amp;" in the URL for regular ampersands
		$url = str_replace('&amp;', '&', $url);
		
		$body .= "\n\nModify the item here:\n\n".$url;

		SystemUtils::sendMail($subject,$body,$emails);
	}

}
?>
