<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'tracker_extra_field' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.tracker.lib.map
 */
class TrackerExtraFieldMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.tracker.lib.map.TrackerExtraFieldMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("tracker_extra_field");
		$tMap->setPhpName("TrackerExtraField");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("tracker_extra_field_tracker_extra_field_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("TRACKER_EXTRA_FIELD_ID", "TrackerExtraFieldId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("TRACKER_ID", "TrackerId", "int", CreoleTypes::INTEGER, "tracker" , "TRACKER_ID", true);
		$tMap->addColumn("FIELD_NAME", "FieldName", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("FIELD_TYPE", "FieldType", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addColumn("ATTRIBUTE1", "Attribute1", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("ATTRIBUTE2", "Attribute2", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("IS_REQUIRED", "IsRequired", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("ALIAS", "Alias", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("FIELD_ORDER", "FieldOrder", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("USE_IN_QUICK_BROWSE", "UseInQuickBrowse", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("SHOW_ON_SUBMIT", "ShowOnSubmit", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("USE_AUTO_ASSIGN", "UseAutoAssign", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("USE_WORKFLOW", "UseWorkflow", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("USE_COMMIT_RULE", "UseCommitRule", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("DEFAULT_VALUE", "DefaultValue", "string", CreoleTypes::VARCHAR, false, null);
				
    }
}
