<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/tracker/lib/TrackerItem.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerItemPeer.php';
 

// (on-demand) include_once 'plugins/tracker/lib/TrackerTimeCode.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerTimeCodePeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'plugins/tracker/lib/TrackerItemTimePeer.php';

/**
 * Base class that represents a row from the 'tracker_item_time' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TrackerItemTime class. 
 * 
 * @package plugins.tracker.lib 
 */
abstract class BaseTrackerItemTime extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TrackerItemTimePeer
	 */
	protected static $peer;

	/**
	 * The value for the tracker_item_time_id field.
	 * @var int	  
	 */
	protected $tracker_item_time_id;	

	/**
	 * The value for the date_entry field.
	 * @var int	  
	 */
	protected $date_entry = -1;	

	/**
	 * The value for the user_id field.
	 * @var int	  
	 */
	protected $user_id;	

	/**
	 * The value for the tracker_item_id field.
	 * @var int	  
	 */
	protected $tracker_item_id;	

	/**
	 * The value for the hours field.
	 * @var double	  
	 */
	protected $hours;	

	/**
	 * The value for the tracker_time_code_id field.
	 * @var int	  
	 */
	protected $tracker_time_code_id;	
  
	/**
	 * Get the TrackerItemTimeId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerItemTimeId()
	{
		return $this->tracker_item_time_id;
	}


	/**
	 * Set the value of `tracker_item_time_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setTrackerItemTimeId($v)
	{
		if ($this->tracker_item_time_id !== $v) {
			$this->tracker_item_time_id = $v;
			$this->modifiedColumns[] = TrackerItemTimePeer::TRACKER_ITEM_TIME_ID;
		}
				
	}


	/**
	 * Get the [optionally formatted] `date_entry` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getDateEntry($format = 'Y-m-d H:i:s')
	{
		if ($this->date_entry === null || $this->date_entry === '') {
			return null;
		} elseif (!is_int($this->date_entry)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->date_entry);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of date_entry as date/time value: " . var_export($this->date_entry, true));
			}
		} else {
			$ts = $this->date_entry;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `date_entry` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setDateEntry($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for date_entry from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->date_entry !== $ts || $ts === -1) {
			$this->date_entry = $ts;
			$this->modifiedColumns[] = TrackerItemTimePeer::DATE_ENTRY;
		}
		
	}

  
	/**
	 * Get the UserId column value.
	 *  
	 * @return int	  
	 */
	public function getUserId()
	{
		return $this->user_id;
	}


	/**
	 * Set the value of `user_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setUserId($v)
	{
		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = TrackerItemTimePeer::USER_ID;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the TrackerItemId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerItemId()
	{
		return $this->tracker_item_id;
	}


	/**
	 * Set the value of `tracker_item_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerItemId($v)
	{
		if ($this->tracker_item_id !== $v) {
			$this->tracker_item_id = $v;
			$this->modifiedColumns[] = TrackerItemTimePeer::TRACKER_ITEM_ID;
		}
			
		if ($this->aTrackerItem !== null && $this->aTrackerItem->getTrackerItemId() !== $v) {
			$this->aTrackerItem = null;
		}
			
	}

  
	/**
	 * Get the Hours column value.
	 *  
	 * @return double	  
	 */
	public function getHours()
	{
		return $this->hours;
	}


	/**
	 * Set the value of `hours` column.	  
	 *  
	 * @param double $v new value
	 * @return void
	 *  
	 */
	public function setHours($v)
	{
		if ($this->hours !== $v) {
			$this->hours = $v;
			$this->modifiedColumns[] = TrackerItemTimePeer::HOURS;
		}
				
	}

  
	/**
	 * Get the TrackerTimeCodeId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerTimeCodeId()
	{
		return $this->tracker_time_code_id;
	}


	/**
	 * Set the value of `tracker_time_code_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerTimeCodeId($v)
	{
		if ($this->tracker_time_code_id !== $v) {
			$this->tracker_time_code_id = $v;
			$this->modifiedColumns[] = TrackerItemTimePeer::TRACKER_TIME_CODE_ID;
		}
			
		if ($this->aTrackerTimeCode !== null && $this->aTrackerTimeCode->getTrackerTimeCodeId() !== $v) {
			$this->aTrackerTimeCode = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->tracker_item_time_id = $rs->getInt($startcol + 0);					
			$this->date_entry = $rs->getTimestamp($startcol + 1, null);
			$this->user_id = $rs->getInt($startcol + 2);					
			$this->tracker_item_id = $rs->getInt($startcol + 3);					
			$this->hours = $rs->getFloat($startcol + 4);					
			$this->tracker_time_code_id = $rs->getInt($startcol + 5);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TrackerItemTime object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TrackerItemTimePeer::DATABASE_NAME);
		$criteria->add(TrackerItemTimePeer::TRACKER_ITEM_TIME_ID, $this->tracker_item_time_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TrackerItemTimePeer::DATABASE_NAME);
		if ($this->isColumnModified(TrackerItemTimePeer::TRACKER_ITEM_TIME_ID)) $criteria->add(TrackerItemTimePeer::TRACKER_ITEM_TIME_ID, $this->tracker_item_time_id);
		if ($this->isColumnModified(TrackerItemTimePeer::DATE_ENTRY)) $criteria->add(TrackerItemTimePeer::DATE_ENTRY, $this->date_entry);
		if ($this->isColumnModified(TrackerItemTimePeer::USER_ID)) $criteria->add(TrackerItemTimePeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(TrackerItemTimePeer::TRACKER_ITEM_ID)) $criteria->add(TrackerItemTimePeer::TRACKER_ITEM_ID, $this->tracker_item_id);
		if ($this->isColumnModified(TrackerItemTimePeer::HOURS)) $criteria->add(TrackerItemTimePeer::HOURS, $this->hours);
		if ($this->isColumnModified(TrackerItemTimePeer::TRACKER_TIME_CODE_ID)) $criteria->add(TrackerItemTimePeer::TRACKER_TIME_CODE_ID, $this->tracker_time_code_id);
		return $criteria;			
	}
	
	

	/**
	 * @var TrackerItem	  
	 */
	protected $aTrackerItem;

	/**
	 * Declares an association between this object and a TrackerItem object
	 *
	 * @param TrackerItem $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerItem($v)
	{
			
		if ($v === null) {
			$this->setTrackerItemId(NULL);
		} else {
			$this->setTrackerItemId($v->getTrackerItemId());
		}
   
		$this->aTrackerItem = $v;
	}


	/**
	 * Get the associated TrackerItem object
	 *
	 * @param Connection Optional Connection object.
	 * @return TrackerItem The associated TrackerItem object.
	 * @throws PropelException
	 */
	public function getTrackerItem($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';

		if ($this->aTrackerItem === null && ($this->tracker_item_id !== null)) {
	
			$this->aTrackerItem = TrackerItemPeer::retrieveByPK($this->tracker_item_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerItemPeer::retrieveByPK($this->tracker_item_id, $con);
			   $obj->addTrackerItemTimes($this);
			 */
		}
		return $this->aTrackerItem;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerItemKey($key)
	{

		$this->setTrackerItemId( (int) $key);			
		
	}

	/**
	 * @var TrackerTimeCode	  
	 */
	protected $aTrackerTimeCode;

	/**
	 * Declares an association between this object and a TrackerTimeCode object
	 *
	 * @param TrackerTimeCode $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerTimeCode($v)
	{
			
		if ($v === null) {
			$this->setTrackerTimeCodeId(NULL);
		} else {
			$this->setTrackerTimeCodeId($v->getTrackerTimeCodeId());
		}
   
		$this->aTrackerTimeCode = $v;
	}


	/**
	 * Get the associated TrackerTimeCode object
	 *
	 * @param Connection Optional Connection object.
	 * @return TrackerTimeCode The associated TrackerTimeCode object.
	 * @throws PropelException
	 */
	public function getTrackerTimeCode($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerTimeCodePeer.php';

		if ($this->aTrackerTimeCode === null && ($this->tracker_time_code_id !== null)) {
	
			$this->aTrackerTimeCode = TrackerTimeCodePeer::retrieveByPK($this->tracker_time_code_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerTimeCodePeer::retrieveByPK($this->tracker_time_code_id, $con);
			   $obj->addTrackerItemTimes($this);
			 */
		}
		return $this->aTrackerTimeCode;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerTimeCodeKey($key)
	{

		$this->setTrackerTimeCodeId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->user_id !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->user_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->user_id, $con);
			   $obj->addTrackerItemTimes($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setUserId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("tracker_item_time_id", "date_entry", "user_id", "tracker_item_id", "hours", "tracker_time_code_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TrackerItemTimePeer::TRACKER_ITEM_TIME_ID:
				return $this->getTrackerItemTimeId();
				break;
		  
			case TrackerItemTimePeer::DATE_ENTRY:
				return $this->getDateEntry();
				break;
		  
			case TrackerItemTimePeer::USER_ID:
				return $this->getUserId();
				break;
		  
			case TrackerItemTimePeer::TRACKER_ITEM_ID:
				return $this->getTrackerItemId();
				break;
		  
			case TrackerItemTimePeer::HOURS:
				return $this->getHours();
				break;
		  
			case TrackerItemTimePeer::TRACKER_TIME_CODE_ID:
				return $this->getTrackerTimeCodeId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getTrackerItemTimeId();
				break;
  
			case 1:
				return $this->getDateEntry();
				break;
  
			case 2:
				return $this->getUserId();
				break;
  
			case 3:
				return $this->getTrackerItemId();
				break;
  
			case 4:
				return $this->getHours();
				break;
  
			case 5:
				return $this->getTrackerTimeCodeId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TrackerItemTimePeer::TRACKER_ITEM_TIME_ID, $arr)) $this->setTrackerItemTimeId($arr[TrackerItemTimePeer::TRACKER_ITEM_TIME_ID]);
  
		if (array_key_exists(TrackerItemTimePeer::DATE_ENTRY, $arr)) $this->setDateEntry($arr[TrackerItemTimePeer::DATE_ENTRY]);
  
		if (array_key_exists(TrackerItemTimePeer::USER_ID, $arr)) $this->setUserId($arr[TrackerItemTimePeer::USER_ID]);
  
		if (array_key_exists(TrackerItemTimePeer::TRACKER_ITEM_ID, $arr)) $this->setTrackerItemId($arr[TrackerItemTimePeer::TRACKER_ITEM_ID]);
  
		if (array_key_exists(TrackerItemTimePeer::HOURS, $arr)) $this->setHours($arr[TrackerItemTimePeer::HOURS]);
  
		if (array_key_exists(TrackerItemTimePeer::TRACKER_TIME_CODE_ID, $arr)) $this->setTrackerTimeCodeId($arr[TrackerItemTimePeer::TRACKER_TIME_CODE_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TrackerItemTimePeer::TRACKER_ITEM_TIME_ID:
				$this->setTrackerItemTimeId($value);
				break;
	  
			case TrackerItemTimePeer::DATE_ENTRY:
				$this->setDateEntry($value);
				break;
	  
			case TrackerItemTimePeer::USER_ID:
				$this->setUserId($value);
				break;
	  
			case TrackerItemTimePeer::TRACKER_ITEM_ID:
				$this->setTrackerItemId($value);
				break;
	  
			case TrackerItemTimePeer::HOURS:
				$this->setHours($value);
				break;
	  
			case TrackerItemTimePeer::TRACKER_TIME_CODE_ID:
				$this->setTrackerTimeCodeId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setTrackerItemTimeId($value);
				break;
  
			case 1:
				$this->setDateEntry($value);
				break;
  
			case 2:
				$this->setUserId($value);
				break;
  
			case 3:
				$this->setTrackerItemId($value);
				break;
  
			case 4:
				$this->setHours($value);
				break;
  
			case 5:
				$this->setTrackerTimeCodeId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerItemTimePeer::DATABASE_NAME);

		try {
			$con->begin();
			TrackerItemTimePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerItemTimePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aTrackerItem !== null) {
				if ($this->aTrackerItem->isModified()) $this->aTrackerItem->save($con);
				$this->setTrackerItem($this->aTrackerItem);
			}
 
			if ($this->aTrackerTimeCode !== null) {
				if ($this->aTrackerTimeCode->isModified()) $this->aTrackerTimeCode->save($con);
				$this->setTrackerTimeCode($this->aTrackerTimeCode);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TrackerItemTimePeer::doInsert($this, $con);
					$this->setTrackerItemTimeId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					TrackerItemTimePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TrackerItemTimePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aTrackerItem !== null) {
				if (($retval = $this->aTrackerItem->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aTrackerTimeCode !== null) {
				if (($retval = $this->aTrackerTimeCode->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TrackerItemTimePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed tracker_item_time_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setTrackerItemTimeId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getTrackerItemTimeId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TrackerItemTime Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TrackerItemTime();
		$copyObj->setDateEntry($this->date_entry);
		$copyObj->setUserId($this->user_id);
		$copyObj->setTrackerItemId($this->tracker_item_id);
		$copyObj->setHours($this->hours);
		$copyObj->setTrackerTimeCodeId($this->tracker_time_code_id);
		
		$copyObj->setNew(true);
		
		$copyObj->setTrackerItemTimeId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TrackerItemTimePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TrackerItemTimePeer();
		}
		return self::$peer;
	}

}
