<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new TrackerQuery and saves it to the 
// database
//
require_once('plugins/tracker/lib/TrackerQuery.php');
require_once('plugins/tracker/lib/TrackerQueryPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();	
}

$Project = GFUrl::getUrl()->getProject();
$Tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);
$crit = new Criteria();
$crit->add(TrackerQueryPeer::USER_ID, $session->getUser()->getID());
$crit->add(TrackerQueryPeer::TRACKER_QUERY_ID,$_REQUEST['tracker_query_id']);
$arr = $Tracker->getTrackerQuerys($crit);
$TrackerQuery=$arr[0];
if (!is_object($TrackerQuery)) {
	throw new PermissionDeniedException();
}
if (isset($_POST['sure'])) {
	$TrackerQuery->delete();
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerQueryBrowse'), array('feedback' => $language->getText('TrackerQuery.DeleteFeedback'),'tracker_id'=>$Tracker->getTrackerId()));
} else {
	$feedback = Language::getSessLang()->getText('TrackerQueryDeleteForm.DidntConfirm');
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerQueryBrowse'), array('feedback' => $feedback,'tracker_id'=>$Tracker->getTrackerId()));
	
}

?>
