<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists TrackerExtraFieldElement
//
require_once('plugins/tracker/lib/TrackerExtraFieldElementPeer.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElement.php');
require_once('lib/html/HTMLWidget.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$TrackerExtraField = TrackerExtraFieldPeer::retrieveByPk( isset($_REQUEST['tracker_extra_field_id']) ? $_REQUEST['tracker_extra_field_id'] : $tracker_extra_field_id );
$Tracker = $TrackerExtraField->getTracker();
$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldBrowse').'&amp;tracker_id='.$Tracker->getTrackerID() .'">'. $Lang->getText('TrackerExtraField.Edit') .'</a>');

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerExtraField.Edit').' > '.$Lang->getText('TrackerExtraFieldElement.BrowsePageTitle')
		);
$theme->header($params);
echo '<p><div class="infobox">'.$Lang->getText('Common.templateUpdating').'</div></p>';

echo '<script type="text/javascript" src="/prototype.js"></script>';
echo '<script type="text/javascript" src="/scriptaculous.js"></script>';


// Retrieve the objects array
$crit = new Criteria();
$crit->add(TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID, $TrackerExtraField->getTrackerExtraFieldId());
$crit->addAscendingOrderByColumn(TrackerExtraFieldElementPeer::SORT_ORDER);
$arr = TrackerExtraFieldElementPeer::doSelect($crit);

	$theader = array();

	$theader[] = $Lang->getText('TrackerExtraFieldElement.ElementNameName');
	if ($TrackerExtraField->getFieldType() == TrackerExtraField::TYPE_STATUS) {
		$theader[] = $Lang->getText('TrackerExtraFieldElement.StatusIdName');
	}
	if ($TrackerExtraField->getUseAutoAssign()) {
		$theader[] = $Lang->getText('TrackerExtraField.AutoAssignTo');
	}
	if ($TrackerExtraField->getUseWorkflow()) {
		$use_workflow=true;
		$theader[] = $Lang->getText('TrackerExtraFieldElement.Workflow');
	} else {
		$use_workflow=false;
	}
	if ($TrackerExtraField->getUseCommitRule()) {
		$use_commit_rule=true;
		$theader[] = $Lang->getText('TrackerExtraFieldElement.CanCommit');
	} else {
		$use_commit_rule=false;
	}
	$theader[] = $Lang->getText('TrackerExtraFieldElement.DefaultSelectedName');
	$theader[] = $Lang->getText('TrackerExtraFieldElement.SortOrderName');
	$theader[] = $Lang->getText('Delete');

	?><form action="<?php echo GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldElementEditAction') ?>" method="post"><?php
	echo $theme->tableTop($theader,false,'class="jsSortTBL"');

if (count($arr) < 1) {
	echo $theme->tableFullRow($Lang->getText('TrackerExtraFieldElement.NoneFound'));
} else {
	$statuses=$Tracker->getStatuses();
	echo '<tbody id="jsExtraFieldElementList">';
	foreach ($arr as $item) {
		$trow = array();
		$tmod = array();
		$trow[]='<input type="text" name="element_name['.$item->getElementId().']" value="'.$item->getElementName().'" />';
		$tmod[]='class="moveHandle"';
		if ($TrackerExtraField->getFieldType() == TrackerExtraField::TYPE_STATUS) {
			$trow[]=$statuses[$item->getStatusId()];
			$tmod[]='';
		}
		if ($TrackerExtraField->getUseAutoAssign()) {
			$trow[]=HTMLWidget::select('auto_assign_to['.$item->getElementId().']',$TrackerExtraField->getTracker()->getTechnicians(),$item->getAutoAssignTo(),100,true,'Unassigned',false,null);
			$tmod[]='';
		}
		if ($use_workflow) {
			$trow[]='<a href="'.GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldElementTransitionBrowse').'&amp;element_id='.$item->getElementId().'">'.$Lang->getText('TrackerExtraFieldElement.DefineRules').'</a>';
			$tmod[]='';
		}
		if ($use_commit_rule) {
			$trow[]='<input type="checkbox" name="can_commit['.$item->getElementId().']" value="1" '.($item->getCanCommit()=='1' ? ' checked' : '' ).' />';
			$tmod[]='';
		}
		$trow[]='<input type="radio" name="default_selected" value="'.$item->getElementId().'"'.($item->getDefaultSelected()=='1' ? ' checked' : '' ).' />';
		$tmod[]='';
		$trow[]='<input type="text" name="sort_order['.$item->getElementId().']" value="'.$item->getSortOrder().'"  id="EFEOrder'.$item->getElementID().'" size="3" maxlength="3"/>';
		$tmod[]='';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldElementDelete').'&amp;element_id='.$item->getElementID().'">'. $Lang->getText('Delete') .'</a>';
		$tmod[]='';

		echo $theme->tableRow($trow, $tmod, false, 'id="jsExtraFieldElementList_EFEOrder'.$item->getElementID().'"');
	}
	echo '</tbody>';

}
	echo $theme->tableBottom(array(GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldElementAdd').'&amp;tracker_extra_field_id='.$TrackerExtraField->getTrackerExtraFieldId()=>$Lang->getText('TrackerExtraFieldElement.AddNew')));
	?>
<br />
<?php echo HTMLWidget::button("submit", $Lang->getText('Common.Submit')); ?>
<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Back') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'TrackerExtraFieldBrowse','tracker','admin',array('tracker_id' => $Tracker->getTrackerId())) . "'; ")?>
</form>

<script type="text/javascript">
var moveHandlers = document.body.getElementsByClassName("moveHandle");
if(moveHandlers.length > 0)
{
	function updateOrder() {
		arrayEF = Sortable.serialize('jsExtraFieldElementList').split('&');
		for (i=0;i<arrayEF.length;i++) {
			efKeyVal = arrayEF[i].split('=');
			obj = FindObject(efKeyVal[1]);
			if (obj) obj.value = i;
		}
		return true;
	}

	Sortable.create("jsExtraFieldElementList", {
		dropOnEmpty:true,
		handle:'moveHandle',
		containment:["jsExtraFieldElementList"],
		constraint:false,
		tag:'tr',
		onUpdate:updateOrder
		}
	);
	//window.onload=updateOrder;
	window.onload=window.onload=function(){oldload();convertTrees();window.setTimeout('expandableExpandItem()',100);docmanExpandTree();updateOrder();}
}
</script>
<?php

$theme->footer($params);
?>
