<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/ProjectPeer.php');
require_once('lib/core/UserPeer.php');
require_once('lib/core/User.php');
require_once('lib/core/RolePeer.php');
require_once('lib/core/Role.php');
require_once('lib/core/UserPeer.php');
require_once('plugins/userfiles/lib/html/UserfilesMyAdminTemplate.php');

$theme = new UserfilesMyAdminTemplate();
$user = GFUrl::getUrl()->getUser();
$params = array(
		'user' => $user,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => 'Userfiles Admin'
		);
$theme->header($params);


?>


<?php
$theader = array();
$theader[] = Language::getSessText('UserFiles.Filename');
//$theader[] = Language::getSessText('UserFiles.Edit');
$theader[] = Language::getSessText('UserFiles.Delete');

echo $theme->tableTop($theader);

// get the files for the user
$c = new Criteria();
$c->add(FilesystemPeer::SECTION,'user');
$c->add(FilesystemPeer::REF_ID,$user->getUserId());
$userfiles = FilesystemPeer::doSelect($c);
if (count($userfiles)>0) {
	foreach ($userfiles as $userfile) {
		$trow = array();
		$url = GFUrl::getURL()->downloadURL(User::SECTION,$user->getUserId(),$userfile->getPrimaryKey(),$userfile->getFileNameSafe());
		$trow[] = '<a href="' . $url . '">'.$userfile->getFileName().'</a>';
		//$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('UserfileEdit').'&amp;file_id='.$userfile->getPrimaryKey() .'">'. Language::getSessText('Edit') .'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('UserfileDelete').'&amp;file_id='.$userfile->getPrimaryKey() .'">'. Language::getSessText('Delete') .'</a>';		
		echo $theme->tableRow($trow);
	}
} else {
	echo $theme->tableRow(array(Language::getSessText('UserFiles.NoFiles')),array('colspan=3'));
}

echo $theme->tableBottom();

?>

<?php
$theme->footer();
?>