<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/ProjectPeer.php');
require_once('lib/core/UserPeer.php');
require_once('lib/core/User.php');
require_once('lib/core/RolePeer.php');
require_once('lib/core/Role.php');
require_once('lib/core/UserPeer.php');

$components = GFUrl::getUrl()->getURI();
$arr = explode('/',$components);
if (in_array('my',$arr)) {
	require_once('plugins/userfiles/lib/html/UserfilesMyTemplate.php');
	$theme = new UserfilesMyTemplate();
} else {
	require_once('plugins/userfiles/lib/html/UserfilesUserTemplate.php');
	$theme = new UserfilesUserTemplate();
}


$user = GFUrl::getUrl()->getUser();
$params = array(
		'user' => $user,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => 'User Files',
		'selectedbottomtab' => 'userfiles'
		);
$theme->header($params);


?>

<?php

$theader = array();
$theader[] = Language::getSessText('UserFiles.Filename');
$theader[] = Language::getSessText('UserFiles.Filesize');
$theader[] = Language::getSessText('UserFiles.Downloads');

echo $theme->tableTop($theader);

// get the files for the user
$c = new Criteria();
$c->add(FilesystemPeer::SECTION,'user');
$c->add(FilesystemPeer::REF_ID,$user->getUserId());
$userfiles = FilesystemPeer::doSelect($c);
if (count($userfiles)>0) {
	foreach ($userfiles as $userfile) {
		$trow = array();
		$url = GFUrl::getURL()->downloadURL(User::SECTION,$user->getUserId(),$userfile->getPrimaryKey(),$userfile->getFileNameSafe());
		$trow[] = '<a href="' . $url . '">'.$userfile->getFileName().'</a>';
		$size = $userfile->getFileSize()/1024;
		if ($size > 1024) {
			$size = $size / 1024;
			if ($size > 1024) {
				$size = round($size,2) . ' Gb';
			} else {
				$size = round($size,2) . ' Mb';
			}
		} else {
			$size = round($size,2) . ' Kb';
		}
		$trow[] = $size;
		$trow[] = $userfile->getDownloadCount();
		echo $theme->tableRow($trow);
	}
} else {
	echo $theme->tableRow(array(Language::getSessText('UserFiles.NoFiles')),array('colspan=3'));
}

if (in_array('my',$arr)) {
	echo $theme->tableBottom(array(GFUrl::getUrl()->currentBaseUrl('UserfileAdd') => Language::getSessText('UserFiles.AddNew')));
} else {
	echo $theme->tableBottom();
}


?>

<?php
$theme->footer();
?>