<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/userwiki/lib/WikiPage.php';
// (on-demand) include_once 'plugins/userwiki/lib/WikiPagePeer.php';
 

// (on-demand) include_once 'plugins/userwiki/lib/WikiPage.php';
// (on-demand) include_once 'plugins/userwiki/lib/WikiPagePeer.php';

include_once 'plugins/userwiki/lib/WikiPageLinkPeer.php';

/**
 * Base class that represents a row from the 'wiki_page_link' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to WikiPageLink class. 
 * 
 * @package plugins.wiki.lib 
 */
abstract class BaseUserWikiPageLink extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var WikiPageLinkPeer
	 */
	protected static $peer;

	/**
	 * The value for the from_wiki_page_id field.
	 * @var int	  
	 */
	protected $from_wiki_page_id;	

	/**
	 * The value for the to_wiki_page_id field.
	 * @var int	  
	 */
	protected $to_wiki_page_id;	
  
	/**
	 * Get the FromWikiPageId column value.
	 *  
	 * @return int	  
	 */
	public function getFromWikiPageId()
	{
		return $this->from_wiki_page_id;
	}


	/**
	 * Set the value of `from_wiki_page_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setFromWikiPageId($v)
	{
		if ($this->from_wiki_page_id !== $v) {
			$this->from_wiki_page_id = $v;
			$this->modifiedColumns[] = UserWikiPageLinkPeer::FROM_WIKI_PAGE_ID;
		}
			
		if ($this->aWikiPageRelatedByFromWikiPageId !== null && $this->aWikiPageRelatedByFromWikiPageId->getWikiPageId() !== $v) {
			$this->aWikiPageRelatedByFromWikiPageId = null;
		}
			
	}

  
	/**
	 * Get the ToWikiPageId column value.
	 *  
	 * @return int	  
	 */
	public function getToWikiPageId()
	{
		return $this->to_wiki_page_id;
	}


	/**
	 * Set the value of `to_wiki_page_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setToWikiPageId($v)
	{
		if ($this->to_wiki_page_id !== $v) {
			$this->to_wiki_page_id = $v;
			$this->modifiedColumns[] = UserWikiPageLinkPeer::TO_WIKI_PAGE_ID;
		}
			
		if ($this->aWikiPageRelatedByToWikiPageId !== null && $this->aWikiPageRelatedByToWikiPageId->getWikiPageId() !== $v) {
			$this->aWikiPageRelatedByToWikiPageId = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->from_wiki_page_id = $rs->getInt($startcol + 0);					
			$this->to_wiki_page_id = $rs->getInt($startcol + 1);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating UserWikiPageLink object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(UserWikiPageLinkPeer::DATABASE_NAME);
		$criteria->add(UserWikiPageLinkPeer::FROM_WIKI_PAGE_ID, $this->from_wiki_page_id);
		$criteria->add(UserWikiPageLinkPeer::TO_WIKI_PAGE_ID, $this->to_wiki_page_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(UserWikiPageLinkPeer::DATABASE_NAME);
		if ($this->isColumnModified(UserWikiPageLinkPeer::FROM_WIKI_PAGE_ID)) $criteria->add(UserWikiPageLinkPeer::FROM_WIKI_PAGE_ID, $this->from_wiki_page_id);
		if ($this->isColumnModified(UserWikiPageLinkPeer::TO_WIKI_PAGE_ID)) $criteria->add(UserWikiPageLinkPeer::TO_WIKI_PAGE_ID, $this->to_wiki_page_id);
		return $criteria;			
	}
	
	

	/**
	 * @var WikiPage	  
	 */
	protected $aWikiPageRelatedByFromWikiPageId;

	/**
	 * Declares an association between this object and a WikiPage object
	 *
	 * @param WikiPage $v
	 * @return void
	 * @throws PropelException
	 */
	public function setWikiPageRelatedByFromWikiPageId($v)
	{
			
		if ($v === null) {
			$this->setFromWikiPageId(NULL);
		} else {
			$this->setFromWikiPageId($v->getWikiPageId());
		}
   
		$this->aWikiPageRelatedByFromWikiPageId = $v;
	}


	/**
	 * Get the associated WikiPage object
	 *
	 * @param Connection Optional Connection object.
	 * @return WikiPage The associated WikiPage object.
	 * @throws PropelException
	 */
	public function getWikiPageRelatedByFromWikiPageId($con = null)
	{
		// include the Peer class
		include_once 'plugins/userwiki/lib/WikiPagePeer.php';

		if ($this->aWikiPageRelatedByFromWikiPageId === null && ($this->from_wiki_page_id !== null)) {
	
			$this->aWikiPageRelatedByFromWikiPageId = UserWikiPagePeer::retrieveByPK($this->from_wiki_page_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = WikiPagePeer::retrieveByPK($this->from_wiki_page_id, $con);
			   $obj->addUserWikiPageLinksRelatedByFromWikiPageId($this);
			 */
		}
		return $this->aWikiPageRelatedByFromWikiPageId;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setWikiPageRelatedByFromWikiPageIdKey($key)
	{

		$this->setFromWikiPageId( (int) $key);			
		
	}

	/**
	 * @var WikiPage	  
	 */
	protected $aWikiPageRelatedByToWikiPageId;

	/**
	 * Declares an association between this object and a WikiPage object
	 *
	 * @param WikiPage $v
	 * @return void
	 * @throws PropelException
	 */
	public function setWikiPageRelatedByToWikiPageId($v)
	{
			
		if ($v === null) {
			$this->setToWikiPageId(NULL);
		} else {
			$this->setToWikiPageId($v->getWikiPageId());
		}
   
		$this->aWikiPageRelatedByToWikiPageId = $v;
	}


	/**
	 * Get the associated WikiPage object
	 *
	 * @param Connection Optional Connection object.
	 * @return WikiPage The associated WikiPage object.
	 * @throws PropelException
	 */
	public function getWikiPageRelatedByToWikiPageId($con = null)
	{
		// include the Peer class
		include_once 'plugins/userwiki/lib/WikiPagePeer.php';

		if ($this->aWikiPageRelatedByToWikiPageId === null && ($this->to_wiki_page_id !== null)) {
	
			$this->aWikiPageRelatedByToWikiPageId = UserWikiPagePeer::retrieveByPK($this->to_wiki_page_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserWikiPagePeer::retrieveByPK($this->to_wiki_page_id, $con);
			   $obj->addUserWikiPageLinksRelatedByToWikiPageId($this);
			 */
		}
		return $this->aWikiPageRelatedByToWikiPageId;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setWikiPageRelatedByToWikiPageIdKey($key)
	{

		$this->setToWikiPageId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("from_wiki_page_id", "to_wiki_page_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case UserWikiPageLinkPeer::FROM_WIKI_PAGE_ID:
				return $this->getFromWikiPageId();
				break;
		  
			case UserWikiPageLinkPeer::TO_WIKI_PAGE_ID:
				return $this->getToWikiPageId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getFromWikiPageId();
				break;
  
			case 1:
				return $this->getToWikiPageId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(UserWikiPageLinkPeer::FROM_WIKI_PAGE_ID, $arr)) $this->setFromWikiPageId($arr[UserWikiPageLinkPeer::FROM_WIKI_PAGE_ID]);
  
		if (array_key_exists(UserWikiPageLinkPeer::TO_WIKI_PAGE_ID, $arr)) $this->setToWikiPageId($arr[UserWikiPageLinkPeer::TO_WIKI_PAGE_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case UserWikiPageLinkPeer::FROM_WIKI_PAGE_ID:
				$this->setFromWikiPageId($value);
				break;
	  
			case UserWikiPageLinkPeer::TO_WIKI_PAGE_ID:
				$this->setToWikiPageId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setFromWikiPageId($value);
				break;
  
			case 1:
				$this->setToWikiPageId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserWikiPageLinkPeer::DATABASE_NAME);

		try {
			$con->begin();
			UserWikiPageLinkPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserWikiPageLinkPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aWikiPageRelatedByFromWikiPageId !== null) {
				if ($this->aWikiPageRelatedByFromWikiPageId->isModified()) $this->aWikiPageRelatedByFromWikiPageId->save($con);
				$this->setWikiPageRelatedByFromWikiPageId($this->aWikiPageRelatedByFromWikiPageId);
			}
 
			if ($this->aWikiPageRelatedByToWikiPageId !== null) {
				if ($this->aWikiPageRelatedByToWikiPageId->isModified()) $this->aWikiPageRelatedByToWikiPageId->save($con);
				$this->setWikiPageRelatedByToWikiPageId($this->aWikiPageRelatedByToWikiPageId);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UserWikiPageLinkPeer::doInsert($this, $con);
					$this->setNew(false);
				} else {
					UserWikiPageLinkPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return UserWikiPageLinkPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aWikiPageRelatedByFromWikiPageId !== null) {
				if (($retval = $this->aWikiPageRelatedByFromWikiPageId->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aWikiPageRelatedByToWikiPageId !== null) {
				if (($retval = $this->aWikiPageRelatedByToWikiPageId->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = UserWikiPageLinkPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  


	private $pks = array();
	
	/**
	 * Set the PrimaryKey.
	 *
	 * @param array $keys The elements of the composite key (order must match the order in XML file).
	 * @return void
	 * @throws PropelException
	 */
	public function setPrimaryKey($keys)
	{						

		$this->setFromWikiPageId($keys[0]);

		$this->setToWikiPageId($keys[1]);

	}


	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return array 
	 */
	public function getPrimaryKey()
	{
		$this->pks[0] = $this->getFromWikiPageId();
		$this->pks[1] = $this->getToWikiPageId();
		return $this->pks;

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return UserWikiPageLink Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new UserWikiPageLink();
		
		$copyObj->setNew(true);
		
		$copyObj->setFromWikiPageId(NULL); // this is a pkey column, so set to default value
		$copyObj->setToWikiPageId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return UserWikiPageLinkPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UserWikiPageLinkPeer();
		}
		return self::$peer;
	}

}
