<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a User and saves it to the 
// database
//
require_once('core/User.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$User = $session->getUser();

$errors = array();
$language = Language::getSessLang();

if (GFConf::get('system.useSSO') && !GFConf::get('system.SSORequireStoredPassword')) {
        //some sso systems would not have an initial stored password
} elseif($User->getPasswordMd5() != md5($_POST['old_password'])) {
        $errors[] = $language->getText('MyUserPasswordEdit.ErrorOldPasswordIncorrect');
}

//new passwords must match
if ($_POST['new_password'] != $_POST['new_password_conf']) {
	$errors[] = $language->getText('MyUserPasswordEdit.PasswordsMustMatch');
} else {
	$passresult = Validator::validatePassword($_POST['new_password']);
	if (!$passresult[0]) {
		$errors = array_merge($errors,$passresult[1]);
	}
}

if (count($errors) == 0) {
	$User->setPassword( $_POST['new_password'] );		// Password must not be sanitized

	$User->save();
	$url = GFUrl::getUrl();
	GFUrl::redirect($url->currentBaseURL('index'), array('feedback' => $language->getText('MyUserPasswordEdit.EditFeedback')));
} else {
	$feedback = implode('<br />', $errors);		
	include('UserPasswordEdit.php');
}

?>
