<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$theme->header($params);
if(!isset($_GET['id'])) {
        throw new PermissionDeniedException();
}

$Group = UserPeer::retrieveByPk(Validator::sanitizeInt($_GET['id']));
if (is_object($Group) && $Group->getIsGroup() != true) {
        throw new PermissionDeniedException();
}

// Retrieve the objects array
$arr = $Group->getUsergroupUsersRelatedByUsergroupid();


$theader = array();

$theader[] = $Lang->getText('Usergroup.MemberUserIdName');
$theader[] = $Lang->getText('UsergroupUser.MemberUserIdName');
$theader[] = $Lang->getText('Delete');

echo $theme->tableTop($theader);

if (count($arr) < 1) {
        echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('UsergroupUser.NoneFound').'</span>');
} else {
        foreach ($arr as $item) {
		$User = UserPeer::retrieveByPk($item->getMemberUserId());
                $trow = array();
                $trow[]=$Group->getFirstName();
                $trow[]=$User->getUserLink();
                $trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupUserDelete').'&amp;id='.$item->getUsergroupId() .'&amp;remove_id='.$item->getMemberUserId().'">'. $Lang->getText('Delete') .'</a>';

                echo $theme->tableRow($trow);
        }
}

//echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupUserAdd').'&amp;id='.$Group->getId() .'">'. $Lang->getText('UsergroupUser.AddNew') .'</a>'));
$buttons_array = array();
$buttons_array[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupUserAdd').'&amp;id='.$Group->getId() .'">'. $Lang->getText('UsergroupUser.AddNew') .'</a>';
$buttons_array[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupBrowse').'">'. $Lang->getText('Common.Back') .'</a>';
echo $theme->tableBottom($buttons_array, array(true, true));
$theme->footer($params);
?>
