<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com 
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/MyTemplate.php');
require_once('plugins/tracker/lib/TrackerMyQueuePeer.php');

$template = new MyTemplate();

$session = Session::getSession();
$User = $session->getUser();
$Lang = $session->getLanguage();

echo popupHeader($template, $Lang->getText('TrackerMyQueue.MyQueue'));

// Get the list of queued tracker items
$crit = new Criteria();
$crit->add(TrackerMyQueuePeer::USER_ID, $User->getUserId());
$crit->addAscendingOrderByColumn(TrackerMyQueuePeer::SORT_ORDER);
$MyQueuedItems = TrackerMyQueuePeer::doSelectJoinTrackerItem($crit);
?>
<script type="text/javascript" src="/js/tooltip.js"></script>
<script type="text/javascript" src="/prototype.js"></script>
<script type="text/javascript" src="/scriptaculous.js"></script>

<form action="<?php echo GFUrl::getUrl()->currentBaseURL('MyQueueUpdateAction') ?>" method="POST">
<input type="hidden" name="returnToPopup" value="true"/>

<div id="jsTrackerQueue" class="jsTrackerQueue">
	<div class="listviewheader" style="padding: 0px;height:20px;">
		<table cellspacing="0" cellpadding="0" border="0" class="jsTrackerQueueTable"><tr>
			<td class="jsTrackerQueueTitle jsRBorder jsTrackerQueueColId"><?php echo $Lang->getText('Common.Id');?></td>
			<td class="jsTrackerQueueTitle jsRBorder jsTrackerQueueColName"><?php echo $Lang->getText('TrackerItem.SummaryName'); ?></td>
			<td class="jsTrackerQueueTitle jsRBorder jsTrackerQueueColPriority"><?php echo $Lang->getText('TrackerItem.PriorityName'); ?></td>
			<td class="jsTrackerQueueTitle jsTrackerQueueColRemove">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
		</tr></table>
	</div>
	<div id="jsTrackerItemList">
<?php
if (count($MyQueuedItems) == 0) {
	echo $Lang->getText('TrackerMyQueue.NoItems');
} else {
	// Add Tracker Item Ids (in the format needed here) to the JavaScript code
	$i = 0;
	foreach ($MyQueuedItems as $QueuedItem) {
		$myClass = ($i % 2) ? 'jsItemB' : 'jsItemA';
		$TrackerItem = $QueuedItem->getTrackerItem();
		$myPriority = $TrackerItem->getPriority();
		$myPriorityCol = $theme->getPriorityColor($TrackerItem->getPriority());
		$tooltip = StringUtils::trimString($TrackerItem->getDetails(), 500);
		$tooltip = StringUtils::generateTooltip($tooltip);
	
		$myLink = '<a href="'.GFUrl::getUrl()->projectURL(ProjectPeer::retrieveByPk($TrackerItem->getTracker()->getProjectId()),'TrackerItemEdit','tracker','', 
				array('tracker_id'=>$TrackerItem->getTrackerId(),'tracker_item_id'=>$TrackerItem->getTrackerItemId())) .
				'" onmouseover="tooltip(\''.$tooltip.'\')" onmouseout="tooltipexit()" target="_blank">'.$TrackerItem->getSummary().'</a>';
	
		echo '<div id="ulTrackerList_ulTrackerList'.$QueuedItem->getTrackerItemId().'" class="moveHandle" style="clear:both;">
					<input name="queuedTrackerItems[]" type="hidden" value="'.$QueuedItem->getTrackerItemId().'">
					<table cellspacing="0" cellpadding="0" border="0" class="jsTrackerQueueTable"><tr>
						<td class="'.$myClass.' jsRBorder jsTrackerQueueColId">'.$QueuedItem->getTrackerItemId().'</td>
						<td class="'.$myClass.' jsRBorder jsTrackerQueueColName">'.$myLink.'</td>
						<td class="'.$myClass.' jsRBorder jsTrackerQueueColPriority" style="background-color: '.$myPriorityCol.';">'.$myPriority.'&nbsp;&nbsp;</td>
						<td class="'.$myClass.' jsTrackerQueueColRemove">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
					</tr></table>'.
			"</div>\n";
		$i++;
	}
}
?>
	</div>
	<div id="jsSeparator" style="height:16px;"></div>
</div>
<div class="jsTrackerQueueSave" align="right"><?php echo HTMLWidget::button("submit","" .   $Lang->getText('TrackerMyQueue.SaveQueue') . " ","updateQueue","","")?></div>
</form>

<script type="text/javascript">
Sortable.create("jsTrackerItemList", {dropOnEmpty:true,containment:["jsTrackerItemList"], handle:'moveHandle', tag:'div',constraint:false});
</script>
<?php

echo popupFooter();

?>
