<?php

/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Prez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


?>
<form method="post" action="<?php echo GFUrl::getUrl()->currentBaseUrl('UserPluginsEditAction') ?>">
	<?php
		// First show the plugins which have no exclusive_type

		//@todo: let the user edit the order of the plugins
		$count = 0;
		
		$c = new Criteria();
		$c->add(PluginPeer::PLUGIN_TYPE, GFPlugin::USER_PLUGIN);
		$c->add(PluginPeer::EXCLUSIVE_TYPE, null, Criteria::ISNULL);
		$c->addAscendingOrderByColumn(PluginPeer::PLUGIN_ORDER);
		$UserPlugins = PluginPeer::doSelect($c);
		
		$count = $count + count($UserPlugins);
		foreach ($UserPlugins as $plugin) {
			$usesPlugin = $User->usesPlugin($plugin->getPluginName());
			$pluginName = $plugin->getPluginName();
	?>
		<input type="checkbox" name="plugins[]" value="<?php echo htmlspecialchars($pluginName) ?>" <?php if ($usesPlugin) echo 'checked="checked"'; ?>/><?php echo $plugin->getPluginDesc() ?> <br />
		<input type="hidden" name="allPlugins[]" value="<?php echo htmlspecialchars($pluginName) ?>" />
	<?php
		}
		
		// Now display the ones with exclusive_type
		
		// get a list of the different exclusive types
		$exclusive_types = UserPluginPeer::getExclusiveTypes();
		
		foreach ($exclusive_types as $exclusive_type) {
			$plugins = UserPluginPeer::getExclusiveTypePlugins($exclusive_type);
			
			echo "<hr />\n";
			$desc = $Lang->getText('ExclusiveType.'.$exclusive_type);
			if (!$desc) $desc = $exclusive_type;
			
			echo $desc.":<br />\n";
			$usesAny = false;		// Uses ANY of these plugins?
			
			$count = $count + count($plugins);
			foreach ($plugins as $plugin) {
				$usesPlugin = $User->usesPlugin($plugin->getPluginName());
				$usesAny = $usesAny || $usesPlugin;
				$pluginName = $plugin->getPluginName();
	?>
		<input type="radio" name="plugins[<?php echo $exclusive_type ?>]" value="<?php echo htmlspecialchars($pluginName) ?>" <?php if ($usesPlugin) echo 'checked="checked"'; ?>/><?php echo $plugin->getPluginDesc() ?> <br />
		<input type="hidden" name="allPlugins[]" value="<?php echo htmlspecialchars($pluginName) ?>" />
	<?php
			}
	?>
	<input type="radio" name="plugins[<?php echo $exclusive_type ?>]" value="" <?php if (!$usesAny) echo 'checked="checked"'; ?>/><?php echo $Lang->getText('Options.None') ?> <br />
	<?php
		}
		
		if ($count == 0) {
	?>
		<?php echo $Lang->getText('UserPlugin.NoneFound'); ?>
	<?php
		}
		else {
	?>
		<div align="center">
			<?php echo HTMLWidget::button("submit","" .   htmlspecialchars($Lang->getText('Common.Submit'))  . " ","submit","","")?>
			<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Back') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->baseURL('', '', 'account') . "'; ")?>
		</div>
	<?php
		}
	?>

</form>
