<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');
require_once('core/ProjectPeer.php');
require_once('session/Session.php');
require_once('core/Plugin.php');
require_once('plugin/GFPlugin.php');
require_once('core/RolePeer.php');
require_once('core/UserProject.php');
require_once('html/HTMLWidget.php');

$session = Session::getSession();
$project = GFUrl::getUrl()->getProject();
$project_id = $project->getProjectId();
$Lang = $session->getLanguage();

if (!$project->userIsAdmin()) {
	throw new PermissionDeniedException();
}


require_once('html/templates/ProjectAdminTemplate.php');
$template = new ProjectAdminTemplate();
$params = array(
		'selectedbottomtab'	=> 'project_admin',
		'project' => $project,
		'title' => Language::getSessText('ProjectAdmin.UserRole'),
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : ''
	);
$template->header($params);

?>

<table width="100%" cellpadding="2" cellspacing="2" border="0">
	<tr valign="top">
		<td width="50%">
<?php

$user_projects = $project->getUserProjectsJoinUser();

$headers = array(Language::getSessText('Project.ProjectNameName'),
				Language::getSessText('ProjectAdmin.Role'),
				Language::getSessText('ProjectAdmin.Update'),
				Language::getSessText('ProjectAdmin.Remove')
			);

echo $template->tableTop($headers);

$c = new Criteria();
$c->add(RolePeer::PROJECT_ID,$project_id);
$roles = RolePeer::doSelect($c);
$i=0;
foreach ($user_projects as $up) {
	$i++;
	$sel=array();
	$rs=$up->getUserProjectRoles();
	foreach ($rs as $r) {
		$sel[]=$r->getRoleId();
	}
	echo '<form action="' . GFUrl::getUrl()->projectURL($project,'UpdateUser','','admin') . '"  method="post">
		<input type="hidden" name="user_id" value="'.$up->getUserId().'" />';
	$trow=array();
	$trow[]=$up->getUser()->getUserLink().' ('.$up->getUser()->getUnixName().')';
	$trow[]=HTMLWidget::multiselect('role_id[]',$roles,$sel,HTMLWidget::OPTION_NONE,false,null,false);
	$trow[]= HTMLWidget::button("submit",Language::getSessText('ProjectAdmin.Update'),"updateuser","updateuser_$i","") ;
	$trow[]= HTMLWidget::button("submit",Language::getSessText('ProjectAdmin.Remove'),"rmuser","rmuser_$i","") ;
	echo $template->tableRow($trow);
	echo '</form>';
}
$trow=array();
echo '<form id="useradd" name="useradd" action="'. GFUrl::getUrl()->projectURL($project,'UpdateUser','','admin') .'" method="post">';
$trow[]='<input type="text" name="unix_name" size="10" value="" />&nbsp;&nbsp;<a href="javascript:void(0);" onclick="popup(\''.GFUrl::getUrl()->baseURL('findusers', '', 'admin/popups', array('search' => 'user_0', 'type' => 'user')).'&words=\' + document.useradd.unix_name.value, \'300\', \'200\');">'.Language::getSessText('ProjectAdmin.PopupAddUser').'</a>';
$trow[]=HTMLWidget::multiselect('role_id[]',$roles,array(),false,false);
$trow[]=HTMLWidget::button("submit", Language::getSessText('ProjectAdmin.AddUser'), "adduser");
$trow[]='&nbsp;';
echo $template->tableRow($trow);
echo '</form>';

echo $template->tableBottom();

$template->footer();
?>
