<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for $OBJECT deletion
//
require_once('core/AssociationPeer.php');
require_once('core/Association.php');
require_once('plugins/tracker/lib/TrackerItemPeer.php');
require_once('plugins/tracker/lib/TrackerItem.php');
require_once('plugins/wiki/lib/WikiPage.php');
require_once('plugins/wiki/lib/WikiPagePeer.php');
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('plugins/frs/lib/FrsReleasePeer.php');
require_once('plugins/frs/lib/FrsRelease.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('lib/html/ProjectTemplate.php');
$theme = new SiteTemplate();

$Project = GFUrl::getUrl()->getProject();
$crit= new Criteria();
$key=((isset($_POST['key'])) ? $_POST['key'] : $_GET['key']);
$vals = explode('|',$key);
$crit->add( AssociationPeer::SECTION,$vals[0] );
$crit->add( AssociationPeer::REF_ID,$vals[1] );
$crit->add( AssociationPeer::TO_SECTION,$vals[2] );
$crit->add( AssociationPeer::TO_REF_ID,$vals[3] );
$Association = AssociationPeer::doSelectOne($crit);

//association id of section
$assoc_id_1 = $vals[1];
//association id of to-section
$assoc_id_2 = $vals[3];
//gets the item name for section

switch ($vals[0]) {
	case "trackeritem":
		$TrackerAssoc = TrackerItemPeer::retrieveByPk($vals[1]);
		if ($TrackerAssoc == null || !is_object($TrackerAssoc)) {
			throw new PermissionDeniedException();
		}
		$assoc_name_1 = $TrackerAssoc->getSummary();
	break;

	case "wikipage":
		$WikiAssoc = WikiPagePeer::retrieveByPk($vals[1]);
		if ($WikiAssoc == null || !is_object($WikiAssoc)) {
			throw new PermissionDeniedException();
		}
		$assoc_name_1 = $WikiAssoc->getPageName();
	break;

	case "docmanfile":
		$DocmanFile = DocmanFilePeer::retrieveByPk($vals[1]);
		if ($DocmanFile == null || !is_object($DocmanFile)) {
			throw new PermissionDeniedException();
		}
		$assoc_name_1 = $DocmanFile->getLatestVersion()->getFile()->getFileName();
	break;

	case "frsrelease":
		$FrsRelease = FrsReleasePeer::retrieveByPk($vals[1]);
		if ($FrsRelease == null || !is_object($FrsRelease)) {
			throw new PermissionDeniedException();
		}
		$assoc_name_1 = $FrsRelease->getReleaseName();
	break;

	case "forummessage":
		$ForumMessage = ForumMessagePeer::retrieveByPk($vals[1]);
		if ($ForumMessage == null || !is_object($ForumMessage)){
			throw new PermissionDeniexException();
		}
		$assoc_name_1 = $ForumMessage->getSubject();
	break;

	case "scmcommit":
		$assoc_name_1 = "Scm Commit #".$vals[1];
	break;	
}

//gets the item name for to-section
switch ($vals[2]) {
	case "trackeritem":
		$TrackerAssoc = TrackerItemPeer::retrieveByPk($vals[3]);
		if ($TrackerAssoc == null || !is_object($TrackerAssoc)) {
			throw new PermissionDeniedException();
		}
		$assoc_name_2 = $TrackerAssoc->getSummary();
	break;

	case "wikipage":
		$WikiAssoc = WikiPagePeer::retrieveByPk($vals[3]);
		if ($WikiAssoc == null || !is_object($WikiAssoc)) {
			throw new PermissionDeniedException();
		}
		$assoc_name_2 = $WikiAssoc->getPageName();
	break;

	case "docmanfile":
		$DocmanFile = DocmanFilePeer::retrieveByPk($vals[3]);
		if ($DocmanFile == null || !is_object($DocmanFile)) {
			throw new PermissionDeniedException();
		}
		$assoc_name_2 = $DocmanFile->getLatestVersion()->getFile()->getFileName();
	break;

	case "frsrelease":
		$FrsRelease = FrsReleasePeer::retrieveByPk($vals[3]);
		if ($FrsRelease == null || !is_object($FrsRelease)) {
			throw new PermissionDeniedException();
		}
		$assoc_name_2 = $FrsRelease->getReleaseName();
	break;
	case "forummessage":
		$ForumMessage = ForumMessagePeer::retrieveByPk($vals[3]);
		if ($ForumMessage == null || !is_object($ForumMessage)){
			throw new PermissionDeniexException();
		}
		$assoc_name_2 = $ForumMessage->getSubject();
	break;


	case "scmcommit":
		$assoc_name_2 = "Scm Commit #".$vals[3];
	break;	
}

if (!is_object($Association) || !$Association->userCanDelete()) {
	throw new PermissionDeniedException();
}

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Association.DeletePageTitle')
		);

$return_to=((isset($_POST['return_to'])) ? $_POST['return_to'] : $_GET['return_to']);
$return_to = preg_replace("/&feedback=.*$/", "", $return_to);


include('forms/AssociationDelete-tpl.php');

?>
