<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/CountryCode.php';
// (on-demand) include_once 'core/CountryCodePeer.php';
 

// (on-demand) include_once 'core/Language.php';
// (on-demand) include_once 'core/LanguagePeer.php';
 

// (on-demand) include_once 'core/Theme.php';
// (on-demand) include_once 'core/ThemePeer.php';

include_once 'core/UserPeer.php';

/**
 * Base class that represents a row from the 'user' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to User class. 
 * 
 * @package core 
 */
abstract class BaseUser extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var UserPeer
	 */
	protected static $peer;

	/**
	 * The value for the user_id field.
	 * @var int	  
	 */
	protected $user_id;	

	/**
	 * The value for the unix_name field.
	 * @var string	  
	 */
	protected $unix_name;	

	/**
	 * The value for the email field.
	 * @var string	  
	 */
	protected $email;	

	/**
	 * The value for the status field.
	 * @var int	  
	 */
	protected $status = 0;	

	/**
	 * The value for the password_md5 field.
	 * @var string	  
	 */
	protected $password_md5;	

	/**
	 * The value for the password_crypt field.
	 * @var string	  
	 */
	protected $password_crypt;	

	/**
	 * The value for the create_date field.
	 * @var int	  
	 */
	protected $create_date = -1;	

	/**
	 * The value for the confirm_hash field.
	 * @var string	  
	 */
	protected $confirm_hash;	

	/**
	 * The value for the email_new field.
	 * @var string	  
	 */
	protected $email_new;	

	/**
	 * The value for the timezone field.
	 * @var string	  
	 */
	protected $timezone;	

	/**
	 * The value for the date_format field.
	 * @var string	  
	 */
	protected $date_format;	

	/**
	 * The value for the address field.
	 * @var string	  
	 */
	protected $address;	

	/**
	 * The value for the address2 field.
	 * @var string	  
	 */
	protected $address2;	

	/**
	 * The value for the phone field.
	 * @var string	  
	 */
	protected $phone;	

	/**
	 * The value for the fax field.
	 * @var string	  
	 */
	protected $fax;	

	/**
	 * The value for the title field.
	 * @var string	  
	 */
	protected $title;	

	/**
	 * The value for the firstname field.
	 * @var string	  
	 */
	protected $firstname;	

	/**
	 * The value for the lastname field.
	 * @var string	  
	 */
	protected $lastname;	

	/**
	 * The value for the ccode field.
	 * @var string	  
	 */
	protected $ccode;	

	/**
	 * The value for the language_id field.
	 * @var int	  
	 */
	protected $language_id;	

	/**
	 * The value for the theme_id field.
	 * @var int	  
	 */
	protected $theme_id;	

	/**
	 * The value for the external_id field.
	 * @var string	  
	 */
	protected $external_id;	

	/**
	 * The value for the last_login field.
	 * @var int	  
	 */
	protected $last_login = -1;	

	/**
	 * The value for the user_text1 field.
	 * @var string	  
	 */
	protected $user_text1;	

	/**
	 * The value for the user_text2 field.
	 * @var string	  
	 */
	protected $user_text2;	

	/**
	 * The value for the user_text3 field.
	 * @var string	  
	 */
	protected $user_text3;	

	/**
	 * The value for the user_text4 field.
	 * @var string	  
	 */
	protected $user_text4;	

	/**
	 * The value for the user_text5 field.
	 * @var string	  
	 */
	protected $user_text5;	

	/**
	 * The value for the user_text6 field.
	 * @var string	  
	 */
	protected $user_text6;	

	/**
	 * The value for the is_group field.
	 * @var boolean	  
	 */
	protected $is_group;	

	/**
	 * The value for the password_change_date field.
	 * @var int	  
	 */
	protected $password_change_date = -1;	

	/**
	 * The value for the is_restricted field.
	 * @var boolean	  
	 */
	protected $is_restricted = false;	
  
	/**
	 * Get the UserId column value.
	 *  
	 * @return int	  
	 */
	public function getUserId()
	{
		return $this->user_id;
	}


	/**
	 * Set the value of `user_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setUserId($v)
	{
		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = UserPeer::USER_ID;
		}
			
		  // update associated AuditTrail		  
		  if ($this->collAuditTrails !== null) {
			  for ($i=0,$size=count($this->collAuditTrails); $i < $size; $i++) {
				  $this->collAuditTrails[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated Cruisecontrol		  
		  if ($this->collCruisecontrols !== null) {
			  for ($i=0,$size=count($this->collCruisecontrols); $i < $size; $i++) {
				  $this->collCruisecontrols[$i]->setSubmitterId($v);
			  }
		  }
			  	
		  // update associated CruisecontrolAssignee		  
		  if ($this->collCruisecontrolAssignees !== null) {
			  for ($i=0,$size=count($this->collCruisecontrolAssignees); $i < $size; $i++) {
				  $this->collCruisecontrolAssignees[$i]->setAssignee($v);
			  }
		  }
			  	
		  // update associated CruisecontrolBuildChangeUser		  
		  if ($this->collCruisecontrolBuildChangeUsers !== null) {
			  for ($i=0,$size=count($this->collCruisecontrolBuildChangeUsers); $i < $size; $i++) {
				  $this->collCruisecontrolBuildChangeUsers[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated DocmanFileVersion		  
		  if ($this->collDocmanFileVersions !== null) {
			  for ($i=0,$size=count($this->collDocmanFileVersions); $i < $size; $i++) {
				  $this->collDocmanFileVersions[$i]->setCreatedBy($v);
			  }
		  }
			  	
		  // update associated Filesystem		  
		  if ($this->collFilesystems !== null) {
			  for ($i=0,$size=count($this->collFilesystems); $i < $size; $i++) {
				  $this->collFilesystems[$i]->setPostedBy($v);
			  }
		  }
			  	
		  // update associated ForumMessage		  
		  if ($this->collForumMessages !== null) {
			  for ($i=0,$size=count($this->collForumMessages); $i < $size; $i++) {
				  $this->collForumMessages[$i]->setCreatedBy($v);
			  }
		  }
			  	
		  // update associated ForumThread		  
		  if ($this->collForumThreads !== null) {
			  for ($i=0,$size=count($this->collForumThreads); $i < $size; $i++) {
				  $this->collForumThreads[$i]->setCreatedBy($v);
			  }
		  }
			  	
		  // update associated FrsRelease		  
		  if ($this->collFrsReleases !== null) {
			  for ($i=0,$size=count($this->collFrsReleases); $i < $size; $i++) {
				  $this->collFrsReleases[$i]->setReleasedBy($v);
			  }
		  }
			  	
		  // update associated Mailman		  
		  if ($this->collMailmans !== null) {
			  for ($i=0,$size=count($this->collMailmans); $i < $size; $i++) {
				  $this->collMailmans[$i]->setCreatedBy($v);
			  }
		  }
			  	
		  // update associated Monitor		  
		  if ($this->collMonitors !== null) {
			  for ($i=0,$size=count($this->collMonitors); $i < $size; $i++) {
				  $this->collMonitors[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated News		  
		  if ($this->collNewss !== null) {
			  for ($i=0,$size=count($this->collNewss); $i < $size; $i++) {
				  $this->collNewss[$i]->setSubmittedBy($v);
			  }
		  }
			  	
		  // update associated NotificationQueue		  
		  if ($this->collNotificationQueues !== null) {
			  for ($i=0,$size=count($this->collNotificationQueues); $i < $size; $i++) {
				  $this->collNotificationQueues[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated ProjectJoinRequest		  
		  if ($this->collProjectJoinRequests !== null) {
			  for ($i=0,$size=count($this->collProjectJoinRequests); $i < $size; $i++) {
				  $this->collProjectJoinRequests[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated ScmModuleUser		  
		  if ($this->collScmModuleUsers !== null) {
			  for ($i=0,$size=count($this->collScmModuleUsers); $i < $size; $i++) {
				  $this->collScmModuleUsers[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated ScmCommit		  
		  if ($this->collScmCommits !== null) {
			  for ($i=0,$size=count($this->collScmCommits); $i < $size; $i++) {
				  $this->collScmCommits[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated JabberConnectedUser		  
		  if ($this->collJabberConnectedUsers !== null) {
			  for ($i=0,$size=count($this->collJabberConnectedUsers); $i < $size; $i++) {
				  $this->collJabberConnectedUsers[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated ScmUserStats		  
		  if ($this->collScmUserStatss !== null) {
			  for ($i=0,$size=count($this->collScmUserStatss); $i < $size; $i++) {
				  $this->collScmUserStatss[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated SiteAdmin		  
		  if ($this->collSiteAdmins !== null) {
			  for ($i=0,$size=count($this->collSiteAdmins); $i < $size; $i++) {
				  $this->collSiteAdmins[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated Snippet		  
		  if ($this->collSnippets !== null) {
			  for ($i=0,$size=count($this->collSnippets); $i < $size; $i++) {
				  $this->collSnippets[$i]->setCreatedBy($v);
			  }
		  }
			  	
		  // update associated SurveyResponse		  
		  if ($this->collSurveyResponses !== null) {
			  for ($i=0,$size=count($this->collSurveyResponses); $i < $size; $i++) {
				  $this->collSurveyResponses[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated TrackerItem		  
		  if ($this->collTrackerItems !== null) {
			  for ($i=0,$size=count($this->collTrackerItems); $i < $size; $i++) {
				  $this->collTrackerItems[$i]->setSubmittedBy($v);
			  }
		  }
			  	
		  // update associated TrackerMyQueue		  
		  if ($this->collTrackerMyQueues !== null) {
			  for ($i=0,$size=count($this->collTrackerMyQueues); $i < $size; $i++) {
				  $this->collTrackerMyQueues[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated TrackerItemAssignee		  
		  if ($this->collTrackerItemAssignees !== null) {
			  for ($i=0,$size=count($this->collTrackerItemAssignees); $i < $size; $i++) {
				  $this->collTrackerItemAssignees[$i]->setAssignee($v);
			  }
		  }
			  	
		  // update associated TrackerItemMessage		  
		  if ($this->collTrackerItemMessages !== null) {
			  for ($i=0,$size=count($this->collTrackerItemMessages); $i < $size; $i++) {
				  $this->collTrackerItemMessages[$i]->setSubmittedBy($v);
			  }
		  }
			  	
		  // update associated TrackerItemTime		  
		  if ($this->collTrackerItemTimes !== null) {
			  for ($i=0,$size=count($this->collTrackerItemTimes); $i < $size; $i++) {
				  $this->collTrackerItemTimes[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated TrackerQuery		  
		  if ($this->collTrackerQuerys !== null) {
			  for ($i=0,$size=count($this->collTrackerQuerys); $i < $size; $i++) {
				  $this->collTrackerQuerys[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated UserPlugin		  
		  if ($this->collUserPlugins !== null) {
			  for ($i=0,$size=count($this->collUserPlugins); $i < $size; $i++) {
				  $this->collUserPlugins[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated UserPreference		  
		  if ($this->collUserPreferences !== null) {
			  for ($i=0,$size=count($this->collUserPreferences); $i < $size; $i++) {
				  $this->collUserPreferences[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated UsergroupUser		  
		  if ($this->collUsergroupUsersRelatedByUsergroupId !== null) {
			  for ($i=0,$size=count($this->collUsergroupUsersRelatedByUsergroupId); $i < $size; $i++) {
				  $this->collUsergroupUsersRelatedByUsergroupId[$i]->setUsergroupId($v);
			  }
		  }
			  	
		  // update associated UsergroupUser		  
		  if ($this->collUsergroupUsersRelatedByMemberUserId !== null) {
			  for ($i=0,$size=count($this->collUsergroupUsersRelatedByMemberUserId); $i < $size; $i++) {
				  $this->collUsergroupUsersRelatedByMemberUserId[$i]->setMemberUserId($v);
			  }
		  }
			  	
		  // update associated UserProject		  
		  if ($this->collUserProjects !== null) {
			  for ($i=0,$size=count($this->collUserProjects); $i < $size; $i++) {
				  $this->collUserProjects[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated UserSession		  
		  if ($this->collUserSessions !== null) {
			  for ($i=0,$size=count($this->collUserSessions); $i < $size; $i++) {
				  $this->collUserSessions[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated UserUnix		  
		  if ($this->collUserUnixs !== null) {
			  for ($i=0,$size=count($this->collUserUnixs); $i < $size; $i++) {
				  $this->collUserUnixs[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated UserWatchedProject		  
		  if ($this->collUserWatchedProjects !== null) {
			  for ($i=0,$size=count($this->collUserWatchedProjects); $i < $size; $i++) {
				  $this->collUserWatchedProjects[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated WikiVersion		  
		  if ($this->collWikiVersions !== null) {
			  for ($i=0,$size=count($this->collWikiVersions); $i < $size; $i++) {
				  $this->collWikiVersions[$i]->setPostedBy($v);
			  }
		  }
			  	
		  // update associated MyReportUser		  
		  if ($this->collMyReportUsers !== null) {
			  for ($i=0,$size=count($this->collMyReportUsers); $i < $size; $i++) {
				  $this->collMyReportUsers[$i]->setUserId($v);
			  }
		  }
			  	
		  // update associated MyReport		  
		  if ($this->collMyReports !== null) {
			  for ($i=0,$size=count($this->collMyReports); $i < $size; $i++) {
				  $this->collMyReports[$i]->setUserId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the UnixName column value.
	 *  
	 * @return string	  
	 */
	public function getUnixName()
	{
		return $this->unix_name;
	}


	/**
	 * Set the value of `unix_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setUnixName($v)
	{
		if ($this->unix_name !== $v) {
			$this->unix_name = $v;
			$this->modifiedColumns[] = UserPeer::UNIX_NAME;
		}
				
	}

  
	/**
	 * Get the Email column value.
	 *  
	 * @return string	  
	 */
	public function getEmail()
	{
		return $this->email;
	}


	/**
	 * Set the value of `email` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setEmail($v)
	{
		if ($this->email !== $v) {
			$this->email = $v;
			$this->modifiedColumns[] = UserPeer::EMAIL;
		}
				
	}

  
	/**
	 * Get the Status column value.
	 *  
	 * @return int	  
	 */
	public function getStatus()
	{
		return $this->status;
	}


	/**
	 * Set the value of `status` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setStatus($v)
	{
		if ($this->status !== $v || $v === 0) {
			$this->status = $v;
			$this->modifiedColumns[] = UserPeer::STATUS;
		}
				
	}

  
	/**
	 * Get the PasswordMd5 column value.
	 *  
	 * @return string	  
	 */
	public function getPasswordMd5()
	{
		return $this->password_md5;
	}


	/**
	 * Set the value of `password_md5` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setPasswordMd5($v)
	{
		if ($this->password_md5 !== $v) {
			$this->password_md5 = $v;
			$this->modifiedColumns[] = UserPeer::PASSWORD_MD5;
		}
				
	}

  
	/**
	 * Get the PasswordCrypt column value.
	 *  
	 * @return string	  
	 */
	public function getPasswordCrypt()
	{
		return $this->password_crypt;
	}


	/**
	 * Set the value of `password_crypt` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setPasswordCrypt($v)
	{
		if ($this->password_crypt !== $v) {
			$this->password_crypt = $v;
			$this->modifiedColumns[] = UserPeer::PASSWORD_CRYPT;
		}
				
	}


	/**
	 * Get the [optionally formatted] `create_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCreateDate($format = 'Y-m-d H:i:s')
	{
		if ($this->create_date === null || $this->create_date === '') {
			return null;
		} elseif (!is_int($this->create_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->create_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of create_date as date/time value: " . var_export($this->create_date, true));
			}
		} else {
			$ts = $this->create_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `create_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setCreateDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for create_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->create_date !== $ts || $ts === -1) {
			$this->create_date = $ts;
			$this->modifiedColumns[] = UserPeer::CREATE_DATE;
		}
		
	}

  
	/**
	 * Get the ConfirmHash column value.
	 *  
	 * @return string	  
	 */
	public function getConfirmHash()
	{
		return $this->confirm_hash;
	}


	/**
	 * Set the value of `confirm_hash` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setConfirmHash($v)
	{
		if ($this->confirm_hash !== $v) {
			$this->confirm_hash = $v;
			$this->modifiedColumns[] = UserPeer::CONFIRM_HASH;
		}
				
	}

  
	/**
	 * Get the EmailNew column value.
	 *  
	 * @return string	  
	 */
	public function getEmailNew()
	{
		return $this->email_new;
	}


	/**
	 * Set the value of `email_new` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setEmailNew($v)
	{
		if ($this->email_new !== $v) {
			$this->email_new = $v;
			$this->modifiedColumns[] = UserPeer::EMAIL_NEW;
		}
				
	}

  
	/**
	 * Get the Timezone column value.
	 *  
	 * @return string	  
	 */
	public function getTimezone()
	{
		return $this->timezone;
	}


	/**
	 * Set the value of `timezone` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setTimezone($v)
	{
		if ($this->timezone !== $v) {
			$this->timezone = $v;
			$this->modifiedColumns[] = UserPeer::TIMEZONE;
		}
				
	}

  
	/**
	 * Get the DateFormat column value.
	 *  
	 * @return string	  
	 */
	public function getDateFormat()
	{
		return $this->date_format;
	}


	/**
	 * Set the value of `date_format` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDateFormat($v)
	{
		if ($this->date_format !== $v) {
			$this->date_format = $v;
			$this->modifiedColumns[] = UserPeer::DATE_FORMAT;
		}
				
	}

  
	/**
	 * Get the Address column value.
	 *  
	 * @return string	  
	 */
	public function getAddress()
	{
		return $this->address;
	}


	/**
	 * Set the value of `address` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setAddress($v)
	{
		if ($this->address !== $v) {
			$this->address = $v;
			$this->modifiedColumns[] = UserPeer::ADDRESS;
		}
				
	}

  
	/**
	 * Get the Address2 column value.
	 *  
	 * @return string	  
	 */
	public function getAddress2()
	{
		return $this->address2;
	}


	/**
	 * Set the value of `address2` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setAddress2($v)
	{
		if ($this->address2 !== $v) {
			$this->address2 = $v;
			$this->modifiedColumns[] = UserPeer::ADDRESS2;
		}
				
	}

  
	/**
	 * Get the Phone column value.
	 *  
	 * @return string	  
	 */
	public function getPhone()
	{
		return $this->phone;
	}


	/**
	 * Set the value of `phone` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setPhone($v)
	{
		if ($this->phone !== $v) {
			$this->phone = $v;
			$this->modifiedColumns[] = UserPeer::PHONE;
		}
				
	}

  
	/**
	 * Get the Fax column value.
	 *  
	 * @return string	  
	 */
	public function getFax()
	{
		return $this->fax;
	}


	/**
	 * Set the value of `fax` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFax($v)
	{
		if ($this->fax !== $v) {
			$this->fax = $v;
			$this->modifiedColumns[] = UserPeer::FAX;
		}
				
	}

  
	/**
	 * Get the Title column value.
	 *  
	 * @return string	  
	 */
	public function getTitle()
	{
		return $this->title;
	}


	/**
	 * Set the value of `title` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setTitle($v)
	{
		if ($this->title !== $v) {
			$this->title = $v;
			$this->modifiedColumns[] = UserPeer::TITLE;
		}
				
	}

  
	/**
	 * Get the Firstname column value.
	 *  
	 * @return string	  
	 */
	public function getFirstname()
	{
		return $this->firstname;
	}


	/**
	 * Set the value of `firstname` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFirstname($v)
	{
		if ($this->firstname !== $v) {
			$this->firstname = $v;
			$this->modifiedColumns[] = UserPeer::FIRSTNAME;
		}
				
	}

  
	/**
	 * Get the Lastname column value.
	 *  
	 * @return string	  
	 */
	public function getLastname()
	{
		return $this->lastname;
	}


	/**
	 * Set the value of `lastname` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setLastname($v)
	{
		if ($this->lastname !== $v) {
			$this->lastname = $v;
			$this->modifiedColumns[] = UserPeer::LASTNAME;
		}
				
	}

  
	/**
	 * Get the Ccode column value.
	 *  
	 * @return string	  
	 */
	public function getCcode()
	{
		return $this->ccode;
	}


	/**
	 * Set the value of `ccode` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCcode($v)
	{
		if ($this->ccode !== $v) {
			$this->ccode = $v;
			$this->modifiedColumns[] = UserPeer::CCODE;
		}
			
		if ($this->aCountryCode !== null && $this->aCountryCode->getCcode() !== $v) {
			$this->aCountryCode = null;
		}
			
	}

  
	/**
	 * Get the LanguageId column value.
	 *  
	 * @return int	  
	 */
	public function getLanguageId()
	{
		return $this->language_id;
	}


	/**
	 * Set the value of `language_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setLanguageId($v)
	{
		if ($this->language_id !== $v) {
			$this->language_id = $v;
			$this->modifiedColumns[] = UserPeer::LANGUAGE_ID;
		}
			
		if ($this->aLanguage !== null && $this->aLanguage->getLanguageId() !== $v) {
			$this->aLanguage = null;
		}
			
	}

  
	/**
	 * Get the ThemeId column value.
	 *  
	 * @return int	  
	 */
	public function getThemeId()
	{
		return $this->theme_id;
	}


	/**
	 * Set the value of `theme_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setThemeId($v)
	{
		if ($this->theme_id !== $v) {
			$this->theme_id = $v;
			$this->modifiedColumns[] = UserPeer::THEME_ID;
		}
			
		if ($this->aTheme !== null && $this->aTheme->getThemeId() !== $v) {
			$this->aTheme = null;
		}
			
	}

  
	/**
	 * Get the ExternalId column value.
	 *  
	 * @return string	  
	 */
	public function getExternalId()
	{
		return $this->external_id;
	}


	/**
	 * Set the value of `external_id` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setExternalId($v)
	{
		if ($this->external_id !== $v) {
			$this->external_id = $v;
			$this->modifiedColumns[] = UserPeer::EXTERNAL_ID;
		}
				
	}


	/**
	 * Get the [optionally formatted] `last_login` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getLastLogin($format = 'Y-m-d H:i:s')
	{
		if ($this->last_login === null || $this->last_login === '') {
			return null;
		} elseif (!is_int($this->last_login)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->last_login);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of last_login as date/time value: " . var_export($this->last_login, true));
			}
		} else {
			$ts = $this->last_login;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `last_login` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setLastLogin($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for last_login from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->last_login !== $ts || $ts === -1) {
			$this->last_login = $ts;
			$this->modifiedColumns[] = UserPeer::LAST_LOGIN;
		}
		
	}

  
	/**
	 * Get the UserText1 column value.
	 *  
	 * @return string	  
	 */
	public function getUserText1()
	{
		return $this->user_text1;
	}


	/**
	 * Set the value of `user_text1` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setUserText1($v)
	{
		if ($this->user_text1 !== $v) {
			$this->user_text1 = $v;
			$this->modifiedColumns[] = UserPeer::USER_TEXT1;
		}
				
	}

  
	/**
	 * Get the UserText2 column value.
	 *  
	 * @return string	  
	 */
	public function getUserText2()
	{
		return $this->user_text2;
	}


	/**
	 * Set the value of `user_text2` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setUserText2($v)
	{
		if ($this->user_text2 !== $v) {
			$this->user_text2 = $v;
			$this->modifiedColumns[] = UserPeer::USER_TEXT2;
		}
				
	}

  
	/**
	 * Get the UserText3 column value.
	 *  
	 * @return string	  
	 */
	public function getUserText3()
	{
		return $this->user_text3;
	}


	/**
	 * Set the value of `user_text3` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setUserText3($v)
	{
		if ($this->user_text3 !== $v) {
			$this->user_text3 = $v;
			$this->modifiedColumns[] = UserPeer::USER_TEXT3;
		}
				
	}

  
	/**
	 * Get the UserText4 column value.
	 *  
	 * @return string	  
	 */
	public function getUserText4()
	{
		return $this->user_text4;
	}


	/**
	 * Set the value of `user_text4` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setUserText4($v)
	{
		if ($this->user_text4 !== $v) {
			$this->user_text4 = $v;
			$this->modifiedColumns[] = UserPeer::USER_TEXT4;
		}
				
	}

  
	/**
	 * Get the UserText5 column value.
	 *  
	 * @return string	  
	 */
	public function getUserText5()
	{
		return $this->user_text5;
	}


	/**
	 * Set the value of `user_text5` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setUserText5($v)
	{
		if ($this->user_text5 !== $v) {
			$this->user_text5 = $v;
			$this->modifiedColumns[] = UserPeer::USER_TEXT5;
		}
				
	}

  
	/**
	 * Get the UserText6 column value.
	 *  
	 * @return string	  
	 */
	public function getUserText6()
	{
		return $this->user_text6;
	}


	/**
	 * Set the value of `user_text6` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setUserText6($v)
	{
		if ($this->user_text6 !== $v) {
			$this->user_text6 = $v;
			$this->modifiedColumns[] = UserPeer::USER_TEXT6;
		}
				
	}

  
	/**
	 * Get the IsGroup column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsGroup()
	{
		return $this->is_group;
	}


	/**
	 * Set the value of `is_group` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsGroup($v)
	{
		if ($this->is_group !== $v) {
			$this->is_group = $v;
			$this->modifiedColumns[] = UserPeer::IS_GROUP;
		}
				
	}


	/**
	 * Get the [optionally formatted] `password_change_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getPasswordChangeDate($format = 'Y-m-d H:i:s')
	{
		if ($this->password_change_date === null || $this->password_change_date === '') {
			return null;
		} elseif (!is_int($this->password_change_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->password_change_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of password_change_date as date/time value: " . var_export($this->password_change_date, true));
			}
		} else {
			$ts = $this->password_change_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `password_change_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setPasswordChangeDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for password_change_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->password_change_date !== $ts || $ts === -1) {
			$this->password_change_date = $ts;
			$this->modifiedColumns[] = UserPeer::PASSWORD_CHANGE_DATE;
		}
		
	}

  
	/**
	 * Get the IsRestricted column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsRestricted()
	{
		return $this->is_restricted;
	}


	/**
	 * Set the value of `is_restricted` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsRestricted($v)
	{
		if ($this->is_restricted !== $v || $v === false) {
			$this->is_restricted = $v;
			$this->modifiedColumns[] = UserPeer::IS_RESTRICTED;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->user_id = $rs->getInt($startcol + 0);					
			$this->unix_name = $rs->getString($startcol + 1);					
			$this->email = $rs->getString($startcol + 2);					
			$this->status = $rs->getInt($startcol + 3);					
			$this->password_md5 = $rs->getString($startcol + 4);					
			$this->password_crypt = $rs->getString($startcol + 5);					
			$this->create_date = $rs->getTimestamp($startcol + 6, null);
			$this->confirm_hash = $rs->getString($startcol + 7);					
			$this->email_new = $rs->getString($startcol + 8);					
			$this->timezone = $rs->getString($startcol + 9);					
			$this->date_format = $rs->getString($startcol + 10);					
			$this->address = $rs->getString($startcol + 11);					
			$this->address2 = $rs->getString($startcol + 12);					
			$this->phone = $rs->getString($startcol + 13);					
			$this->fax = $rs->getString($startcol + 14);					
			$this->title = $rs->getString($startcol + 15);					
			$this->firstname = $rs->getString($startcol + 16);					
			$this->lastname = $rs->getString($startcol + 17);					
			$this->ccode = $rs->getString($startcol + 18);					
			$this->language_id = $rs->getInt($startcol + 19);					
			$this->theme_id = $rs->getInt($startcol + 20);					
			$this->external_id = $rs->getString($startcol + 21);					
			$this->last_login = $rs->getTimestamp($startcol + 22, null);
			$this->user_text1 = $rs->getString($startcol + 23);					
			$this->user_text2 = $rs->getString($startcol + 24);					
			$this->user_text3 = $rs->getString($startcol + 25);					
			$this->user_text4 = $rs->getString($startcol + 26);					
			$this->user_text5 = $rs->getString($startcol + 27);					
			$this->user_text6 = $rs->getString($startcol + 28);					
			$this->is_group = $rs->getBoolean($startcol + 29);					
			$this->password_change_date = $rs->getTimestamp($startcol + 30, null);
			$this->is_restricted = $rs->getBoolean($startcol + 31);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating User object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(UserPeer::DATABASE_NAME);
		$criteria->add(UserPeer::USER_ID, $this->user_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(UserPeer::DATABASE_NAME);
		if ($this->isColumnModified(UserPeer::USER_ID)) $criteria->add(UserPeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(UserPeer::UNIX_NAME)) $criteria->add(UserPeer::UNIX_NAME, $this->unix_name);
		if ($this->isColumnModified(UserPeer::EMAIL)) $criteria->add(UserPeer::EMAIL, $this->email);
		if ($this->isColumnModified(UserPeer::STATUS)) $criteria->add(UserPeer::STATUS, $this->status);
		if ($this->isColumnModified(UserPeer::PASSWORD_MD5)) $criteria->add(UserPeer::PASSWORD_MD5, $this->password_md5);
		if ($this->isColumnModified(UserPeer::PASSWORD_CRYPT)) $criteria->add(UserPeer::PASSWORD_CRYPT, $this->password_crypt);
		if ($this->isColumnModified(UserPeer::CREATE_DATE)) $criteria->add(UserPeer::CREATE_DATE, $this->create_date);
		if ($this->isColumnModified(UserPeer::CONFIRM_HASH)) $criteria->add(UserPeer::CONFIRM_HASH, $this->confirm_hash);
		if ($this->isColumnModified(UserPeer::EMAIL_NEW)) $criteria->add(UserPeer::EMAIL_NEW, $this->email_new);
		if ($this->isColumnModified(UserPeer::TIMEZONE)) $criteria->add(UserPeer::TIMEZONE, $this->timezone);
		if ($this->isColumnModified(UserPeer::DATE_FORMAT)) $criteria->add(UserPeer::DATE_FORMAT, $this->date_format);
		if ($this->isColumnModified(UserPeer::ADDRESS)) $criteria->add(UserPeer::ADDRESS, $this->address);
		if ($this->isColumnModified(UserPeer::ADDRESS2)) $criteria->add(UserPeer::ADDRESS2, $this->address2);
		if ($this->isColumnModified(UserPeer::PHONE)) $criteria->add(UserPeer::PHONE, $this->phone);
		if ($this->isColumnModified(UserPeer::FAX)) $criteria->add(UserPeer::FAX, $this->fax);
		if ($this->isColumnModified(UserPeer::TITLE)) $criteria->add(UserPeer::TITLE, $this->title);
		if ($this->isColumnModified(UserPeer::FIRSTNAME)) $criteria->add(UserPeer::FIRSTNAME, $this->firstname);
		if ($this->isColumnModified(UserPeer::LASTNAME)) $criteria->add(UserPeer::LASTNAME, $this->lastname);
		if ($this->isColumnModified(UserPeer::CCODE)) $criteria->add(UserPeer::CCODE, $this->ccode);
		if ($this->isColumnModified(UserPeer::LANGUAGE_ID)) $criteria->add(UserPeer::LANGUAGE_ID, $this->language_id);
		if ($this->isColumnModified(UserPeer::THEME_ID)) $criteria->add(UserPeer::THEME_ID, $this->theme_id);
		if ($this->isColumnModified(UserPeer::EXTERNAL_ID)) $criteria->add(UserPeer::EXTERNAL_ID, $this->external_id);
		if ($this->isColumnModified(UserPeer::LAST_LOGIN)) $criteria->add(UserPeer::LAST_LOGIN, $this->last_login);
		if ($this->isColumnModified(UserPeer::USER_TEXT1)) $criteria->add(UserPeer::USER_TEXT1, $this->user_text1);
		if ($this->isColumnModified(UserPeer::USER_TEXT2)) $criteria->add(UserPeer::USER_TEXT2, $this->user_text2);
		if ($this->isColumnModified(UserPeer::USER_TEXT3)) $criteria->add(UserPeer::USER_TEXT3, $this->user_text3);
		if ($this->isColumnModified(UserPeer::USER_TEXT4)) $criteria->add(UserPeer::USER_TEXT4, $this->user_text4);
		if ($this->isColumnModified(UserPeer::USER_TEXT5)) $criteria->add(UserPeer::USER_TEXT5, $this->user_text5);
		if ($this->isColumnModified(UserPeer::USER_TEXT6)) $criteria->add(UserPeer::USER_TEXT6, $this->user_text6);
		if ($this->isColumnModified(UserPeer::IS_GROUP)) $criteria->add(UserPeer::IS_GROUP, $this->is_group);
		if ($this->isColumnModified(UserPeer::PASSWORD_CHANGE_DATE)) $criteria->add(UserPeer::PASSWORD_CHANGE_DATE, $this->password_change_date);
		if ($this->isColumnModified(UserPeer::IS_RESTRICTED)) $criteria->add(UserPeer::IS_RESTRICTED, $this->is_restricted);
		return $criteria;			
	}
	
	

	/**
	 * @var CountryCode	  
	 */
	protected $aCountryCode;

	/**
	 * Declares an association between this object and a CountryCode object
	 *
	 * @param CountryCode $v
	 * @return void
	 * @throws PropelException
	 */
	public function setCountryCode($v)
	{
			
		if ($v === null) {
			$this->setCcode(NULL);
		} else {
			$this->setCcode($v->getCcode());
		}
   
		$this->aCountryCode = $v;
	}


	/**
	 * Get the associated CountryCode object
	 *
	 * @param Connection Optional Connection object.
	 * @return CountryCode The associated CountryCode object.
	 * @throws PropelException
	 */
	public function getCountryCode($con = null)
	{
		// include the Peer class
		include_once 'core/CountryCodePeer.php';

		if ($this->aCountryCode === null && (($this->ccode !== "" && $this->ccode !== null))) {
	
			$this->aCountryCode = CountryCodePeer::retrieveByPK($this->ccode, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = CountryCodePeer::retrieveByPK($this->ccode, $con);
			   $obj->addUsers($this);
			 */
		}
		return $this->aCountryCode;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setCountryCodeKey($key)
	{

		$this->setCcode( (string) $key);			
		
	}

	/**
	 * @var Language	  
	 */
	protected $aLanguage;

	/**
	 * Declares an association between this object and a Language object
	 *
	 * @param Language $v
	 * @return void
	 * @throws PropelException
	 */
	public function setLanguage($v)
	{
			
		if ($v === null) {
			$this->setLanguageId(NULL);
		} else {
			$this->setLanguageId($v->getLanguageId());
		}
   
		$this->aLanguage = $v;
	}


	/**
	 * Get the associated Language object
	 *
	 * @param Connection Optional Connection object.
	 * @return Language The associated Language object.
	 * @throws PropelException
	 */
	public function getLanguage($con = null)
	{
		// include the Peer class
		include_once 'core/LanguagePeer.php';

		if ($this->aLanguage === null && ($this->language_id !== null)) {
	
			$this->aLanguage = LanguagePeer::retrieveByPK($this->language_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = LanguagePeer::retrieveByPK($this->language_id, $con);
			   $obj->addUsers($this);
			 */
		}
		return $this->aLanguage;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setLanguageKey($key)
	{

		$this->setLanguageId( (int) $key);			
		
	}

	/**
	 * @var Theme	  
	 */
	protected $aTheme;

	/**
	 * Declares an association between this object and a Theme object
	 *
	 * @param Theme $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTheme($v)
	{
			
		if ($v === null) {
			$this->setThemeId(NULL);
		} else {
			$this->setThemeId($v->getThemeId());
		}
   
		$this->aTheme = $v;
	}


	/**
	 * Get the associated Theme object
	 *
	 * @param Connection Optional Connection object.
	 * @return Theme The associated Theme object.
	 * @throws PropelException
	 */
	public function getTheme($con = null)
	{
		// include the Peer class
		include_once 'core/ThemePeer.php';

		if ($this->aTheme === null && ($this->theme_id !== null)) {
	
			$this->aTheme = ThemePeer::retrieveByPK($this->theme_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ThemePeer::retrieveByPK($this->theme_id, $con);
			   $obj->addUsers($this);
			 */
		}
		return $this->aTheme;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setThemeKey($key)
	{

		$this->setThemeId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collAuditTrails	  
	 * @var array
	 */
	protected $collAuditTrails; 

	/**
	 * Temporary storage of collAuditTrails to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initAuditTrails()
	{
		if ($this->collAuditTrails === null) {
			$this->collAuditTrails = array();
		}
	}

	/**
	 * Method called to associate a AuditTrail object to this object
	 * through the AuditTrail foreign key attribute
	 *
	 * @param AuditTrail $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addAuditTrail(AuditTrail $l)
	{
		$this->collAuditTrails[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collAuditTrails.
	 * @var Criteria
	 */
	private $lastAuditTrailsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related AuditTrails from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getAuditTrails($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/AuditTrailPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collAuditTrails === null) {
			if ($this->isNew()) {
			   $this->collAuditTrails = array();
			} else {
	
				$criteria->add(AuditTrailPeer::USER_ID, $this->getUserId() );

				$this->collAuditTrails = AuditTrailPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(AuditTrailPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastAuditTrailsCriteria) || !$this->lastAuditTrailsCriteria->equals($criteria)) {
					$this->collAuditTrails = AuditTrailPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastAuditTrailsCriteria = $criteria;

		return $this->collAuditTrails;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related AuditTrails from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getAuditTrailsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/AuditTrailPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collAuditTrails === null) {
			if ($this->isNew()) {
			   $this->collAuditTrails = array();
			} else {
	   
				$criteria->add(AuditTrailPeer::USER_ID, $this->getUserId());
				$this->collAuditTrails = AuditTrailPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(AuditTrailPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastAuditTrailsCriteria) || !$this->lastAuditTrailsCriteria->equals($criteria)) {
				$this->collAuditTrails = AuditTrailPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastAuditTrailsCriteria = $criteria;

		return $this->collAuditTrails;
	}

	/**
	 * Collection to store aggregation of collCruisecontrols	  
	 * @var array
	 */
	protected $collCruisecontrols; 

	/**
	 * Temporary storage of collCruisecontrols to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCruisecontrols()
	{
		if ($this->collCruisecontrols === null) {
			$this->collCruisecontrols = array();
		}
	}

	/**
	 * Method called to associate a Cruisecontrol object to this object
	 * through the Cruisecontrol foreign key attribute
	 *
	 * @param Cruisecontrol $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCruisecontrol(Cruisecontrol $l)
	{
		$this->collCruisecontrols[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collCruisecontrols.
	 * @var Criteria
	 */
	private $lastCruisecontrolsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related Cruisecontrols from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCruisecontrols($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCruisecontrols === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrols = array();
			} else {
	
				$criteria->add(CruisecontrolPeer::SUBMITTER_ID, $this->getUserId() );

				$this->collCruisecontrols = CruisecontrolPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CruisecontrolPeer::SUBMITTER_ID, $this->getUserId());

				if (!isset($this->lastCruisecontrolsCriteria) || !$this->lastCruisecontrolsCriteria->equals($criteria)) {
					$this->collCruisecontrols = CruisecontrolPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCruisecontrolsCriteria = $criteria;

		return $this->collCruisecontrols;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Cruisecontrols from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getCruisecontrolsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrols === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrols = array();
			} else {
	   
				$criteria->add(CruisecontrolPeer::SUBMITTER_ID, $this->getUserId());
				$this->collCruisecontrols = CruisecontrolPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolPeer::SUBMITTER_ID, $this->getUserId());
			if (!isset($this->lastCruisecontrolsCriteria) || !$this->lastCruisecontrolsCriteria->equals($criteria)) {
				$this->collCruisecontrols = CruisecontrolPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastCruisecontrolsCriteria = $criteria;

		return $this->collCruisecontrols;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Cruisecontrols from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getCruisecontrolsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrols === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrols = array();
			} else {
	   
				$criteria->add(CruisecontrolPeer::SUBMITTER_ID, $this->getUserId());
				$this->collCruisecontrols = CruisecontrolPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolPeer::SUBMITTER_ID, $this->getUserId());
			if (!isset($this->lastCruisecontrolsCriteria) || !$this->lastCruisecontrolsCriteria->equals($criteria)) {
				$this->collCruisecontrols = CruisecontrolPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastCruisecontrolsCriteria = $criteria;

		return $this->collCruisecontrols;
	}

	/**
	 * Collection to store aggregation of collCruisecontrolAssignees	  
	 * @var array
	 */
	protected $collCruisecontrolAssignees; 

	/**
	 * Temporary storage of collCruisecontrolAssignees to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCruisecontrolAssignees()
	{
		if ($this->collCruisecontrolAssignees === null) {
			$this->collCruisecontrolAssignees = array();
		}
	}

	/**
	 * Method called to associate a CruisecontrolAssignee object to this object
	 * through the CruisecontrolAssignee foreign key attribute
	 *
	 * @param CruisecontrolAssignee $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCruisecontrolAssignee(CruisecontrolAssignee $l)
	{
		$this->collCruisecontrolAssignees[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collCruisecontrolAssignees.
	 * @var Criteria
	 */
	private $lastCruisecontrolAssigneesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related CruisecontrolAssignees from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCruisecontrolAssignees($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolAssigneePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCruisecontrolAssignees === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolAssignees = array();
			} else {
	
				$criteria->add(CruisecontrolAssigneePeer::ASSIGNEE, $this->getUserId() );

				$this->collCruisecontrolAssignees = CruisecontrolAssigneePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CruisecontrolAssigneePeer::ASSIGNEE, $this->getUserId());

				if (!isset($this->lastCruisecontrolAssigneesCriteria) || !$this->lastCruisecontrolAssigneesCriteria->equals($criteria)) {
					$this->collCruisecontrolAssignees = CruisecontrolAssigneePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCruisecontrolAssigneesCriteria = $criteria;

		return $this->collCruisecontrolAssignees;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related CruisecontrolAssignees from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getCruisecontrolAssigneesJoinCruisecontrol($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolAssigneePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolAssignees === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolAssignees = array();
			} else {
	   
				$criteria->add(CruisecontrolAssigneePeer::ASSIGNEE, $this->getUserId());
				$this->collCruisecontrolAssignees = CruisecontrolAssigneePeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolAssigneePeer::ASSIGNEE, $this->getUserId());
			if (!isset($this->lastCruisecontrolAssigneesCriteria) || !$this->lastCruisecontrolAssigneesCriteria->equals($criteria)) {
				$this->collCruisecontrolAssignees = CruisecontrolAssigneePeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		}
		$this->lastCruisecontrolAssigneesCriteria = $criteria;

		return $this->collCruisecontrolAssignees;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related CruisecontrolAssignees from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getCruisecontrolAssigneesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolAssigneePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolAssignees === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolAssignees = array();
			} else {
	   
				$criteria->add(CruisecontrolAssigneePeer::ASSIGNEE, $this->getUserId());
				$this->collCruisecontrolAssignees = CruisecontrolAssigneePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolAssigneePeer::ASSIGNEE, $this->getUserId());
			if (!isset($this->lastCruisecontrolAssigneesCriteria) || !$this->lastCruisecontrolAssigneesCriteria->equals($criteria)) {
				$this->collCruisecontrolAssignees = CruisecontrolAssigneePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastCruisecontrolAssigneesCriteria = $criteria;

		return $this->collCruisecontrolAssignees;
	}

	/**
	 * Collection to store aggregation of collCruisecontrolBuildChangeUsers	  
	 * @var array
	 */
	protected $collCruisecontrolBuildChangeUsers; 

	/**
	 * Temporary storage of collCruisecontrolBuildChangeUsers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCruisecontrolBuildChangeUsers()
	{
		if ($this->collCruisecontrolBuildChangeUsers === null) {
			$this->collCruisecontrolBuildChangeUsers = array();
		}
	}

	/**
	 * Method called to associate a CruisecontrolBuildChangeUser object to this object
	 * through the CruisecontrolBuildChangeUser foreign key attribute
	 *
	 * @param CruisecontrolBuildChangeUser $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCruisecontrolBuildChangeUser(CruisecontrolBuildChangeUser $l)
	{
		$this->collCruisecontrolBuildChangeUsers[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collCruisecontrolBuildChangeUsers.
	 * @var Criteria
	 */
	private $lastCruisecontrolBuildChangeUsersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related CruisecontrolBuildChangeUsers from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCruisecontrolBuildChangeUsers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolBuildChangeUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCruisecontrolBuildChangeUsers === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolBuildChangeUsers = array();
			} else {
	
				$criteria->add(CruisecontrolBuildChangeUserPeer::USER_ID, $this->getUserId() );

				$this->collCruisecontrolBuildChangeUsers = CruisecontrolBuildChangeUserPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CruisecontrolBuildChangeUserPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastCruisecontrolBuildChangeUsersCriteria) || !$this->lastCruisecontrolBuildChangeUsersCriteria->equals($criteria)) {
					$this->collCruisecontrolBuildChangeUsers = CruisecontrolBuildChangeUserPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCruisecontrolBuildChangeUsersCriteria = $criteria;

		return $this->collCruisecontrolBuildChangeUsers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related CruisecontrolBuildChangeUsers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getCruisecontrolBuildChangeUsersJoinCruisecontrolBuild($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolBuildChangeUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolBuildChangeUsers === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolBuildChangeUsers = array();
			} else {
	   
				$criteria->add(CruisecontrolBuildChangeUserPeer::USER_ID, $this->getUserId());
				$this->collCruisecontrolBuildChangeUsers = CruisecontrolBuildChangeUserPeer::doSelectJoinCruisecontrolBuild($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolBuildChangeUserPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastCruisecontrolBuildChangeUsersCriteria) || !$this->lastCruisecontrolBuildChangeUsersCriteria->equals($criteria)) {
				$this->collCruisecontrolBuildChangeUsers = CruisecontrolBuildChangeUserPeer::doSelectJoinCruisecontrolBuild($criteria, $con);
			}
		}
		$this->lastCruisecontrolBuildChangeUsersCriteria = $criteria;

		return $this->collCruisecontrolBuildChangeUsers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related CruisecontrolBuildChangeUsers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getCruisecontrolBuildChangeUsersJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolBuildChangeUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolBuildChangeUsers === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolBuildChangeUsers = array();
			} else {
	   
				$criteria->add(CruisecontrolBuildChangeUserPeer::USER_ID, $this->getUserId());
				$this->collCruisecontrolBuildChangeUsers = CruisecontrolBuildChangeUserPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolBuildChangeUserPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastCruisecontrolBuildChangeUsersCriteria) || !$this->lastCruisecontrolBuildChangeUsersCriteria->equals($criteria)) {
				$this->collCruisecontrolBuildChangeUsers = CruisecontrolBuildChangeUserPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastCruisecontrolBuildChangeUsersCriteria = $criteria;

		return $this->collCruisecontrolBuildChangeUsers;
	}

	/**
	 * Collection to store aggregation of collDocmanFileVersions	  
	 * @var array
	 */
	protected $collDocmanFileVersions; 

	/**
	 * Temporary storage of collDocmanFileVersions to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initDocmanFileVersions()
	{
		if ($this->collDocmanFileVersions === null) {
			$this->collDocmanFileVersions = array();
		}
	}

	/**
	 * Method called to associate a DocmanFileVersion object to this object
	 * through the DocmanFileVersion foreign key attribute
	 *
	 * @param DocmanFileVersion $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addDocmanFileVersion(DocmanFileVersion $l)
	{
		$this->collDocmanFileVersions[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collDocmanFileVersions.
	 * @var Criteria
	 */
	private $lastDocmanFileVersionsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related DocmanFileVersions from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getDocmanFileVersions($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFileVersionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collDocmanFileVersions === null) {
			if ($this->isNew()) {
			   $this->collDocmanFileVersions = array();
			} else {
	
				$criteria->add(DocmanFileVersionPeer::CREATED_BY, $this->getUserId() );

				$this->collDocmanFileVersions = DocmanFileVersionPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(DocmanFileVersionPeer::CREATED_BY, $this->getUserId());

				if (!isset($this->lastDocmanFileVersionsCriteria) || !$this->lastDocmanFileVersionsCriteria->equals($criteria)) {
					$this->collDocmanFileVersions = DocmanFileVersionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDocmanFileVersionsCriteria = $criteria;

		return $this->collDocmanFileVersions;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related DocmanFileVersions from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getDocmanFileVersionsJoinDocmanFile($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFileVersionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collDocmanFileVersions === null) {
			if ($this->isNew()) {
			   $this->collDocmanFileVersions = array();
			} else {
	   
				$criteria->add(DocmanFileVersionPeer::CREATED_BY, $this->getUserId());
				$this->collDocmanFileVersions = DocmanFileVersionPeer::doSelectJoinDocmanFile($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(DocmanFileVersionPeer::CREATED_BY, $this->getUserId());
			if (!isset($this->lastDocmanFileVersionsCriteria) || !$this->lastDocmanFileVersionsCriteria->equals($criteria)) {
				$this->collDocmanFileVersions = DocmanFileVersionPeer::doSelectJoinDocmanFile($criteria, $con);
			}
		}
		$this->lastDocmanFileVersionsCriteria = $criteria;

		return $this->collDocmanFileVersions;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related DocmanFileVersions from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getDocmanFileVersionsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFileVersionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collDocmanFileVersions === null) {
			if ($this->isNew()) {
			   $this->collDocmanFileVersions = array();
			} else {
	   
				$criteria->add(DocmanFileVersionPeer::CREATED_BY, $this->getUserId());
				$this->collDocmanFileVersions = DocmanFileVersionPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(DocmanFileVersionPeer::CREATED_BY, $this->getUserId());
			if (!isset($this->lastDocmanFileVersionsCriteria) || !$this->lastDocmanFileVersionsCriteria->equals($criteria)) {
				$this->collDocmanFileVersions = DocmanFileVersionPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastDocmanFileVersionsCriteria = $criteria;

		return $this->collDocmanFileVersions;
	}

	/**
	 * Collection to store aggregation of collFilesystems	  
	 * @var array
	 */
	protected $collFilesystems; 

	/**
	 * Temporary storage of collFilesystems to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initFilesystems()
	{
		if ($this->collFilesystems === null) {
			$this->collFilesystems = array();
		}
	}

	/**
	 * Method called to associate a Filesystem object to this object
	 * through the Filesystem foreign key attribute
	 *
	 * @param Filesystem $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addFilesystem(Filesystem $l)
	{
		$this->collFilesystems[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collFilesystems.
	 * @var Criteria
	 */
	private $lastFilesystemsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related Filesystems from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getFilesystems($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/FilesystemPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collFilesystems === null) {
			if ($this->isNew()) {
			   $this->collFilesystems = array();
			} else {
	
				$criteria->add(FilesystemPeer::POSTED_BY, $this->getUserId() );

				$this->collFilesystems = FilesystemPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(FilesystemPeer::POSTED_BY, $this->getUserId());

				if (!isset($this->lastFilesystemsCriteria) || !$this->lastFilesystemsCriteria->equals($criteria)) {
					$this->collFilesystems = FilesystemPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastFilesystemsCriteria = $criteria;

		return $this->collFilesystems;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Filesystems from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getFilesystemsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/FilesystemPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collFilesystems === null) {
			if ($this->isNew()) {
			   $this->collFilesystems = array();
			} else {
	   
				$criteria->add(FilesystemPeer::POSTED_BY, $this->getUserId());
				$this->collFilesystems = FilesystemPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(FilesystemPeer::POSTED_BY, $this->getUserId());
			if (!isset($this->lastFilesystemsCriteria) || !$this->lastFilesystemsCriteria->equals($criteria)) {
				$this->collFilesystems = FilesystemPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastFilesystemsCriteria = $criteria;

		return $this->collFilesystems;
	}

	/**
	 * Collection to store aggregation of collForumMessages	  
	 * @var array
	 */
	protected $collForumMessages; 

	/**
	 * Temporary storage of collForumMessages to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initForumMessages()
	{
		if ($this->collForumMessages === null) {
			$this->collForumMessages = array();
		}
	}

	/**
	 * Method called to associate a ForumMessage object to this object
	 * through the ForumMessage foreign key attribute
	 *
	 * @param ForumMessage $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addForumMessage(ForumMessage $l)
	{
		$this->collForumMessages[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collForumMessages.
	 * @var Criteria
	 */
	private $lastForumMessagesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related ForumMessages from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getForumMessages($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collForumMessages === null) {
			if ($this->isNew()) {
			   $this->collForumMessages = array();
			} else {
	
				$criteria->add(ForumMessagePeer::CREATED_BY, $this->getUserId() );

				$this->collForumMessages = ForumMessagePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ForumMessagePeer::CREATED_BY, $this->getUserId());

				if (!isset($this->lastForumMessagesCriteria) || !$this->lastForumMessagesCriteria->equals($criteria)) {
					$this->collForumMessages = ForumMessagePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastForumMessagesCriteria = $criteria;

		return $this->collForumMessages;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related ForumMessages from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getForumMessagesJoinForumThread($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collForumMessages === null) {
			if ($this->isNew()) {
			   $this->collForumMessages = array();
			} else {
	   
				$criteria->add(ForumMessagePeer::CREATED_BY, $this->getUserId());
				$this->collForumMessages = ForumMessagePeer::doSelectJoinForumThread($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ForumMessagePeer::CREATED_BY, $this->getUserId());
			if (!isset($this->lastForumMessagesCriteria) || !$this->lastForumMessagesCriteria->equals($criteria)) {
				$this->collForumMessages = ForumMessagePeer::doSelectJoinForumThread($criteria, $con);
			}
		}
		$this->lastForumMessagesCriteria = $criteria;

		return $this->collForumMessages;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related ForumMessages from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getForumMessagesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collForumMessages === null) {
			if ($this->isNew()) {
			   $this->collForumMessages = array();
			} else {
	   
				$criteria->add(ForumMessagePeer::CREATED_BY, $this->getUserId());
				$this->collForumMessages = ForumMessagePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ForumMessagePeer::CREATED_BY, $this->getUserId());
			if (!isset($this->lastForumMessagesCriteria) || !$this->lastForumMessagesCriteria->equals($criteria)) {
				$this->collForumMessages = ForumMessagePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastForumMessagesCriteria = $criteria;

		return $this->collForumMessages;
	}

	/**
	 * Collection to store aggregation of collForumThreads	  
	 * @var array
	 */
	protected $collForumThreads; 

	/**
	 * Temporary storage of collForumThreads to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initForumThreads()
	{
		if ($this->collForumThreads === null) {
			$this->collForumThreads = array();
		}
	}

	/**
	 * Method called to associate a ForumThread object to this object
	 * through the ForumThread foreign key attribute
	 *
	 * @param ForumThread $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addForumThread(ForumThread $l)
	{
		$this->collForumThreads[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collForumThreads.
	 * @var Criteria
	 */
	private $lastForumThreadsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related ForumThreads from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getForumThreads($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumThreadPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collForumThreads === null) {
			if ($this->isNew()) {
			   $this->collForumThreads = array();
			} else {
	
				$criteria->add(ForumThreadPeer::CREATED_BY, $this->getUserId() );

				$this->collForumThreads = ForumThreadPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ForumThreadPeer::CREATED_BY, $this->getUserId());

				if (!isset($this->lastForumThreadsCriteria) || !$this->lastForumThreadsCriteria->equals($criteria)) {
					$this->collForumThreads = ForumThreadPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastForumThreadsCriteria = $criteria;

		return $this->collForumThreads;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related ForumThreads from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getForumThreadsJoinForum($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumThreadPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collForumThreads === null) {
			if ($this->isNew()) {
			   $this->collForumThreads = array();
			} else {
	   
				$criteria->add(ForumThreadPeer::CREATED_BY, $this->getUserId());
				$this->collForumThreads = ForumThreadPeer::doSelectJoinForum($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ForumThreadPeer::CREATED_BY, $this->getUserId());
			if (!isset($this->lastForumThreadsCriteria) || !$this->lastForumThreadsCriteria->equals($criteria)) {
				$this->collForumThreads = ForumThreadPeer::doSelectJoinForum($criteria, $con);
			}
		}
		$this->lastForumThreadsCriteria = $criteria;

		return $this->collForumThreads;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related ForumThreads from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getForumThreadsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumThreadPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collForumThreads === null) {
			if ($this->isNew()) {
			   $this->collForumThreads = array();
			} else {
	   
				$criteria->add(ForumThreadPeer::CREATED_BY, $this->getUserId());
				$this->collForumThreads = ForumThreadPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ForumThreadPeer::CREATED_BY, $this->getUserId());
			if (!isset($this->lastForumThreadsCriteria) || !$this->lastForumThreadsCriteria->equals($criteria)) {
				$this->collForumThreads = ForumThreadPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastForumThreadsCriteria = $criteria;

		return $this->collForumThreads;
	}

	/**
	 * Collection to store aggregation of collFrsReleases	  
	 * @var array
	 */
	protected $collFrsReleases; 

	/**
	 * Temporary storage of collFrsReleases to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initFrsReleases()
	{
		if ($this->collFrsReleases === null) {
			$this->collFrsReleases = array();
		}
	}

	/**
	 * Method called to associate a FrsRelease object to this object
	 * through the FrsRelease foreign key attribute
	 *
	 * @param FrsRelease $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addFrsRelease(FrsRelease $l)
	{
		$this->collFrsReleases[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collFrsReleases.
	 * @var Criteria
	 */
	private $lastFrsReleasesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related FrsReleases from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getFrsReleases($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/frs/lib/FrsReleasePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collFrsReleases === null) {
			if ($this->isNew()) {
			   $this->collFrsReleases = array();
			} else {
	
				$criteria->add(FrsReleasePeer::RELEASED_BY, $this->getUserId() );

				$this->collFrsReleases = FrsReleasePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(FrsReleasePeer::RELEASED_BY, $this->getUserId());

				if (!isset($this->lastFrsReleasesCriteria) || !$this->lastFrsReleasesCriteria->equals($criteria)) {
					$this->collFrsReleases = FrsReleasePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastFrsReleasesCriteria = $criteria;

		return $this->collFrsReleases;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related FrsReleases from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getFrsReleasesJoinFrsPackage($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/frs/lib/FrsReleasePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collFrsReleases === null) {
			if ($this->isNew()) {
			   $this->collFrsReleases = array();
			} else {
	   
				$criteria->add(FrsReleasePeer::RELEASED_BY, $this->getUserId());
				$this->collFrsReleases = FrsReleasePeer::doSelectJoinFrsPackage($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(FrsReleasePeer::RELEASED_BY, $this->getUserId());
			if (!isset($this->lastFrsReleasesCriteria) || !$this->lastFrsReleasesCriteria->equals($criteria)) {
				$this->collFrsReleases = FrsReleasePeer::doSelectJoinFrsPackage($criteria, $con);
			}
		}
		$this->lastFrsReleasesCriteria = $criteria;

		return $this->collFrsReleases;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related FrsReleases from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getFrsReleasesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/frs/lib/FrsReleasePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collFrsReleases === null) {
			if ($this->isNew()) {
			   $this->collFrsReleases = array();
			} else {
	   
				$criteria->add(FrsReleasePeer::RELEASED_BY, $this->getUserId());
				$this->collFrsReleases = FrsReleasePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(FrsReleasePeer::RELEASED_BY, $this->getUserId());
			if (!isset($this->lastFrsReleasesCriteria) || !$this->lastFrsReleasesCriteria->equals($criteria)) {
				$this->collFrsReleases = FrsReleasePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastFrsReleasesCriteria = $criteria;

		return $this->collFrsReleases;
	}

	/**
	 * Collection to store aggregation of collMailmans	  
	 * @var array
	 */
	protected $collMailmans; 

	/**
	 * Temporary storage of collMailmans to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMailmans()
	{
		if ($this->collMailmans === null) {
			$this->collMailmans = array();
		}
	}

	/**
	 * Method called to associate a Mailman object to this object
	 * through the Mailman foreign key attribute
	 *
	 * @param Mailman $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addMailman(Mailman $l)
	{
		$this->collMailmans[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collMailmans.
	 * @var Criteria
	 */
	private $lastMailmansCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related Mailmans from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMailmans($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/mailman/lib/MailmanPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collMailmans === null) {
			if ($this->isNew()) {
			   $this->collMailmans = array();
			} else {
	
				$criteria->add(MailmanPeer::CREATED_BY, $this->getUserId() );

				$this->collMailmans = MailmanPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(MailmanPeer::CREATED_BY, $this->getUserId());

				if (!isset($this->lastMailmansCriteria) || !$this->lastMailmansCriteria->equals($criteria)) {
					$this->collMailmans = MailmanPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMailmansCriteria = $criteria;

		return $this->collMailmans;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Mailmans from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getMailmansJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/mailman/lib/MailmanPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMailmans === null) {
			if ($this->isNew()) {
			   $this->collMailmans = array();
			} else {
	   
				$criteria->add(MailmanPeer::CREATED_BY, $this->getUserId());
				$this->collMailmans = MailmanPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MailmanPeer::CREATED_BY, $this->getUserId());
			if (!isset($this->lastMailmansCriteria) || !$this->lastMailmansCriteria->equals($criteria)) {
				$this->collMailmans = MailmanPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastMailmansCriteria = $criteria;

		return $this->collMailmans;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Mailmans from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getMailmansJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/mailman/lib/MailmanPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMailmans === null) {
			if ($this->isNew()) {
			   $this->collMailmans = array();
			} else {
	   
				$criteria->add(MailmanPeer::CREATED_BY, $this->getUserId());
				$this->collMailmans = MailmanPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MailmanPeer::CREATED_BY, $this->getUserId());
			if (!isset($this->lastMailmansCriteria) || !$this->lastMailmansCriteria->equals($criteria)) {
				$this->collMailmans = MailmanPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastMailmansCriteria = $criteria;

		return $this->collMailmans;
	}

	/**
	 * Collection to store aggregation of collMonitors	  
	 * @var array
	 */
	protected $collMonitors; 

	/**
	 * Temporary storage of collMonitors to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMonitors()
	{
		if ($this->collMonitors === null) {
			$this->collMonitors = array();
		}
	}

	/**
	 * Method called to associate a Monitor object to this object
	 * through the Monitor foreign key attribute
	 *
	 * @param Monitor $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addMonitor(Monitor $l)
	{
		$this->collMonitors[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collMonitors.
	 * @var Criteria
	 */
	private $lastMonitorsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related Monitors from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMonitors($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MonitorPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collMonitors === null) {
			if ($this->isNew()) {
			   $this->collMonitors = array();
			} else {
	
				$criteria->add(MonitorPeer::USER_ID, $this->getUserId() );

				$this->collMonitors = MonitorPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(MonitorPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastMonitorsCriteria) || !$this->lastMonitorsCriteria->equals($criteria)) {
					$this->collMonitors = MonitorPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMonitorsCriteria = $criteria;

		return $this->collMonitors;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Monitors from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getMonitorsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MonitorPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMonitors === null) {
			if ($this->isNew()) {
			   $this->collMonitors = array();
			} else {
	   
				$criteria->add(MonitorPeer::USER_ID, $this->getUserId());
				$this->collMonitors = MonitorPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MonitorPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastMonitorsCriteria) || !$this->lastMonitorsCriteria->equals($criteria)) {
				$this->collMonitors = MonitorPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastMonitorsCriteria = $criteria;

		return $this->collMonitors;
	}

	/**
	 * Collection to store aggregation of collNewss	  
	 * @var array
	 */
	protected $collNewss; 

	/**
	 * Temporary storage of collNewss to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initNewss()
	{
		if ($this->collNewss === null) {
			$this->collNewss = array();
		}
	}

	/**
	 * Method called to associate a News object to this object
	 * through the News foreign key attribute
	 *
	 * @param News $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addNews(News $l)
	{
		$this->collNewss[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collNewss.
	 * @var Criteria
	 */
	private $lastNewssCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related Newss from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getNewss($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/news/lib/NewsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collNewss === null) {
			if ($this->isNew()) {
			   $this->collNewss = array();
			} else {
	
				$criteria->add(NewsPeer::SUBMITTED_BY, $this->getUserId() );

				$this->collNewss = NewsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(NewsPeer::SUBMITTED_BY, $this->getUserId());

				if (!isset($this->lastNewssCriteria) || !$this->lastNewssCriteria->equals($criteria)) {
					$this->collNewss = NewsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastNewssCriteria = $criteria;

		return $this->collNewss;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Newss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getNewssJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/news/lib/NewsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collNewss === null) {
			if ($this->isNew()) {
			   $this->collNewss = array();
			} else {
	   
				$criteria->add(NewsPeer::SUBMITTED_BY, $this->getUserId());
				$this->collNewss = NewsPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(NewsPeer::SUBMITTED_BY, $this->getUserId());
			if (!isset($this->lastNewssCriteria) || !$this->lastNewssCriteria->equals($criteria)) {
				$this->collNewss = NewsPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastNewssCriteria = $criteria;

		return $this->collNewss;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Newss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getNewssJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/news/lib/NewsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collNewss === null) {
			if ($this->isNew()) {
			   $this->collNewss = array();
			} else {
	   
				$criteria->add(NewsPeer::SUBMITTED_BY, $this->getUserId());
				$this->collNewss = NewsPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(NewsPeer::SUBMITTED_BY, $this->getUserId());
			if (!isset($this->lastNewssCriteria) || !$this->lastNewssCriteria->equals($criteria)) {
				$this->collNewss = NewsPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastNewssCriteria = $criteria;

		return $this->collNewss;
	}

	/**
	 * Collection to store aggregation of collNotificationQueues	  
	 * @var array
	 */
	protected $collNotificationQueues; 

	/**
	 * Temporary storage of collNotificationQueues to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initNotificationQueues()
	{
		if ($this->collNotificationQueues === null) {
			$this->collNotificationQueues = array();
		}
	}

	/**
	 * Method called to associate a NotificationQueue object to this object
	 * through the NotificationQueue foreign key attribute
	 *
	 * @param NotificationQueue $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addNotificationQueue(NotificationQueue $l)
	{
		$this->collNotificationQueues[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collNotificationQueues.
	 * @var Criteria
	 */
	private $lastNotificationQueuesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related NotificationQueues from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getNotificationQueues($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/NotificationQueuePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collNotificationQueues === null) {
			if ($this->isNew()) {
			   $this->collNotificationQueues = array();
			} else {
	
				$criteria->add(NotificationQueuePeer::USER_ID, $this->getUserId() );

				$this->collNotificationQueues = NotificationQueuePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(NotificationQueuePeer::USER_ID, $this->getUserId());

				if (!isset($this->lastNotificationQueuesCriteria) || !$this->lastNotificationQueuesCriteria->equals($criteria)) {
					$this->collNotificationQueues = NotificationQueuePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastNotificationQueuesCriteria = $criteria;

		return $this->collNotificationQueues;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related NotificationQueues from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getNotificationQueuesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/NotificationQueuePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collNotificationQueues === null) {
			if ($this->isNew()) {
			   $this->collNotificationQueues = array();
			} else {
	   
				$criteria->add(NotificationQueuePeer::USER_ID, $this->getUserId());
				$this->collNotificationQueues = NotificationQueuePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(NotificationQueuePeer::USER_ID, $this->getUserId());
			if (!isset($this->lastNotificationQueuesCriteria) || !$this->lastNotificationQueuesCriteria->equals($criteria)) {
				$this->collNotificationQueues = NotificationQueuePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastNotificationQueuesCriteria = $criteria;

		return $this->collNotificationQueues;
	}

	/**
	 * Collection to store aggregation of collProjectJoinRequests	  
	 * @var array
	 */
	protected $collProjectJoinRequests; 

	/**
	 * Temporary storage of collProjectJoinRequests to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initProjectJoinRequests()
	{
		if ($this->collProjectJoinRequests === null) {
			$this->collProjectJoinRequests = array();
		}
	}

	/**
	 * Method called to associate a ProjectJoinRequest object to this object
	 * through the ProjectJoinRequest foreign key attribute
	 *
	 * @param ProjectJoinRequest $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addProjectJoinRequest(ProjectJoinRequest $l)
	{
		$this->collProjectJoinRequests[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collProjectJoinRequests.
	 * @var Criteria
	 */
	private $lastProjectJoinRequestsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related ProjectJoinRequests from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getProjectJoinRequests($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectJoinRequestPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collProjectJoinRequests === null) {
			if ($this->isNew()) {
			   $this->collProjectJoinRequests = array();
			} else {
	
				$criteria->add(ProjectJoinRequestPeer::USER_ID, $this->getUserId() );

				$this->collProjectJoinRequests = ProjectJoinRequestPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ProjectJoinRequestPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastProjectJoinRequestsCriteria) || !$this->lastProjectJoinRequestsCriteria->equals($criteria)) {
					$this->collProjectJoinRequests = ProjectJoinRequestPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastProjectJoinRequestsCriteria = $criteria;

		return $this->collProjectJoinRequests;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related ProjectJoinRequests from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getProjectJoinRequestsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectJoinRequestPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collProjectJoinRequests === null) {
			if ($this->isNew()) {
			   $this->collProjectJoinRequests = array();
			} else {
	   
				$criteria->add(ProjectJoinRequestPeer::USER_ID, $this->getUserId());
				$this->collProjectJoinRequests = ProjectJoinRequestPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ProjectJoinRequestPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastProjectJoinRequestsCriteria) || !$this->lastProjectJoinRequestsCriteria->equals($criteria)) {
				$this->collProjectJoinRequests = ProjectJoinRequestPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastProjectJoinRequestsCriteria = $criteria;

		return $this->collProjectJoinRequests;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related ProjectJoinRequests from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getProjectJoinRequestsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectJoinRequestPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collProjectJoinRequests === null) {
			if ($this->isNew()) {
			   $this->collProjectJoinRequests = array();
			} else {
	   
				$criteria->add(ProjectJoinRequestPeer::USER_ID, $this->getUserId());
				$this->collProjectJoinRequests = ProjectJoinRequestPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ProjectJoinRequestPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastProjectJoinRequestsCriteria) || !$this->lastProjectJoinRequestsCriteria->equals($criteria)) {
				$this->collProjectJoinRequests = ProjectJoinRequestPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastProjectJoinRequestsCriteria = $criteria;

		return $this->collProjectJoinRequests;
	}

	/**
	 * Collection to store aggregation of collScmModuleUsers	  
	 * @var array
	 */
	protected $collScmModuleUsers; 

	/**
	 * Temporary storage of collScmModuleUsers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initScmModuleUsers()
	{
		if ($this->collScmModuleUsers === null) {
			$this->collScmModuleUsers = array();
		}
	}

	/**
	 * Method called to associate a ScmModuleUser object to this object
	 * through the ScmModuleUser foreign key attribute
	 *
	 * @param ScmModuleUser $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addScmModuleUser(ScmModuleUser $l)
	{
		$this->collScmModuleUsers[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collScmModuleUsers.
	 * @var Criteria
	 */
	private $lastScmModuleUsersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related ScmModuleUsers from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getScmModuleUsers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmModuleUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collScmModuleUsers === null) {
			if ($this->isNew()) {
			   $this->collScmModuleUsers = array();
			} else {
	
				$criteria->add(ScmModuleUserPeer::USER_ID, $this->getUserId() );

				$this->collScmModuleUsers = ScmModuleUserPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ScmModuleUserPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastScmModuleUsersCriteria) || !$this->lastScmModuleUsersCriteria->equals($criteria)) {
					$this->collScmModuleUsers = ScmModuleUserPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastScmModuleUsersCriteria = $criteria;

		return $this->collScmModuleUsers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related ScmModuleUsers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getScmModuleUsersJoinScmModule($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmModuleUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmModuleUsers === null) {
			if ($this->isNew()) {
			   $this->collScmModuleUsers = array();
			} else {
	   
				$criteria->add(ScmModuleUserPeer::USER_ID, $this->getUserId());
				$this->collScmModuleUsers = ScmModuleUserPeer::doSelectJoinScmModule($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmModuleUserPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastScmModuleUsersCriteria) || !$this->lastScmModuleUsersCriteria->equals($criteria)) {
				$this->collScmModuleUsers = ScmModuleUserPeer::doSelectJoinScmModule($criteria, $con);
			}
		}
		$this->lastScmModuleUsersCriteria = $criteria;

		return $this->collScmModuleUsers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related ScmModuleUsers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getScmModuleUsersJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmModuleUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmModuleUsers === null) {
			if ($this->isNew()) {
			   $this->collScmModuleUsers = array();
			} else {
	   
				$criteria->add(ScmModuleUserPeer::USER_ID, $this->getUserId());
				$this->collScmModuleUsers = ScmModuleUserPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmModuleUserPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastScmModuleUsersCriteria) || !$this->lastScmModuleUsersCriteria->equals($criteria)) {
				$this->collScmModuleUsers = ScmModuleUserPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastScmModuleUsersCriteria = $criteria;

		return $this->collScmModuleUsers;
	}

	/**
	 * Collection to store aggregation of collScmCommits	  
	 * @var array
	 */
	protected $collScmCommits; 

	/**
	 * Temporary storage of collScmCommits to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initScmCommits()
	{
		if ($this->collScmCommits === null) {
			$this->collScmCommits = array();
		}
	}

	/**
	 * Method called to associate a ScmCommit object to this object
	 * through the ScmCommit foreign key attribute
	 *
	 * @param ScmCommit $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addScmCommit(ScmCommit $l)
	{
		$this->collScmCommits[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collScmCommits.
	 * @var Criteria
	 */
	private $lastScmCommitsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related ScmCommits from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getScmCommits($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collScmCommits === null) {
			if ($this->isNew()) {
			   $this->collScmCommits = array();
			} else {
	
				$criteria->add(ScmCommitPeer::USER_ID, $this->getUserId() );

				$this->collScmCommits = ScmCommitPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ScmCommitPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastScmCommitsCriteria) || !$this->lastScmCommitsCriteria->equals($criteria)) {
					$this->collScmCommits = ScmCommitPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastScmCommitsCriteria = $criteria;

		return $this->collScmCommits;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related ScmCommits from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getScmCommitsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmCommits === null) {
			if ($this->isNew()) {
			   $this->collScmCommits = array();
			} else {
	   
				$criteria->add(ScmCommitPeer::USER_ID, $this->getUserId());
				$this->collScmCommits = ScmCommitPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmCommitPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastScmCommitsCriteria) || !$this->lastScmCommitsCriteria->equals($criteria)) {
				$this->collScmCommits = ScmCommitPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastScmCommitsCriteria = $criteria;

		return $this->collScmCommits;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related ScmCommits from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getScmCommitsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmCommits === null) {
			if ($this->isNew()) {
			   $this->collScmCommits = array();
			} else {
	   
				$criteria->add(ScmCommitPeer::USER_ID, $this->getUserId());
				$this->collScmCommits = ScmCommitPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmCommitPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastScmCommitsCriteria) || !$this->lastScmCommitsCriteria->equals($criteria)) {
				$this->collScmCommits = ScmCommitPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastScmCommitsCriteria = $criteria;

		return $this->collScmCommits;
	}

	/**
	 * Collection to store aggregation of collJabberConnectedUsers	  
	 * @var array
	 */
	protected $collJabberConnectedUsers; 

	/**
	 * Temporary storage of collJabberConnectedUsers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initJabberConnectedUsers()
	{
		if ($this->collJabberConnectedUsers === null) {
			$this->collJabberConnectedUsers = array();
		}
	}

	/**
	 * Method called to associate a JabberConnectedUser object to this object
	 * through the JabberConnectedUser foreign key attribute
	 *
	 * @param JabberConnectedUser $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addJabberConnectedUser(JabberConnectedUser $l)
	{
		$this->collJabberConnectedUsers[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collJabberConnectedUsers.
	 * @var Criteria
	 */
	private $lastJabberConnectedUsersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related JabberConnectedUsers from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getJabberConnectedUsers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/jabber/lib/JabberConnectedUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collJabberConnectedUsers === null) {
			if ($this->isNew()) {
			   $this->collJabberConnectedUsers = array();
			} else {
	
				$criteria->add(JabberConnectedUserPeer::USER_ID, $this->getUserId() );

				$this->collJabberConnectedUsers = JabberConnectedUserPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(JabberConnectedUserPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastJabberConnectedUsersCriteria) || !$this->lastJabberConnectedUsersCriteria->equals($criteria)) {
					$this->collJabberConnectedUsers = JabberConnectedUserPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastJabberConnectedUsersCriteria = $criteria;

		return $this->collJabberConnectedUsers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related JabberConnectedUsers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getJabberConnectedUsersJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/jabber/lib/JabberConnectedUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collJabberConnectedUsers === null) {
			if ($this->isNew()) {
			   $this->collJabberConnectedUsers = array();
			} else {
	   
				$criteria->add(JabberConnectedUserPeer::USER_ID, $this->getUserId());
				$this->collJabberConnectedUsers = JabberConnectedUserPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(JabberConnectedUserPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastJabberConnectedUsersCriteria) || !$this->lastJabberConnectedUsersCriteria->equals($criteria)) {
				$this->collJabberConnectedUsers = JabberConnectedUserPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastJabberConnectedUsersCriteria = $criteria;

		return $this->collJabberConnectedUsers;
	}

	/**
	 * Collection to store aggregation of collScmUserStatss	  
	 * @var array
	 */
	protected $collScmUserStatss; 

	/**
	 * Temporary storage of collScmUserStatss to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initScmUserStatss()
	{
		if ($this->collScmUserStatss === null) {
			$this->collScmUserStatss = array();
		}
	}

	/**
	 * Method called to associate a ScmUserStats object to this object
	 * through the ScmUserStats foreign key attribute
	 *
	 * @param ScmUserStats $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addScmUserStats(ScmUserStats $l)
	{
		$this->collScmUserStatss[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collScmUserStatss.
	 * @var Criteria
	 */
	private $lastScmUserStatssCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related ScmUserStatss from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getScmUserStatss($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmUserStatsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collScmUserStatss === null) {
			if ($this->isNew()) {
			   $this->collScmUserStatss = array();
			} else {
	
				$criteria->add(ScmUserStatsPeer::USER_ID, $this->getUserId() );

				$this->collScmUserStatss = ScmUserStatsPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ScmUserStatsPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastScmUserStatssCriteria) || !$this->lastScmUserStatssCriteria->equals($criteria)) {
					$this->collScmUserStatss = ScmUserStatsPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastScmUserStatssCriteria = $criteria;

		return $this->collScmUserStatss;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related ScmUserStatss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getScmUserStatssJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmUserStatsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmUserStatss === null) {
			if ($this->isNew()) {
			   $this->collScmUserStatss = array();
			} else {
	   
				$criteria->add(ScmUserStatsPeer::USER_ID, $this->getUserId());
				$this->collScmUserStatss = ScmUserStatsPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmUserStatsPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastScmUserStatssCriteria) || !$this->lastScmUserStatssCriteria->equals($criteria)) {
				$this->collScmUserStatss = ScmUserStatsPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastScmUserStatssCriteria = $criteria;

		return $this->collScmUserStatss;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related ScmUserStatss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getScmUserStatssJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmUserStatsPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmUserStatss === null) {
			if ($this->isNew()) {
			   $this->collScmUserStatss = array();
			} else {
	   
				$criteria->add(ScmUserStatsPeer::USER_ID, $this->getUserId());
				$this->collScmUserStatss = ScmUserStatsPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmUserStatsPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastScmUserStatssCriteria) || !$this->lastScmUserStatssCriteria->equals($criteria)) {
				$this->collScmUserStatss = ScmUserStatsPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastScmUserStatssCriteria = $criteria;

		return $this->collScmUserStatss;
	}

	/**
	 * Collection to store aggregation of collSiteAdmins	  
	 * @var array
	 */
	protected $collSiteAdmins; 

	/**
	 * Temporary storage of collSiteAdmins to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initSiteAdmins()
	{
		if ($this->collSiteAdmins === null) {
			$this->collSiteAdmins = array();
		}
	}

	/**
	 * Method called to associate a SiteAdmin object to this object
	 * through the SiteAdmin foreign key attribute
	 *
	 * @param SiteAdmin $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addSiteAdmin(SiteAdmin $l)
	{
		$this->collSiteAdmins[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collSiteAdmins.
	 * @var Criteria
	 */
	private $lastSiteAdminsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related SiteAdmins from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getSiteAdmins($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/SiteAdminPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collSiteAdmins === null) {
			if ($this->isNew()) {
			   $this->collSiteAdmins = array();
			} else {
	
				$criteria->add(SiteAdminPeer::USER_ID, $this->getUserId() );

				$this->collSiteAdmins = SiteAdminPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(SiteAdminPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastSiteAdminsCriteria) || !$this->lastSiteAdminsCriteria->equals($criteria)) {
					$this->collSiteAdmins = SiteAdminPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSiteAdminsCriteria = $criteria;

		return $this->collSiteAdmins;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related SiteAdmins from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getSiteAdminsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/SiteAdminPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collSiteAdmins === null) {
			if ($this->isNew()) {
			   $this->collSiteAdmins = array();
			} else {
	   
				$criteria->add(SiteAdminPeer::USER_ID, $this->getUserId());
				$this->collSiteAdmins = SiteAdminPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(SiteAdminPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastSiteAdminsCriteria) || !$this->lastSiteAdminsCriteria->equals($criteria)) {
				$this->collSiteAdmins = SiteAdminPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastSiteAdminsCriteria = $criteria;

		return $this->collSiteAdmins;
	}

	/**
	 * Collection to store aggregation of collSnippets	  
	 * @var array
	 */
	protected $collSnippets; 

	/**
	 * Temporary storage of collSnippets to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initSnippets()
	{
		if ($this->collSnippets === null) {
			$this->collSnippets = array();
		}
	}

	/**
	 * Method called to associate a Snippet object to this object
	 * through the Snippet foreign key attribute
	 *
	 * @param Snippet $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addSnippet(Snippet $l)
	{
		$this->collSnippets[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collSnippets.
	 * @var Criteria
	 */
	private $lastSnippetsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related Snippets from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getSnippets($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/snippet/lib/SnippetPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collSnippets === null) {
			if ($this->isNew()) {
			   $this->collSnippets = array();
			} else {
	
				$criteria->add(SnippetPeer::CREATED_BY, $this->getUserId() );

				$this->collSnippets = SnippetPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(SnippetPeer::CREATED_BY, $this->getUserId());

				if (!isset($this->lastSnippetsCriteria) || !$this->lastSnippetsCriteria->equals($criteria)) {
					$this->collSnippets = SnippetPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSnippetsCriteria = $criteria;

		return $this->collSnippets;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Snippets from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getSnippetsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/snippet/lib/SnippetPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collSnippets === null) {
			if ($this->isNew()) {
			   $this->collSnippets = array();
			} else {
	   
				$criteria->add(SnippetPeer::CREATED_BY, $this->getUserId());
				$this->collSnippets = SnippetPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(SnippetPeer::CREATED_BY, $this->getUserId());
			if (!isset($this->lastSnippetsCriteria) || !$this->lastSnippetsCriteria->equals($criteria)) {
				$this->collSnippets = SnippetPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastSnippetsCriteria = $criteria;

		return $this->collSnippets;
	}

	/**
	 * Collection to store aggregation of collSurveyResponses	  
	 * @var array
	 */
	protected $collSurveyResponses; 

	/**
	 * Temporary storage of collSurveyResponses to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initSurveyResponses()
	{
		if ($this->collSurveyResponses === null) {
			$this->collSurveyResponses = array();
		}
	}

	/**
	 * Method called to associate a SurveyResponse object to this object
	 * through the SurveyResponse foreign key attribute
	 *
	 * @param SurveyResponse $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addSurveyResponse(SurveyResponse $l)
	{
		$this->collSurveyResponses[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collSurveyResponses.
	 * @var Criteria
	 */
	private $lastSurveyResponsesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related SurveyResponses from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getSurveyResponses($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/survey/lib/SurveyResponsePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collSurveyResponses === null) {
			if ($this->isNew()) {
			   $this->collSurveyResponses = array();
			} else {
	
				$criteria->add(SurveyResponsePeer::USER_ID, $this->getUserId() );

				$this->collSurveyResponses = SurveyResponsePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(SurveyResponsePeer::USER_ID, $this->getUserId());

				if (!isset($this->lastSurveyResponsesCriteria) || !$this->lastSurveyResponsesCriteria->equals($criteria)) {
					$this->collSurveyResponses = SurveyResponsePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSurveyResponsesCriteria = $criteria;

		return $this->collSurveyResponses;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related SurveyResponses from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getSurveyResponsesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/survey/lib/SurveyResponsePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collSurveyResponses === null) {
			if ($this->isNew()) {
			   $this->collSurveyResponses = array();
			} else {
	   
				$criteria->add(SurveyResponsePeer::USER_ID, $this->getUserId());
				$this->collSurveyResponses = SurveyResponsePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(SurveyResponsePeer::USER_ID, $this->getUserId());
			if (!isset($this->lastSurveyResponsesCriteria) || !$this->lastSurveyResponsesCriteria->equals($criteria)) {
				$this->collSurveyResponses = SurveyResponsePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastSurveyResponsesCriteria = $criteria;

		return $this->collSurveyResponses;
	}

	/**
	 * Collection to store aggregation of collTrackerItems	  
	 * @var array
	 */
	protected $collTrackerItems; 

	/**
	 * Temporary storage of collTrackerItems to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItems()
	{
		if ($this->collTrackerItems === null) {
			$this->collTrackerItems = array();
		}
	}

	/**
	 * Method called to associate a TrackerItem object to this object
	 * through the TrackerItem foreign key attribute
	 *
	 * @param TrackerItem $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItem(TrackerItem $l)
	{
		$this->collTrackerItems[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItems.
	 * @var Criteria
	 */
	private $lastTrackerItemsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related TrackerItems from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItems($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItems === null) {
			if ($this->isNew()) {
			   $this->collTrackerItems = array();
			} else {
	
				$criteria->add(TrackerItemPeer::SUBMITTED_BY, $this->getUserId() );

				$this->collTrackerItems = TrackerItemPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemPeer::SUBMITTED_BY, $this->getUserId());

				if (!isset($this->lastTrackerItemsCriteria) || !$this->lastTrackerItemsCriteria->equals($criteria)) {
					$this->collTrackerItems = TrackerItemPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemsCriteria = $criteria;

		return $this->collTrackerItems;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related TrackerItems from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTrackerItemsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItems === null) {
			if ($this->isNew()) {
			   $this->collTrackerItems = array();
			} else {
	   
				$criteria->add(TrackerItemPeer::SUBMITTED_BY, $this->getUserId());
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemPeer::SUBMITTED_BY, $this->getUserId());
			if (!isset($this->lastTrackerItemsCriteria) || !$this->lastTrackerItemsCriteria->equals($criteria)) {
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerItemsCriteria = $criteria;

		return $this->collTrackerItems;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related TrackerItems from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTrackerItemsJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItems === null) {
			if ($this->isNew()) {
			   $this->collTrackerItems = array();
			} else {
	   
				$criteria->add(TrackerItemPeer::SUBMITTED_BY, $this->getUserId());
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemPeer::SUBMITTED_BY, $this->getUserId());
			if (!isset($this->lastTrackerItemsCriteria) || !$this->lastTrackerItemsCriteria->equals($criteria)) {
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastTrackerItemsCriteria = $criteria;

		return $this->collTrackerItems;
	}

	/**
	 * Collection to store aggregation of collTrackerMyQueues	  
	 * @var array
	 */
	protected $collTrackerMyQueues; 

	/**
	 * Temporary storage of collTrackerMyQueues to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerMyQueues()
	{
		if ($this->collTrackerMyQueues === null) {
			$this->collTrackerMyQueues = array();
		}
	}

	/**
	 * Method called to associate a TrackerMyQueue object to this object
	 * through the TrackerMyQueue foreign key attribute
	 *
	 * @param TrackerMyQueue $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerMyQueue(TrackerMyQueue $l)
	{
		$this->collTrackerMyQueues[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerMyQueues.
	 * @var Criteria
	 */
	private $lastTrackerMyQueuesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related TrackerMyQueues from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerMyQueues($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerMyQueuePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerMyQueues === null) {
			if ($this->isNew()) {
			   $this->collTrackerMyQueues = array();
			} else {
	
				$criteria->add(TrackerMyQueuePeer::USER_ID, $this->getUserId() );

				$this->collTrackerMyQueues = TrackerMyQueuePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerMyQueuePeer::USER_ID, $this->getUserId());

				if (!isset($this->lastTrackerMyQueuesCriteria) || !$this->lastTrackerMyQueuesCriteria->equals($criteria)) {
					$this->collTrackerMyQueues = TrackerMyQueuePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerMyQueuesCriteria = $criteria;

		return $this->collTrackerMyQueues;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related TrackerMyQueues from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTrackerMyQueuesJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerMyQueuePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerMyQueues === null) {
			if ($this->isNew()) {
			   $this->collTrackerMyQueues = array();
			} else {
	   
				$criteria->add(TrackerMyQueuePeer::USER_ID, $this->getUserId());
				$this->collTrackerMyQueues = TrackerMyQueuePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerMyQueuePeer::USER_ID, $this->getUserId());
			if (!isset($this->lastTrackerMyQueuesCriteria) || !$this->lastTrackerMyQueuesCriteria->equals($criteria)) {
				$this->collTrackerMyQueues = TrackerMyQueuePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastTrackerMyQueuesCriteria = $criteria;

		return $this->collTrackerMyQueues;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related TrackerMyQueues from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTrackerMyQueuesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerMyQueuePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerMyQueues === null) {
			if ($this->isNew()) {
			   $this->collTrackerMyQueues = array();
			} else {
	   
				$criteria->add(TrackerMyQueuePeer::USER_ID, $this->getUserId());
				$this->collTrackerMyQueues = TrackerMyQueuePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerMyQueuePeer::USER_ID, $this->getUserId());
			if (!isset($this->lastTrackerMyQueuesCriteria) || !$this->lastTrackerMyQueuesCriteria->equals($criteria)) {
				$this->collTrackerMyQueues = TrackerMyQueuePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerMyQueuesCriteria = $criteria;

		return $this->collTrackerMyQueues;
	}

	/**
	 * Collection to store aggregation of collTrackerItemAssignees	  
	 * @var array
	 */
	protected $collTrackerItemAssignees; 

	/**
	 * Temporary storage of collTrackerItemAssignees to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItemAssignees()
	{
		if ($this->collTrackerItemAssignees === null) {
			$this->collTrackerItemAssignees = array();
		}
	}

	/**
	 * Method called to associate a TrackerItemAssignee object to this object
	 * through the TrackerItemAssignee foreign key attribute
	 *
	 * @param TrackerItemAssignee $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItemAssignee(TrackerItemAssignee $l)
	{
		$this->collTrackerItemAssignees[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItemAssignees.
	 * @var Criteria
	 */
	private $lastTrackerItemAssigneesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related TrackerItemAssignees from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItemAssignees($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemAssigneePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItemAssignees === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemAssignees = array();
			} else {
	
				$criteria->add(TrackerItemAssigneePeer::ASSIGNEE, $this->getUserId() );

				$this->collTrackerItemAssignees = TrackerItemAssigneePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemAssigneePeer::ASSIGNEE, $this->getUserId());

				if (!isset($this->lastTrackerItemAssigneesCriteria) || !$this->lastTrackerItemAssigneesCriteria->equals($criteria)) {
					$this->collTrackerItemAssignees = TrackerItemAssigneePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemAssigneesCriteria = $criteria;

		return $this->collTrackerItemAssignees;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related TrackerItemAssignees from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTrackerItemAssigneesJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemAssigneePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemAssignees === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemAssignees = array();
			} else {
	   
				$criteria->add(TrackerItemAssigneePeer::ASSIGNEE, $this->getUserId());
				$this->collTrackerItemAssignees = TrackerItemAssigneePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemAssigneePeer::ASSIGNEE, $this->getUserId());
			if (!isset($this->lastTrackerItemAssigneesCriteria) || !$this->lastTrackerItemAssigneesCriteria->equals($criteria)) {
				$this->collTrackerItemAssignees = TrackerItemAssigneePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastTrackerItemAssigneesCriteria = $criteria;

		return $this->collTrackerItemAssignees;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related TrackerItemAssignees from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTrackerItemAssigneesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemAssigneePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemAssignees === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemAssignees = array();
			} else {
	   
				$criteria->add(TrackerItemAssigneePeer::ASSIGNEE, $this->getUserId());
				$this->collTrackerItemAssignees = TrackerItemAssigneePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemAssigneePeer::ASSIGNEE, $this->getUserId());
			if (!isset($this->lastTrackerItemAssigneesCriteria) || !$this->lastTrackerItemAssigneesCriteria->equals($criteria)) {
				$this->collTrackerItemAssignees = TrackerItemAssigneePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerItemAssigneesCriteria = $criteria;

		return $this->collTrackerItemAssignees;
	}

	/**
	 * Collection to store aggregation of collTrackerItemMessages	  
	 * @var array
	 */
	protected $collTrackerItemMessages; 

	/**
	 * Temporary storage of collTrackerItemMessages to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItemMessages()
	{
		if ($this->collTrackerItemMessages === null) {
			$this->collTrackerItemMessages = array();
		}
	}

	/**
	 * Method called to associate a TrackerItemMessage object to this object
	 * through the TrackerItemMessage foreign key attribute
	 *
	 * @param TrackerItemMessage $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItemMessage(TrackerItemMessage $l)
	{
		$this->collTrackerItemMessages[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItemMessages.
	 * @var Criteria
	 */
	private $lastTrackerItemMessagesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related TrackerItemMessages from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItemMessages($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItemMessages === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemMessages = array();
			} else {
	
				$criteria->add(TrackerItemMessagePeer::SUBMITTED_BY, $this->getUserId() );

				$this->collTrackerItemMessages = TrackerItemMessagePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemMessagePeer::SUBMITTED_BY, $this->getUserId());

				if (!isset($this->lastTrackerItemMessagesCriteria) || !$this->lastTrackerItemMessagesCriteria->equals($criteria)) {
					$this->collTrackerItemMessages = TrackerItemMessagePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemMessagesCriteria = $criteria;

		return $this->collTrackerItemMessages;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related TrackerItemMessages from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTrackerItemMessagesJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemMessages === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemMessages = array();
			} else {
	   
				$criteria->add(TrackerItemMessagePeer::SUBMITTED_BY, $this->getUserId());
				$this->collTrackerItemMessages = TrackerItemMessagePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemMessagePeer::SUBMITTED_BY, $this->getUserId());
			if (!isset($this->lastTrackerItemMessagesCriteria) || !$this->lastTrackerItemMessagesCriteria->equals($criteria)) {
				$this->collTrackerItemMessages = TrackerItemMessagePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastTrackerItemMessagesCriteria = $criteria;

		return $this->collTrackerItemMessages;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related TrackerItemMessages from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTrackerItemMessagesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemMessages === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemMessages = array();
			} else {
	   
				$criteria->add(TrackerItemMessagePeer::SUBMITTED_BY, $this->getUserId());
				$this->collTrackerItemMessages = TrackerItemMessagePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemMessagePeer::SUBMITTED_BY, $this->getUserId());
			if (!isset($this->lastTrackerItemMessagesCriteria) || !$this->lastTrackerItemMessagesCriteria->equals($criteria)) {
				$this->collTrackerItemMessages = TrackerItemMessagePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerItemMessagesCriteria = $criteria;

		return $this->collTrackerItemMessages;
	}

	/**
	 * Collection to store aggregation of collTrackerItemTimes	  
	 * @var array
	 */
	protected $collTrackerItemTimes; 

	/**
	 * Temporary storage of collTrackerItemTimes to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItemTimes()
	{
		if ($this->collTrackerItemTimes === null) {
			$this->collTrackerItemTimes = array();
		}
	}

	/**
	 * Method called to associate a TrackerItemTime object to this object
	 * through the TrackerItemTime foreign key attribute
	 *
	 * @param TrackerItemTime $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItemTime(TrackerItemTime $l)
	{
		$this->collTrackerItemTimes[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItemTimes.
	 * @var Criteria
	 */
	private $lastTrackerItemTimesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related TrackerItemTimes from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItemTimes($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemTimePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItemTimes === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemTimes = array();
			} else {
	
				$criteria->add(TrackerItemTimePeer::USER_ID, $this->getUserId() );

				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemTimePeer::USER_ID, $this->getUserId());

				if (!isset($this->lastTrackerItemTimesCriteria) || !$this->lastTrackerItemTimesCriteria->equals($criteria)) {
					$this->collTrackerItemTimes = TrackerItemTimePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemTimesCriteria = $criteria;

		return $this->collTrackerItemTimes;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related TrackerItemTimes from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTrackerItemTimesJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemTimePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemTimes === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemTimes = array();
			} else {
	   
				$criteria->add(TrackerItemTimePeer::USER_ID, $this->getUserId());
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemTimePeer::USER_ID, $this->getUserId());
			if (!isset($this->lastTrackerItemTimesCriteria) || !$this->lastTrackerItemTimesCriteria->equals($criteria)) {
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastTrackerItemTimesCriteria = $criteria;

		return $this->collTrackerItemTimes;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related TrackerItemTimes from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTrackerItemTimesJoinTrackerTimeCode($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemTimePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemTimes === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemTimes = array();
			} else {
	   
				$criteria->add(TrackerItemTimePeer::USER_ID, $this->getUserId());
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinTrackerTimeCode($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemTimePeer::USER_ID, $this->getUserId());
			if (!isset($this->lastTrackerItemTimesCriteria) || !$this->lastTrackerItemTimesCriteria->equals($criteria)) {
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinTrackerTimeCode($criteria, $con);
			}
		}
		$this->lastTrackerItemTimesCriteria = $criteria;

		return $this->collTrackerItemTimes;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related TrackerItemTimes from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTrackerItemTimesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemTimePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemTimes === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemTimes = array();
			} else {
	   
				$criteria->add(TrackerItemTimePeer::USER_ID, $this->getUserId());
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemTimePeer::USER_ID, $this->getUserId());
			if (!isset($this->lastTrackerItemTimesCriteria) || !$this->lastTrackerItemTimesCriteria->equals($criteria)) {
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerItemTimesCriteria = $criteria;

		return $this->collTrackerItemTimes;
	}

	/**
	 * Collection to store aggregation of collTrackerQuerys	  
	 * @var array
	 */
	protected $collTrackerQuerys; 

	/**
	 * Temporary storage of collTrackerQuerys to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerQuerys()
	{
		if ($this->collTrackerQuerys === null) {
			$this->collTrackerQuerys = array();
		}
	}

	/**
	 * Method called to associate a TrackerQuery object to this object
	 * through the TrackerQuery foreign key attribute
	 *
	 * @param TrackerQuery $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerQuery(TrackerQuery $l)
	{
		$this->collTrackerQuerys[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerQuerys.
	 * @var Criteria
	 */
	private $lastTrackerQuerysCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related TrackerQuerys from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerQuerys($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerQueryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerQuerys === null) {
			if ($this->isNew()) {
			   $this->collTrackerQuerys = array();
			} else {
	
				$criteria->add(TrackerQueryPeer::USER_ID, $this->getUserId() );

				$this->collTrackerQuerys = TrackerQueryPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerQueryPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastTrackerQuerysCriteria) || !$this->lastTrackerQuerysCriteria->equals($criteria)) {
					$this->collTrackerQuerys = TrackerQueryPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerQuerysCriteria = $criteria;

		return $this->collTrackerQuerys;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related TrackerQuerys from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTrackerQuerysJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerQueryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerQuerys === null) {
			if ($this->isNew()) {
			   $this->collTrackerQuerys = array();
			} else {
	   
				$criteria->add(TrackerQueryPeer::USER_ID, $this->getUserId());
				$this->collTrackerQuerys = TrackerQueryPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerQueryPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastTrackerQuerysCriteria) || !$this->lastTrackerQuerysCriteria->equals($criteria)) {
				$this->collTrackerQuerys = TrackerQueryPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastTrackerQuerysCriteria = $criteria;

		return $this->collTrackerQuerys;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related TrackerQuerys from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTrackerQuerysJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerQueryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerQuerys === null) {
			if ($this->isNew()) {
			   $this->collTrackerQuerys = array();
			} else {
	   
				$criteria->add(TrackerQueryPeer::USER_ID, $this->getUserId());
				$this->collTrackerQuerys = TrackerQueryPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerQueryPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastTrackerQuerysCriteria) || !$this->lastTrackerQuerysCriteria->equals($criteria)) {
				$this->collTrackerQuerys = TrackerQueryPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerQuerysCriteria = $criteria;

		return $this->collTrackerQuerys;
	}

	/**
	 * Collection to store aggregation of collUserPlugins	  
	 * @var array
	 */
	protected $collUserPlugins; 

	/**
	 * Temporary storage of collUserPlugins to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserPlugins()
	{
		if ($this->collUserPlugins === null) {
			$this->collUserPlugins = array();
		}
	}

	/**
	 * Method called to associate a UserPlugin object to this object
	 * through the UserPlugin foreign key attribute
	 *
	 * @param UserPlugin $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUserPlugin(UserPlugin $l)
	{
		$this->collUserPlugins[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collUserPlugins.
	 * @var Criteria
	 */
	private $lastUserPluginsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related UserPlugins from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserPlugins($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserPluginPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUserPlugins === null) {
			if ($this->isNew()) {
			   $this->collUserPlugins = array();
			} else {
	
				$criteria->add(UserPluginPeer::USER_ID, $this->getUserId() );

				$this->collUserPlugins = UserPluginPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserPluginPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastUserPluginsCriteria) || !$this->lastUserPluginsCriteria->equals($criteria)) {
					$this->collUserPlugins = UserPluginPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserPluginsCriteria = $criteria;

		return $this->collUserPlugins;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related UserPlugins from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getUserPluginsJoinPlugin($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserPluginPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserPlugins === null) {
			if ($this->isNew()) {
			   $this->collUserPlugins = array();
			} else {
	   
				$criteria->add(UserPluginPeer::USER_ID, $this->getUserId());
				$this->collUserPlugins = UserPluginPeer::doSelectJoinPlugin($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserPluginPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastUserPluginsCriteria) || !$this->lastUserPluginsCriteria->equals($criteria)) {
				$this->collUserPlugins = UserPluginPeer::doSelectJoinPlugin($criteria, $con);
			}
		}
		$this->lastUserPluginsCriteria = $criteria;

		return $this->collUserPlugins;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related UserPlugins from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getUserPluginsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserPluginPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserPlugins === null) {
			if ($this->isNew()) {
			   $this->collUserPlugins = array();
			} else {
	   
				$criteria->add(UserPluginPeer::USER_ID, $this->getUserId());
				$this->collUserPlugins = UserPluginPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserPluginPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastUserPluginsCriteria) || !$this->lastUserPluginsCriteria->equals($criteria)) {
				$this->collUserPlugins = UserPluginPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastUserPluginsCriteria = $criteria;

		return $this->collUserPlugins;
	}

	/**
	 * Collection to store aggregation of collUserPreferences	  
	 * @var array
	 */
	protected $collUserPreferences; 

	/**
	 * Temporary storage of collUserPreferences to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserPreferences()
	{
		if ($this->collUserPreferences === null) {
			$this->collUserPreferences = array();
		}
	}

	/**
	 * Method called to associate a UserPreference object to this object
	 * through the UserPreference foreign key attribute
	 *
	 * @param UserPreference $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUserPreference(UserPreference $l)
	{
		$this->collUserPreferences[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collUserPreferences.
	 * @var Criteria
	 */
	private $lastUserPreferencesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related UserPreferences from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserPreferences($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserPreferencePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUserPreferences === null) {
			if ($this->isNew()) {
			   $this->collUserPreferences = array();
			} else {
	
				$criteria->add(UserPreferencePeer::USER_ID, $this->getUserId() );

				$this->collUserPreferences = UserPreferencePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserPreferencePeer::USER_ID, $this->getUserId());

				if (!isset($this->lastUserPreferencesCriteria) || !$this->lastUserPreferencesCriteria->equals($criteria)) {
					$this->collUserPreferences = UserPreferencePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserPreferencesCriteria = $criteria;

		return $this->collUserPreferences;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related UserPreferences from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getUserPreferencesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserPreferencePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserPreferences === null) {
			if ($this->isNew()) {
			   $this->collUserPreferences = array();
			} else {
	   
				$criteria->add(UserPreferencePeer::USER_ID, $this->getUserId());
				$this->collUserPreferences = UserPreferencePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserPreferencePeer::USER_ID, $this->getUserId());
			if (!isset($this->lastUserPreferencesCriteria) || !$this->lastUserPreferencesCriteria->equals($criteria)) {
				$this->collUserPreferences = UserPreferencePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastUserPreferencesCriteria = $criteria;

		return $this->collUserPreferences;
	}

	/**
	 * Collection to store aggregation of collUsergroupUsersRelatedByUsergroupId	  
	 * @var array
	 */
	protected $collUsergroupUsersRelatedByUsergroupId; 

	/**
	 * Temporary storage of collUsergroupUsersRelatedByUsergroupId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUsergroupUsersRelatedByUsergroupId()
	{
		if ($this->collUsergroupUsersRelatedByUsergroupId === null) {
			$this->collUsergroupUsersRelatedByUsergroupId = array();
		}
	}

	/**
	 * Method called to associate a UsergroupUser object to this object
	 * through the UsergroupUser foreign key attribute
	 *
	 * @param UsergroupUser $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUsergroupUserRelatedByUsergroupId(UsergroupUser $l)
	{
		$this->collUsergroupUsersRelatedByUsergroupId[] = $l;
		$l->setUserRelatedByUsergroupId($this);
	}

	/**
	 * The criteria used to select the current contents of collUsergroupUsersRelatedByUsergroupId.
	 * @var Criteria
	 */
	private $lastUsergroupUsersRelatedByUsergroupIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related UsergroupUsersRelatedByUsergroupId from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUsergroupUsersRelatedByUsergroupId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UsergroupUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUsergroupUsersRelatedByUsergroupId === null) {
			if ($this->isNew()) {
			   $this->collUsergroupUsersRelatedByUsergroupId = array();
			} else {
	
				$criteria->add(UsergroupUserPeer::USERGROUP_ID, $this->getUserId() );

				$this->collUsergroupUsersRelatedByUsergroupId = UsergroupUserPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UsergroupUserPeer::USERGROUP_ID, $this->getUserId());

				if (!isset($this->lastUsergroupUsersRelatedByUsergroupIdCriteria) || !$this->lastUsergroupUsersRelatedByUsergroupIdCriteria->equals($criteria)) {
					$this->collUsergroupUsersRelatedByUsergroupId = UsergroupUserPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUsergroupUsersRelatedByUsergroupIdCriteria = $criteria;

		return $this->collUsergroupUsersRelatedByUsergroupId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related UsergroupUsersRelatedByUsergroupId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getUsergroupUsersRelatedByUsergroupIdJoinUserRelatedByMemberUserId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UsergroupUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUsergroupUsersRelatedByUsergroupId === null) {
			if ($this->isNew()) {
			   $this->collUsergroupUsersRelatedByUsergroupId = array();
			} else {
	   
				$criteria->add(UsergroupUserPeer::USERGROUP_ID, $this->getUserId());
				$this->collUsergroupUsersRelatedByUsergroupId = UsergroupUserPeer::doSelectJoinUserRelatedByMemberUserId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UsergroupUserPeer::USERGROUP_ID, $this->getUserId());
			if (!isset($this->lastUsergroupUsersRelatedByUsergroupIdCriteria) || !$this->lastUsergroupUsersRelatedByUsergroupIdCriteria->equals($criteria)) {
				$this->collUsergroupUsersRelatedByUsergroupId = UsergroupUserPeer::doSelectJoinUserRelatedByMemberUserId($criteria, $con);
			}
		}
		$this->lastUsergroupUsersRelatedByUsergroupIdCriteria = $criteria;

		return $this->collUsergroupUsersRelatedByUsergroupId;
	}

	/**
	 * Collection to store aggregation of collUsergroupUsersRelatedByMemberUserId	  
	 * @var array
	 */
	protected $collUsergroupUsersRelatedByMemberUserId; 

	/**
	 * Temporary storage of collUsergroupUsersRelatedByMemberUserId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUsergroupUsersRelatedByMemberUserId()
	{
		if ($this->collUsergroupUsersRelatedByMemberUserId === null) {
			$this->collUsergroupUsersRelatedByMemberUserId = array();
		}
	}

	/**
	 * Method called to associate a UsergroupUser object to this object
	 * through the UsergroupUser foreign key attribute
	 *
	 * @param UsergroupUser $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUsergroupUserRelatedByMemberUserId(UsergroupUser $l)
	{
		$this->collUsergroupUsersRelatedByMemberUserId[] = $l;
		$l->setUserRelatedByMemberUserId($this);
	}

	/**
	 * The criteria used to select the current contents of collUsergroupUsersRelatedByMemberUserId.
	 * @var Criteria
	 */
	private $lastUsergroupUsersRelatedByMemberUserIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related UsergroupUsersRelatedByMemberUserId from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUsergroupUsersRelatedByMemberUserId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UsergroupUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUsergroupUsersRelatedByMemberUserId === null) {
			if ($this->isNew()) {
			   $this->collUsergroupUsersRelatedByMemberUserId = array();
			} else {
	
				$criteria->add(UsergroupUserPeer::MEMBER_USER_ID, $this->getUserId() );

				$this->collUsergroupUsersRelatedByMemberUserId = UsergroupUserPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UsergroupUserPeer::MEMBER_USER_ID, $this->getUserId());

				if (!isset($this->lastUsergroupUsersRelatedByMemberUserIdCriteria) || !$this->lastUsergroupUsersRelatedByMemberUserIdCriteria->equals($criteria)) {
					$this->collUsergroupUsersRelatedByMemberUserId = UsergroupUserPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUsergroupUsersRelatedByMemberUserIdCriteria = $criteria;

		return $this->collUsergroupUsersRelatedByMemberUserId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related UsergroupUsersRelatedByMemberUserId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getUsergroupUsersRelatedByMemberUserIdJoinUserRelatedByUsergroupId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UsergroupUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUsergroupUsersRelatedByMemberUserId === null) {
			if ($this->isNew()) {
			   $this->collUsergroupUsersRelatedByMemberUserId = array();
			} else {
	   
				$criteria->add(UsergroupUserPeer::MEMBER_USER_ID, $this->getUserId());
				$this->collUsergroupUsersRelatedByMemberUserId = UsergroupUserPeer::doSelectJoinUserRelatedByUsergroupId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UsergroupUserPeer::MEMBER_USER_ID, $this->getUserId());
			if (!isset($this->lastUsergroupUsersRelatedByMemberUserIdCriteria) || !$this->lastUsergroupUsersRelatedByMemberUserIdCriteria->equals($criteria)) {
				$this->collUsergroupUsersRelatedByMemberUserId = UsergroupUserPeer::doSelectJoinUserRelatedByUsergroupId($criteria, $con);
			}
		}
		$this->lastUsergroupUsersRelatedByMemberUserIdCriteria = $criteria;

		return $this->collUsergroupUsersRelatedByMemberUserId;
	}

	/**
	 * Collection to store aggregation of collUserProjects	  
	 * @var array
	 */
	protected $collUserProjects; 

	/**
	 * Temporary storage of collUserProjects to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserProjects()
	{
		if ($this->collUserProjects === null) {
			$this->collUserProjects = array();
		}
	}

	/**
	 * Method called to associate a UserProject object to this object
	 * through the UserProject foreign key attribute
	 *
	 * @param UserProject $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUserProject(UserProject $l)
	{
		$this->collUserProjects[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collUserProjects.
	 * @var Criteria
	 */
	private $lastUserProjectsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related UserProjects from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserProjects($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUserProjects === null) {
			if ($this->isNew()) {
			   $this->collUserProjects = array();
			} else {
	
				$criteria->add(UserProjectPeer::USER_ID, $this->getUserId() );

				$this->collUserProjects = UserProjectPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserProjectPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastUserProjectsCriteria) || !$this->lastUserProjectsCriteria->equals($criteria)) {
					$this->collUserProjects = UserProjectPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserProjectsCriteria = $criteria;

		return $this->collUserProjects;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related UserProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getUserProjectsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserProjects === null) {
			if ($this->isNew()) {
			   $this->collUserProjects = array();
			} else {
	   
				$criteria->add(UserProjectPeer::USER_ID, $this->getUserId());
				$this->collUserProjects = UserProjectPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserProjectPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastUserProjectsCriteria) || !$this->lastUserProjectsCriteria->equals($criteria)) {
				$this->collUserProjects = UserProjectPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastUserProjectsCriteria = $criteria;

		return $this->collUserProjects;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related UserProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getUserProjectsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserProjects === null) {
			if ($this->isNew()) {
			   $this->collUserProjects = array();
			} else {
	   
				$criteria->add(UserProjectPeer::USER_ID, $this->getUserId());
				$this->collUserProjects = UserProjectPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserProjectPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastUserProjectsCriteria) || !$this->lastUserProjectsCriteria->equals($criteria)) {
				$this->collUserProjects = UserProjectPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastUserProjectsCriteria = $criteria;

		return $this->collUserProjects;
	}

	/**
	 * Collection to store aggregation of collUserSessions	  
	 * @var array
	 */
	protected $collUserSessions; 

	/**
	 * Temporary storage of collUserSessions to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserSessions()
	{
		if ($this->collUserSessions === null) {
			$this->collUserSessions = array();
		}
	}

	/**
	 * Method called to associate a UserSession object to this object
	 * through the UserSession foreign key attribute
	 *
	 * @param UserSession $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUserSession(UserSession $l)
	{
		$this->collUserSessions[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collUserSessions.
	 * @var Criteria
	 */
	private $lastUserSessionsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related UserSessions from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserSessions($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserSessionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUserSessions === null) {
			if ($this->isNew()) {
			   $this->collUserSessions = array();
			} else {
	
				$criteria->add(UserSessionPeer::USER_ID, $this->getUserId() );

				$this->collUserSessions = UserSessionPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserSessionPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastUserSessionsCriteria) || !$this->lastUserSessionsCriteria->equals($criteria)) {
					$this->collUserSessions = UserSessionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserSessionsCriteria = $criteria;

		return $this->collUserSessions;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related UserSessions from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getUserSessionsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserSessionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserSessions === null) {
			if ($this->isNew()) {
			   $this->collUserSessions = array();
			} else {
	   
				$criteria->add(UserSessionPeer::USER_ID, $this->getUserId());
				$this->collUserSessions = UserSessionPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserSessionPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastUserSessionsCriteria) || !$this->lastUserSessionsCriteria->equals($criteria)) {
				$this->collUserSessions = UserSessionPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastUserSessionsCriteria = $criteria;

		return $this->collUserSessions;
	}

	/**
	 * Collection to store aggregation of collUserUnixs	  
	 * @var array
	 */
	protected $collUserUnixs; 

	/**
	 * Temporary storage of collUserUnixs to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserUnixs()
	{
		if ($this->collUserUnixs === null) {
			$this->collUserUnixs = array();
		}
	}

	/**
	 * Method called to associate a UserUnix object to this object
	 * through the UserUnix foreign key attribute
	 *
	 * @param UserUnix $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUserUnix(UserUnix $l)
	{
		$this->collUserUnixs[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collUserUnixs.
	 * @var Criteria
	 */
	private $lastUserUnixsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related UserUnixs from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserUnixs($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserUnixPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUserUnixs === null) {
			if ($this->isNew()) {
			   $this->collUserUnixs = array();
			} else {
	
				$criteria->add(UserUnixPeer::USER_ID, $this->getUserId() );

				$this->collUserUnixs = UserUnixPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserUnixPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastUserUnixsCriteria) || !$this->lastUserUnixsCriteria->equals($criteria)) {
					$this->collUserUnixs = UserUnixPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserUnixsCriteria = $criteria;

		return $this->collUserUnixs;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related UserUnixs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getUserUnixsJoinUnixShell($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserUnixPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserUnixs === null) {
			if ($this->isNew()) {
			   $this->collUserUnixs = array();
			} else {
	   
				$criteria->add(UserUnixPeer::USER_ID, $this->getUserId());
				$this->collUserUnixs = UserUnixPeer::doSelectJoinUnixShell($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserUnixPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastUserUnixsCriteria) || !$this->lastUserUnixsCriteria->equals($criteria)) {
				$this->collUserUnixs = UserUnixPeer::doSelectJoinUnixShell($criteria, $con);
			}
		}
		$this->lastUserUnixsCriteria = $criteria;

		return $this->collUserUnixs;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related UserUnixs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getUserUnixsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserUnixPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserUnixs === null) {
			if ($this->isNew()) {
			   $this->collUserUnixs = array();
			} else {
	   
				$criteria->add(UserUnixPeer::USER_ID, $this->getUserId());
				$this->collUserUnixs = UserUnixPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserUnixPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastUserUnixsCriteria) || !$this->lastUserUnixsCriteria->equals($criteria)) {
				$this->collUserUnixs = UserUnixPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastUserUnixsCriteria = $criteria;

		return $this->collUserUnixs;
	}

	/**
	 * Collection to store aggregation of collUserWatchedProjects	  
	 * @var array
	 */
	protected $collUserWatchedProjects; 

	/**
	 * Temporary storage of collUserWatchedProjects to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserWatchedProjects()
	{
		if ($this->collUserWatchedProjects === null) {
			$this->collUserWatchedProjects = array();
		}
	}

	/**
	 * Method called to associate a UserWatchedProject object to this object
	 * through the UserWatchedProject foreign key attribute
	 *
	 * @param UserWatchedProject $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUserWatchedProject(UserWatchedProject $l)
	{
		$this->collUserWatchedProjects[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collUserWatchedProjects.
	 * @var Criteria
	 */
	private $lastUserWatchedProjectsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related UserWatchedProjects from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserWatchedProjects($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserWatchedProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUserWatchedProjects === null) {
			if ($this->isNew()) {
			   $this->collUserWatchedProjects = array();
			} else {
	
				$criteria->add(UserWatchedProjectPeer::USER_ID, $this->getUserId() );

				$this->collUserWatchedProjects = UserWatchedProjectPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserWatchedProjectPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastUserWatchedProjectsCriteria) || !$this->lastUserWatchedProjectsCriteria->equals($criteria)) {
					$this->collUserWatchedProjects = UserWatchedProjectPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserWatchedProjectsCriteria = $criteria;

		return $this->collUserWatchedProjects;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related UserWatchedProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getUserWatchedProjectsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserWatchedProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserWatchedProjects === null) {
			if ($this->isNew()) {
			   $this->collUserWatchedProjects = array();
			} else {
	   
				$criteria->add(UserWatchedProjectPeer::USER_ID, $this->getUserId());
				$this->collUserWatchedProjects = UserWatchedProjectPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserWatchedProjectPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastUserWatchedProjectsCriteria) || !$this->lastUserWatchedProjectsCriteria->equals($criteria)) {
				$this->collUserWatchedProjects = UserWatchedProjectPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastUserWatchedProjectsCriteria = $criteria;

		return $this->collUserWatchedProjects;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related UserWatchedProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getUserWatchedProjectsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserWatchedProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserWatchedProjects === null) {
			if ($this->isNew()) {
			   $this->collUserWatchedProjects = array();
			} else {
	   
				$criteria->add(UserWatchedProjectPeer::USER_ID, $this->getUserId());
				$this->collUserWatchedProjects = UserWatchedProjectPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserWatchedProjectPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastUserWatchedProjectsCriteria) || !$this->lastUserWatchedProjectsCriteria->equals($criteria)) {
				$this->collUserWatchedProjects = UserWatchedProjectPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastUserWatchedProjectsCriteria = $criteria;

		return $this->collUserWatchedProjects;
	}

	/**
	 * Collection to store aggregation of collWikiVersions	  
	 * @var array
	 */
	protected $collWikiVersions; 

	/**
	 * Temporary storage of collWikiVersions to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initWikiVersions()
	{
		if ($this->collWikiVersions === null) {
			$this->collWikiVersions = array();
		}
	}

	/**
	 * Method called to associate a WikiVersion object to this object
	 * through the WikiVersion foreign key attribute
	 *
	 * @param WikiVersion $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addWikiVersion(WikiVersion $l)
	{
		$this->collWikiVersions[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collWikiVersions.
	 * @var Criteria
	 */
	private $lastWikiVersionsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related WikiVersions from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getWikiVersions($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/wiki/lib/WikiVersionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collWikiVersions === null) {
			if ($this->isNew()) {
			   $this->collWikiVersions = array();
			} else {
	
				$criteria->add(WikiVersionPeer::POSTED_BY, $this->getUserId() );

				$this->collWikiVersions = WikiVersionPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(WikiVersionPeer::POSTED_BY, $this->getUserId());

				if (!isset($this->lastWikiVersionsCriteria) || !$this->lastWikiVersionsCriteria->equals($criteria)) {
					$this->collWikiVersions = WikiVersionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastWikiVersionsCriteria = $criteria;

		return $this->collWikiVersions;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related WikiVersions from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getWikiVersionsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/wiki/lib/WikiVersionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collWikiVersions === null) {
			if ($this->isNew()) {
			   $this->collWikiVersions = array();
			} else {
	   
				$criteria->add(WikiVersionPeer::POSTED_BY, $this->getUserId());
				$this->collWikiVersions = WikiVersionPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(WikiVersionPeer::POSTED_BY, $this->getUserId());
			if (!isset($this->lastWikiVersionsCriteria) || !$this->lastWikiVersionsCriteria->equals($criteria)) {
				$this->collWikiVersions = WikiVersionPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastWikiVersionsCriteria = $criteria;

		return $this->collWikiVersions;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related WikiVersions from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getWikiVersionsJoinWikiPage($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/wiki/lib/WikiVersionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collWikiVersions === null) {
			if ($this->isNew()) {
			   $this->collWikiVersions = array();
			} else {
	   
				$criteria->add(WikiVersionPeer::POSTED_BY, $this->getUserId());
				$this->collWikiVersions = WikiVersionPeer::doSelectJoinWikiPage($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(WikiVersionPeer::POSTED_BY, $this->getUserId());
			if (!isset($this->lastWikiVersionsCriteria) || !$this->lastWikiVersionsCriteria->equals($criteria)) {
				$this->collWikiVersions = WikiVersionPeer::doSelectJoinWikiPage($criteria, $con);
			}
		}
		$this->lastWikiVersionsCriteria = $criteria;

		return $this->collWikiVersions;
	}

	/**
	 * Collection to store aggregation of collMyReportUsers	  
	 * @var array
	 */
	protected $collMyReportUsers; 

	/**
	 * Temporary storage of collMyReportUsers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMyReportUsers()
	{
		if ($this->collMyReportUsers === null) {
			$this->collMyReportUsers = array();
		}
	}

	/**
	 * Method called to associate a MyReportUser object to this object
	 * through the MyReportUser foreign key attribute
	 *
	 * @param MyReportUser $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addMyReportUser(MyReportUser $l)
	{
		$this->collMyReportUsers[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collMyReportUsers.
	 * @var Criteria
	 */
	private $lastMyReportUsersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related MyReportUsers from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMyReportUsers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collMyReportUsers === null) {
			if ($this->isNew()) {
			   $this->collMyReportUsers = array();
			} else {
	
				$criteria->add(MyReportUserPeer::USER_ID, $this->getUserId() );

				$this->collMyReportUsers = MyReportUserPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(MyReportUserPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastMyReportUsersCriteria) || !$this->lastMyReportUsersCriteria->equals($criteria)) {
					$this->collMyReportUsers = MyReportUserPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMyReportUsersCriteria = $criteria;

		return $this->collMyReportUsers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related MyReportUsers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getMyReportUsersJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportUsers === null) {
			if ($this->isNew()) {
			   $this->collMyReportUsers = array();
			} else {
	   
				$criteria->add(MyReportUserPeer::USER_ID, $this->getUserId());
				$this->collMyReportUsers = MyReportUserPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportUserPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastMyReportUsersCriteria) || !$this->lastMyReportUsersCriteria->equals($criteria)) {
				$this->collMyReportUsers = MyReportUserPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastMyReportUsersCriteria = $criteria;

		return $this->collMyReportUsers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related MyReportUsers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getMyReportUsersJoinMyReport($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportUsers === null) {
			if ($this->isNew()) {
			   $this->collMyReportUsers = array();
			} else {
	   
				$criteria->add(MyReportUserPeer::USER_ID, $this->getUserId());
				$this->collMyReportUsers = MyReportUserPeer::doSelectJoinMyReport($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportUserPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastMyReportUsersCriteria) || !$this->lastMyReportUsersCriteria->equals($criteria)) {
				$this->collMyReportUsers = MyReportUserPeer::doSelectJoinMyReport($criteria, $con);
			}
		}
		$this->lastMyReportUsersCriteria = $criteria;

		return $this->collMyReportUsers;
	}

	/**
	 * Collection to store aggregation of collMyReports	  
	 * @var array
	 */
	protected $collMyReports; 

	/**
	 * Temporary storage of collMyReports to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMyReports()
	{
		if ($this->collMyReports === null) {
			$this->collMyReports = array();
		}
	}

	/**
	 * Method called to associate a MyReport object to this object
	 * through the MyReport foreign key attribute
	 *
	 * @param MyReport $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addMyReport(MyReport $l)
	{
		$this->collMyReports[] = $l;
		$l->setUser($this);
	}

	/**
	 * The criteria used to select the current contents of collMyReports.
	 * @var Criteria
	 */
	private $lastMyReportsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related MyReports from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMyReports($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collMyReports === null) {
			if ($this->isNew()) {
			   $this->collMyReports = array();
			} else {
	
				$criteria->add(MyReportPeer::USER_ID, $this->getUserId() );

				$this->collMyReports = MyReportPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(MyReportPeer::USER_ID, $this->getUserId());

				if (!isset($this->lastMyReportsCriteria) || !$this->lastMyReportsCriteria->equals($criteria)) {
					$this->collMyReports = MyReportPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMyReportsCriteria = $criteria;

		return $this->collMyReports;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related MyReports from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getMyReportsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReports === null) {
			if ($this->isNew()) {
			   $this->collMyReports = array();
			} else {
	   
				$criteria->add(MyReportPeer::USER_ID, $this->getUserId());
				$this->collMyReports = MyReportPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportPeer::USER_ID, $this->getUserId());
			if (!isset($this->lastMyReportsCriteria) || !$this->lastMyReportsCriteria->equals($criteria)) {
				$this->collMyReports = MyReportPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastMyReportsCriteria = $criteria;

		return $this->collMyReports;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("user_id", "unix_name", "email", "status", "password_md5", "password_crypt", "create_date", "confirm_hash", "email_new", "timezone", "date_format", "address", "address2", "phone", "fax", "title", "firstname", "lastname", "ccode", "language_id", "theme_id", "external_id", "last_login", "user_text1", "user_text2", "user_text3", "user_text4", "user_text5", "user_text6", "is_group", "password_change_date", "is_restricted", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case UserPeer::USER_ID:
				return $this->getUserId();
				break;
		  
			case UserPeer::UNIX_NAME:
				return $this->getUnixName();
				break;
		  
			case UserPeer::EMAIL:
				return $this->getEmail();
				break;
		  
			case UserPeer::STATUS:
				return $this->getStatus();
				break;
		  
			case UserPeer::PASSWORD_MD5:
				return $this->getPasswordMd5();
				break;
		  
			case UserPeer::PASSWORD_CRYPT:
				return $this->getPasswordCrypt();
				break;
		  
			case UserPeer::CREATE_DATE:
				return $this->getCreateDate();
				break;
		  
			case UserPeer::CONFIRM_HASH:
				return $this->getConfirmHash();
				break;
		  
			case UserPeer::EMAIL_NEW:
				return $this->getEmailNew();
				break;
		  
			case UserPeer::TIMEZONE:
				return $this->getTimezone();
				break;
		  
			case UserPeer::DATE_FORMAT:
				return $this->getDateFormat();
				break;
		  
			case UserPeer::ADDRESS:
				return $this->getAddress();
				break;
		  
			case UserPeer::ADDRESS2:
				return $this->getAddress2();
				break;
		  
			case UserPeer::PHONE:
				return $this->getPhone();
				break;
		  
			case UserPeer::FAX:
				return $this->getFax();
				break;
		  
			case UserPeer::TITLE:
				return $this->getTitle();
				break;
		  
			case UserPeer::FIRSTNAME:
				return $this->getFirstname();
				break;
		  
			case UserPeer::LASTNAME:
				return $this->getLastname();
				break;
		  
			case UserPeer::CCODE:
				return $this->getCcode();
				break;
		  
			case UserPeer::LANGUAGE_ID:
				return $this->getLanguageId();
				break;
		  
			case UserPeer::THEME_ID:
				return $this->getThemeId();
				break;
		  
			case UserPeer::EXTERNAL_ID:
				return $this->getExternalId();
				break;
		  
			case UserPeer::LAST_LOGIN:
				return $this->getLastLogin();
				break;
		  
			case UserPeer::USER_TEXT1:
				return $this->getUserText1();
				break;
		  
			case UserPeer::USER_TEXT2:
				return $this->getUserText2();
				break;
		  
			case UserPeer::USER_TEXT3:
				return $this->getUserText3();
				break;
		  
			case UserPeer::USER_TEXT4:
				return $this->getUserText4();
				break;
		  
			case UserPeer::USER_TEXT5:
				return $this->getUserText5();
				break;
		  
			case UserPeer::USER_TEXT6:
				return $this->getUserText6();
				break;
		  
			case UserPeer::IS_GROUP:
				return $this->getIsGroup();
				break;
		  
			case UserPeer::PASSWORD_CHANGE_DATE:
				return $this->getPasswordChangeDate();
				break;
		  
			case UserPeer::IS_RESTRICTED:
				return $this->getIsRestricted();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getUserId();
				break;
  
			case 1:
				return $this->getUnixName();
				break;
  
			case 2:
				return $this->getEmail();
				break;
  
			case 3:
				return $this->getStatus();
				break;
  
			case 4:
				return $this->getPasswordMd5();
				break;
  
			case 5:
				return $this->getPasswordCrypt();
				break;
  
			case 6:
				return $this->getCreateDate();
				break;
  
			case 7:
				return $this->getConfirmHash();
				break;
  
			case 8:
				return $this->getEmailNew();
				break;
  
			case 9:
				return $this->getTimezone();
				break;
  
			case 10:
				return $this->getDateFormat();
				break;
  
			case 11:
				return $this->getAddress();
				break;
  
			case 12:
				return $this->getAddress2();
				break;
  
			case 13:
				return $this->getPhone();
				break;
  
			case 14:
				return $this->getFax();
				break;
  
			case 15:
				return $this->getTitle();
				break;
  
			case 16:
				return $this->getFirstname();
				break;
  
			case 17:
				return $this->getLastname();
				break;
  
			case 18:
				return $this->getCcode();
				break;
  
			case 19:
				return $this->getLanguageId();
				break;
  
			case 20:
				return $this->getThemeId();
				break;
  
			case 21:
				return $this->getExternalId();
				break;
  
			case 22:
				return $this->getLastLogin();
				break;
  
			case 23:
				return $this->getUserText1();
				break;
  
			case 24:
				return $this->getUserText2();
				break;
  
			case 25:
				return $this->getUserText3();
				break;
  
			case 26:
				return $this->getUserText4();
				break;
  
			case 27:
				return $this->getUserText5();
				break;
  
			case 28:
				return $this->getUserText6();
				break;
  
			case 29:
				return $this->getIsGroup();
				break;
  
			case 30:
				return $this->getPasswordChangeDate();
				break;
  
			case 31:
				return $this->getIsRestricted();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(UserPeer::USER_ID, $arr)) $this->setUserId($arr[UserPeer::USER_ID]);
  
		if (array_key_exists(UserPeer::UNIX_NAME, $arr)) $this->setUnixName($arr[UserPeer::UNIX_NAME]);
  
		if (array_key_exists(UserPeer::EMAIL, $arr)) $this->setEmail($arr[UserPeer::EMAIL]);
  
		if (array_key_exists(UserPeer::STATUS, $arr)) $this->setStatus($arr[UserPeer::STATUS]);
  
		if (array_key_exists(UserPeer::PASSWORD_MD5, $arr)) $this->setPasswordMd5($arr[UserPeer::PASSWORD_MD5]);
  
		if (array_key_exists(UserPeer::PASSWORD_CRYPT, $arr)) $this->setPasswordCrypt($arr[UserPeer::PASSWORD_CRYPT]);
  
		if (array_key_exists(UserPeer::CREATE_DATE, $arr)) $this->setCreateDate($arr[UserPeer::CREATE_DATE]);
  
		if (array_key_exists(UserPeer::CONFIRM_HASH, $arr)) $this->setConfirmHash($arr[UserPeer::CONFIRM_HASH]);
  
		if (array_key_exists(UserPeer::EMAIL_NEW, $arr)) $this->setEmailNew($arr[UserPeer::EMAIL_NEW]);
  
		if (array_key_exists(UserPeer::TIMEZONE, $arr)) $this->setTimezone($arr[UserPeer::TIMEZONE]);
  
		if (array_key_exists(UserPeer::DATE_FORMAT, $arr)) $this->setDateFormat($arr[UserPeer::DATE_FORMAT]);
  
		if (array_key_exists(UserPeer::ADDRESS, $arr)) $this->setAddress($arr[UserPeer::ADDRESS]);
  
		if (array_key_exists(UserPeer::ADDRESS2, $arr)) $this->setAddress2($arr[UserPeer::ADDRESS2]);
  
		if (array_key_exists(UserPeer::PHONE, $arr)) $this->setPhone($arr[UserPeer::PHONE]);
  
		if (array_key_exists(UserPeer::FAX, $arr)) $this->setFax($arr[UserPeer::FAX]);
  
		if (array_key_exists(UserPeer::TITLE, $arr)) $this->setTitle($arr[UserPeer::TITLE]);
  
		if (array_key_exists(UserPeer::FIRSTNAME, $arr)) $this->setFirstname($arr[UserPeer::FIRSTNAME]);
  
		if (array_key_exists(UserPeer::LASTNAME, $arr)) $this->setLastname($arr[UserPeer::LASTNAME]);
  
		if (array_key_exists(UserPeer::CCODE, $arr)) $this->setCcode($arr[UserPeer::CCODE]);
  
		if (array_key_exists(UserPeer::LANGUAGE_ID, $arr)) $this->setLanguageId($arr[UserPeer::LANGUAGE_ID]);
  
		if (array_key_exists(UserPeer::THEME_ID, $arr)) $this->setThemeId($arr[UserPeer::THEME_ID]);
  
		if (array_key_exists(UserPeer::EXTERNAL_ID, $arr)) $this->setExternalId($arr[UserPeer::EXTERNAL_ID]);
  
		if (array_key_exists(UserPeer::LAST_LOGIN, $arr)) $this->setLastLogin($arr[UserPeer::LAST_LOGIN]);
  
		if (array_key_exists(UserPeer::USER_TEXT1, $arr)) $this->setUserText1($arr[UserPeer::USER_TEXT1]);
  
		if (array_key_exists(UserPeer::USER_TEXT2, $arr)) $this->setUserText2($arr[UserPeer::USER_TEXT2]);
  
		if (array_key_exists(UserPeer::USER_TEXT3, $arr)) $this->setUserText3($arr[UserPeer::USER_TEXT3]);
  
		if (array_key_exists(UserPeer::USER_TEXT4, $arr)) $this->setUserText4($arr[UserPeer::USER_TEXT4]);
  
		if (array_key_exists(UserPeer::USER_TEXT5, $arr)) $this->setUserText5($arr[UserPeer::USER_TEXT5]);
  
		if (array_key_exists(UserPeer::USER_TEXT6, $arr)) $this->setUserText6($arr[UserPeer::USER_TEXT6]);
  
		if (array_key_exists(UserPeer::IS_GROUP, $arr)) $this->setIsGroup($arr[UserPeer::IS_GROUP]);
  
		if (array_key_exists(UserPeer::PASSWORD_CHANGE_DATE, $arr)) $this->setPasswordChangeDate($arr[UserPeer::PASSWORD_CHANGE_DATE]);
  
		if (array_key_exists(UserPeer::IS_RESTRICTED, $arr)) $this->setIsRestricted($arr[UserPeer::IS_RESTRICTED]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case UserPeer::USER_ID:
				$this->setUserId($value);
				break;
	  
			case UserPeer::UNIX_NAME:
				$this->setUnixName($value);
				break;
	  
			case UserPeer::EMAIL:
				$this->setEmail($value);
				break;
	  
			case UserPeer::STATUS:
				$this->setStatus($value);
				break;
	  
			case UserPeer::PASSWORD_MD5:
				$this->setPasswordMd5($value);
				break;
	  
			case UserPeer::PASSWORD_CRYPT:
				$this->setPasswordCrypt($value);
				break;
	  
			case UserPeer::CREATE_DATE:
				$this->setCreateDate($value);
				break;
	  
			case UserPeer::CONFIRM_HASH:
				$this->setConfirmHash($value);
				break;
	  
			case UserPeer::EMAIL_NEW:
				$this->setEmailNew($value);
				break;
	  
			case UserPeer::TIMEZONE:
				$this->setTimezone($value);
				break;
	  
			case UserPeer::DATE_FORMAT:
				$this->setDateFormat($value);
				break;
	  
			case UserPeer::ADDRESS:
				$this->setAddress($value);
				break;
	  
			case UserPeer::ADDRESS2:
				$this->setAddress2($value);
				break;
	  
			case UserPeer::PHONE:
				$this->setPhone($value);
				break;
	  
			case UserPeer::FAX:
				$this->setFax($value);
				break;
	  
			case UserPeer::TITLE:
				$this->setTitle($value);
				break;
	  
			case UserPeer::FIRSTNAME:
				$this->setFirstname($value);
				break;
	  
			case UserPeer::LASTNAME:
				$this->setLastname($value);
				break;
	  
			case UserPeer::CCODE:
				$this->setCcode($value);
				break;
	  
			case UserPeer::LANGUAGE_ID:
				$this->setLanguageId($value);
				break;
	  
			case UserPeer::THEME_ID:
				$this->setThemeId($value);
				break;
	  
			case UserPeer::EXTERNAL_ID:
				$this->setExternalId($value);
				break;
	  
			case UserPeer::LAST_LOGIN:
				$this->setLastLogin($value);
				break;
	  
			case UserPeer::USER_TEXT1:
				$this->setUserText1($value);
				break;
	  
			case UserPeer::USER_TEXT2:
				$this->setUserText2($value);
				break;
	  
			case UserPeer::USER_TEXT3:
				$this->setUserText3($value);
				break;
	  
			case UserPeer::USER_TEXT4:
				$this->setUserText4($value);
				break;
	  
			case UserPeer::USER_TEXT5:
				$this->setUserText5($value);
				break;
	  
			case UserPeer::USER_TEXT6:
				$this->setUserText6($value);
				break;
	  
			case UserPeer::IS_GROUP:
				$this->setIsGroup($value);
				break;
	  
			case UserPeer::PASSWORD_CHANGE_DATE:
				$this->setPasswordChangeDate($value);
				break;
	  
			case UserPeer::IS_RESTRICTED:
				$this->setIsRestricted($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setUserId($value);
				break;
  
			case 1:
				$this->setUnixName($value);
				break;
  
			case 2:
				$this->setEmail($value);
				break;
  
			case 3:
				$this->setStatus($value);
				break;
  
			case 4:
				$this->setPasswordMd5($value);
				break;
  
			case 5:
				$this->setPasswordCrypt($value);
				break;
  
			case 6:
				$this->setCreateDate($value);
				break;
  
			case 7:
				$this->setConfirmHash($value);
				break;
  
			case 8:
				$this->setEmailNew($value);
				break;
  
			case 9:
				$this->setTimezone($value);
				break;
  
			case 10:
				$this->setDateFormat($value);
				break;
  
			case 11:
				$this->setAddress($value);
				break;
  
			case 12:
				$this->setAddress2($value);
				break;
  
			case 13:
				$this->setPhone($value);
				break;
  
			case 14:
				$this->setFax($value);
				break;
  
			case 15:
				$this->setTitle($value);
				break;
  
			case 16:
				$this->setFirstname($value);
				break;
  
			case 17:
				$this->setLastname($value);
				break;
  
			case 18:
				$this->setCcode($value);
				break;
  
			case 19:
				$this->setLanguageId($value);
				break;
  
			case 20:
				$this->setThemeId($value);
				break;
  
			case 21:
				$this->setExternalId($value);
				break;
  
			case 22:
				$this->setLastLogin($value);
				break;
  
			case 23:
				$this->setUserText1($value);
				break;
  
			case 24:
				$this->setUserText2($value);
				break;
  
			case 25:
				$this->setUserText3($value);
				break;
  
			case 26:
				$this->setUserText4($value);
				break;
  
			case 27:
				$this->setUserText5($value);
				break;
  
			case 28:
				$this->setUserText6($value);
				break;
  
			case 29:
				$this->setIsGroup($value);
				break;
  
			case 30:
				$this->setPasswordChangeDate($value);
				break;
  
			case 31:
				$this->setIsRestricted($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserPeer::DATABASE_NAME);

		try {
			$con->begin();
			UserPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aCountryCode !== null) {
				if ($this->aCountryCode->isModified()) $this->aCountryCode->save($con);
				$this->setCountryCode($this->aCountryCode);
			}
 
			if ($this->aLanguage !== null) {
				if ($this->aLanguage->isModified()) $this->aLanguage->save($con);
				$this->setLanguage($this->aLanguage);
			}
 
			if ($this->aTheme !== null) {
				if ($this->aTheme->isModified()) $this->aTheme->save($con);
				$this->setTheme($this->aTheme);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UserPeer::doInsert($this, $con);
					$this->setUserId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					UserPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collAuditTrails !== null) {
				for ($i=0,$size=count($this->collAuditTrails); $i < $size; $i++) {
					$this->collAuditTrails[$i]->save($con);
				}
			  }
			if ($this->collCruisecontrols !== null) {
				for ($i=0,$size=count($this->collCruisecontrols); $i < $size; $i++) {
					$this->collCruisecontrols[$i]->save($con);
				}
			  }
			if ($this->collCruisecontrolAssignees !== null) {
				for ($i=0,$size=count($this->collCruisecontrolAssignees); $i < $size; $i++) {
					$this->collCruisecontrolAssignees[$i]->save($con);
				}
			  }
			if ($this->collCruisecontrolBuildChangeUsers !== null) {
				for ($i=0,$size=count($this->collCruisecontrolBuildChangeUsers); $i < $size; $i++) {
					$this->collCruisecontrolBuildChangeUsers[$i]->save($con);
				}
			  }
			if ($this->collDocmanFileVersions !== null) {
				for ($i=0,$size=count($this->collDocmanFileVersions); $i < $size; $i++) {
					$this->collDocmanFileVersions[$i]->save($con);
				}
			  }
			if ($this->collFilesystems !== null) {
				for ($i=0,$size=count($this->collFilesystems); $i < $size; $i++) {
					$this->collFilesystems[$i]->save($con);
				}
			  }
			if ($this->collForumMessages !== null) {
				for ($i=0,$size=count($this->collForumMessages); $i < $size; $i++) {
					$this->collForumMessages[$i]->save($con);
				}
			  }
			if ($this->collForumThreads !== null) {
				for ($i=0,$size=count($this->collForumThreads); $i < $size; $i++) {
					$this->collForumThreads[$i]->save($con);
				}
			  }
			if ($this->collFrsReleases !== null) {
				for ($i=0,$size=count($this->collFrsReleases); $i < $size; $i++) {
					$this->collFrsReleases[$i]->save($con);
				}
			  }
			if ($this->collMailmans !== null) {
				for ($i=0,$size=count($this->collMailmans); $i < $size; $i++) {
					$this->collMailmans[$i]->save($con);
				}
			  }
			if ($this->collMonitors !== null) {
				for ($i=0,$size=count($this->collMonitors); $i < $size; $i++) {
					$this->collMonitors[$i]->save($con);
				}
			  }
			if ($this->collNewss !== null) {
				for ($i=0,$size=count($this->collNewss); $i < $size; $i++) {
					$this->collNewss[$i]->save($con);
				}
			  }
			if ($this->collNotificationQueues !== null) {
				for ($i=0,$size=count($this->collNotificationQueues); $i < $size; $i++) {
					$this->collNotificationQueues[$i]->save($con);
				}
			  }
			if ($this->collProjectJoinRequests !== null) {
				for ($i=0,$size=count($this->collProjectJoinRequests); $i < $size; $i++) {
					$this->collProjectJoinRequests[$i]->save($con);
				}
			  }
			if ($this->collScmModuleUsers !== null) {
				for ($i=0,$size=count($this->collScmModuleUsers); $i < $size; $i++) {
					$this->collScmModuleUsers[$i]->save($con);
				}
			  }
			if ($this->collScmCommits !== null) {
				for ($i=0,$size=count($this->collScmCommits); $i < $size; $i++) {
					$this->collScmCommits[$i]->save($con);
				}
			  }
			if ($this->collJabberConnectedUsers !== null) {
				for ($i=0,$size=count($this->collJabberConnectedUsers); $i < $size; $i++) {
					$this->collJabberConnectedUsers[$i]->save($con);
				}
			  }
			if ($this->collScmUserStatss !== null) {
				for ($i=0,$size=count($this->collScmUserStatss); $i < $size; $i++) {
					$this->collScmUserStatss[$i]->save($con);
				}
			  }
			if ($this->collSiteAdmins !== null) {
				for ($i=0,$size=count($this->collSiteAdmins); $i < $size; $i++) {
					$this->collSiteAdmins[$i]->save($con);
				}
			  }
			if ($this->collSnippets !== null) {
				for ($i=0,$size=count($this->collSnippets); $i < $size; $i++) {
					$this->collSnippets[$i]->save($con);
				}
			  }
			if ($this->collSurveyResponses !== null) {
				for ($i=0,$size=count($this->collSurveyResponses); $i < $size; $i++) {
					$this->collSurveyResponses[$i]->save($con);
				}
			  }
			if ($this->collTrackerItems !== null) {
				for ($i=0,$size=count($this->collTrackerItems); $i < $size; $i++) {
					$this->collTrackerItems[$i]->save($con);
				}
			  }
			if ($this->collTrackerMyQueues !== null) {
				for ($i=0,$size=count($this->collTrackerMyQueues); $i < $size; $i++) {
					$this->collTrackerMyQueues[$i]->save($con);
				}
			  }
			if ($this->collTrackerItemAssignees !== null) {
				for ($i=0,$size=count($this->collTrackerItemAssignees); $i < $size; $i++) {
					$this->collTrackerItemAssignees[$i]->save($con);
				}
			  }
			if ($this->collTrackerItemMessages !== null) {
				for ($i=0,$size=count($this->collTrackerItemMessages); $i < $size; $i++) {
					$this->collTrackerItemMessages[$i]->save($con);
				}
			  }
			if ($this->collTrackerItemTimes !== null) {
				for ($i=0,$size=count($this->collTrackerItemTimes); $i < $size; $i++) {
					$this->collTrackerItemTimes[$i]->save($con);
				}
			  }
			if ($this->collTrackerQuerys !== null) {
				for ($i=0,$size=count($this->collTrackerQuerys); $i < $size; $i++) {
					$this->collTrackerQuerys[$i]->save($con);
				}
			  }
			if ($this->collUserPlugins !== null) {
				for ($i=0,$size=count($this->collUserPlugins); $i < $size; $i++) {
					$this->collUserPlugins[$i]->save($con);
				}
			  }
			if ($this->collUserPreferences !== null) {
				for ($i=0,$size=count($this->collUserPreferences); $i < $size; $i++) {
					$this->collUserPreferences[$i]->save($con);
				}
			  }
			if ($this->collUsergroupUsersRelatedByUsergroupId !== null) {
				for ($i=0,$size=count($this->collUsergroupUsersRelatedByUsergroupId); $i < $size; $i++) {
					$this->collUsergroupUsersRelatedByUsergroupId[$i]->save($con);
				}
			  }
			if ($this->collUsergroupUsersRelatedByMemberUserId !== null) {
				for ($i=0,$size=count($this->collUsergroupUsersRelatedByMemberUserId); $i < $size; $i++) {
					$this->collUsergroupUsersRelatedByMemberUserId[$i]->save($con);
				}
			  }
			if ($this->collUserProjects !== null) {
				for ($i=0,$size=count($this->collUserProjects); $i < $size; $i++) {
					$this->collUserProjects[$i]->save($con);
				}
			  }
			if ($this->collUserSessions !== null) {
				for ($i=0,$size=count($this->collUserSessions); $i < $size; $i++) {
					$this->collUserSessions[$i]->save($con);
				}
			  }
			if ($this->collUserUnixs !== null) {
				for ($i=0,$size=count($this->collUserUnixs); $i < $size; $i++) {
					$this->collUserUnixs[$i]->save($con);
				}
			  }
			if ($this->collUserWatchedProjects !== null) {
				for ($i=0,$size=count($this->collUserWatchedProjects); $i < $size; $i++) {
					$this->collUserWatchedProjects[$i]->save($con);
				}
			  }
			if ($this->collWikiVersions !== null) {
				for ($i=0,$size=count($this->collWikiVersions); $i < $size; $i++) {
					$this->collWikiVersions[$i]->save($con);
				}
			  }
			if ($this->collMyReportUsers !== null) {
				for ($i=0,$size=count($this->collMyReportUsers); $i < $size; $i++) {
					$this->collMyReportUsers[$i]->save($con);
				}
			  }
			if ($this->collMyReports !== null) {
				for ($i=0,$size=count($this->collMyReports); $i < $size; $i++) {
					$this->collMyReports[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return UserPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aCountryCode !== null) {
				if (($retval = $this->aCountryCode->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aLanguage !== null) {
				if (($retval = $this->aLanguage->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aTheme !== null) {
				if (($retval = $this->aTheme->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = UserPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collAuditTrails !== null) {
				for ($i=0,$size=count($this->collAuditTrails); $i < $size; $i++) {
					if (($retval = $this->collAuditTrails[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collCruisecontrols !== null) {
				for ($i=0,$size=count($this->collCruisecontrols); $i < $size; $i++) {
					if (($retval = $this->collCruisecontrols[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collCruisecontrolAssignees !== null) {
				for ($i=0,$size=count($this->collCruisecontrolAssignees); $i < $size; $i++) {
					if (($retval = $this->collCruisecontrolAssignees[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collCruisecontrolBuildChangeUsers !== null) {
				for ($i=0,$size=count($this->collCruisecontrolBuildChangeUsers); $i < $size; $i++) {
					if (($retval = $this->collCruisecontrolBuildChangeUsers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collDocmanFileVersions !== null) {
				for ($i=0,$size=count($this->collDocmanFileVersions); $i < $size; $i++) {
					if (($retval = $this->collDocmanFileVersions[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collFilesystems !== null) {
				for ($i=0,$size=count($this->collFilesystems); $i < $size; $i++) {
					if (($retval = $this->collFilesystems[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collForumMessages !== null) {
				for ($i=0,$size=count($this->collForumMessages); $i < $size; $i++) {
					if (($retval = $this->collForumMessages[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collForumThreads !== null) {
				for ($i=0,$size=count($this->collForumThreads); $i < $size; $i++) {
					if (($retval = $this->collForumThreads[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collFrsReleases !== null) {
				for ($i=0,$size=count($this->collFrsReleases); $i < $size; $i++) {
					if (($retval = $this->collFrsReleases[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collMailmans !== null) {
				for ($i=0,$size=count($this->collMailmans); $i < $size; $i++) {
					if (($retval = $this->collMailmans[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collMonitors !== null) {
				for ($i=0,$size=count($this->collMonitors); $i < $size; $i++) {
					if (($retval = $this->collMonitors[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collNewss !== null) {
				for ($i=0,$size=count($this->collNewss); $i < $size; $i++) {
					if (($retval = $this->collNewss[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collNotificationQueues !== null) {
				for ($i=0,$size=count($this->collNotificationQueues); $i < $size; $i++) {
					if (($retval = $this->collNotificationQueues[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collProjectJoinRequests !== null) {
				for ($i=0,$size=count($this->collProjectJoinRequests); $i < $size; $i++) {
					if (($retval = $this->collProjectJoinRequests[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collScmModuleUsers !== null) {
				for ($i=0,$size=count($this->collScmModuleUsers); $i < $size; $i++) {
					if (($retval = $this->collScmModuleUsers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collScmCommits !== null) {
				for ($i=0,$size=count($this->collScmCommits); $i < $size; $i++) {
					if (($retval = $this->collScmCommits[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collJabberConnectedUsers !== null) {
				for ($i=0,$size=count($this->collJabberConnectedUsers); $i < $size; $i++) {
					if (($retval = $this->collJabberConnectedUsers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collScmUserStatss !== null) {
				for ($i=0,$size=count($this->collScmUserStatss); $i < $size; $i++) {
					if (($retval = $this->collScmUserStatss[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collSiteAdmins !== null) {
				for ($i=0,$size=count($this->collSiteAdmins); $i < $size; $i++) {
					if (($retval = $this->collSiteAdmins[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collSnippets !== null) {
				for ($i=0,$size=count($this->collSnippets); $i < $size; $i++) {
					if (($retval = $this->collSnippets[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collSurveyResponses !== null) {
				for ($i=0,$size=count($this->collSurveyResponses); $i < $size; $i++) {
					if (($retval = $this->collSurveyResponses[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerItems !== null) {
				for ($i=0,$size=count($this->collTrackerItems); $i < $size; $i++) {
					if (($retval = $this->collTrackerItems[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerMyQueues !== null) {
				for ($i=0,$size=count($this->collTrackerMyQueues); $i < $size; $i++) {
					if (($retval = $this->collTrackerMyQueues[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerItemAssignees !== null) {
				for ($i=0,$size=count($this->collTrackerItemAssignees); $i < $size; $i++) {
					if (($retval = $this->collTrackerItemAssignees[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerItemMessages !== null) {
				for ($i=0,$size=count($this->collTrackerItemMessages); $i < $size; $i++) {
					if (($retval = $this->collTrackerItemMessages[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerItemTimes !== null) {
				for ($i=0,$size=count($this->collTrackerItemTimes); $i < $size; $i++) {
					if (($retval = $this->collTrackerItemTimes[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerQuerys !== null) {
				for ($i=0,$size=count($this->collTrackerQuerys); $i < $size; $i++) {
					if (($retval = $this->collTrackerQuerys[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collUserPlugins !== null) {
				for ($i=0,$size=count($this->collUserPlugins); $i < $size; $i++) {
					if (($retval = $this->collUserPlugins[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collUserPreferences !== null) {
				for ($i=0,$size=count($this->collUserPreferences); $i < $size; $i++) {
					if (($retval = $this->collUserPreferences[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collUsergroupUsersRelatedByUsergroupId !== null) {
				for ($i=0,$size=count($this->collUsergroupUsersRelatedByUsergroupId); $i < $size; $i++) {
					if (($retval = $this->collUsergroupUsersRelatedByUsergroupId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collUsergroupUsersRelatedByMemberUserId !== null) {
				for ($i=0,$size=count($this->collUsergroupUsersRelatedByMemberUserId); $i < $size; $i++) {
					if (($retval = $this->collUsergroupUsersRelatedByMemberUserId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collUserProjects !== null) {
				for ($i=0,$size=count($this->collUserProjects); $i < $size; $i++) {
					if (($retval = $this->collUserProjects[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collUserSessions !== null) {
				for ($i=0,$size=count($this->collUserSessions); $i < $size; $i++) {
					if (($retval = $this->collUserSessions[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collUserUnixs !== null) {
				for ($i=0,$size=count($this->collUserUnixs); $i < $size; $i++) {
					if (($retval = $this->collUserUnixs[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collUserWatchedProjects !== null) {
				for ($i=0,$size=count($this->collUserWatchedProjects); $i < $size; $i++) {
					if (($retval = $this->collUserWatchedProjects[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collWikiVersions !== null) {
				for ($i=0,$size=count($this->collWikiVersions); $i < $size; $i++) {
					if (($retval = $this->collWikiVersions[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collMyReportUsers !== null) {
				for ($i=0,$size=count($this->collMyReportUsers); $i < $size; $i++) {
					if (($retval = $this->collMyReportUsers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collMyReports !== null) {
				for ($i=0,$size=count($this->collMyReports); $i < $size; $i++) {
					if (($retval = $this->collMyReports[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed user_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setUserId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getUserId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return User Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new User();
		$copyObj->setUnixName($this->unix_name);
		$copyObj->setEmail($this->email);
		$copyObj->setStatus($this->status);
		$copyObj->setPasswordMd5($this->password_md5);
		$copyObj->setPasswordCrypt($this->password_crypt);
		$copyObj->setCreateDate($this->create_date);
		$copyObj->setConfirmHash($this->confirm_hash);
		$copyObj->setEmailNew($this->email_new);
		$copyObj->setTimezone($this->timezone);
		$copyObj->setDateFormat($this->date_format);
		$copyObj->setAddress($this->address);
		$copyObj->setAddress2($this->address2);
		$copyObj->setPhone($this->phone);
		$copyObj->setFax($this->fax);
		$copyObj->setTitle($this->title);
		$copyObj->setFirstname($this->firstname);
		$copyObj->setLastname($this->lastname);
		$copyObj->setCcode($this->ccode);
		$copyObj->setLanguageId($this->language_id);
		$copyObj->setThemeId($this->theme_id);
		$copyObj->setExternalId($this->external_id);
		$copyObj->setLastLogin($this->last_login);
		$copyObj->setUserText1($this->user_text1);
		$copyObj->setUserText2($this->user_text2);
		$copyObj->setUserText3($this->user_text3);
		$copyObj->setUserText4($this->user_text4);
		$copyObj->setUserText5($this->user_text5);
		$copyObj->setUserText6($this->user_text6);
		$copyObj->setIsGroup($this->is_group);
		$copyObj->setPasswordChangeDate($this->password_change_date);
		$copyObj->setIsRestricted($this->is_restricted);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getAuditTrails() as $relObj) {
				$copyObj->addAuditTrail($relObj->copy());
			}

			foreach($this->getCruisecontrols() as $relObj) {
				$copyObj->addCruisecontrol($relObj->copy());
			}

			foreach($this->getCruisecontrolAssignees() as $relObj) {
				$copyObj->addCruisecontrolAssignee($relObj->copy());
			}

			foreach($this->getCruisecontrolBuildChangeUsers() as $relObj) {
				$copyObj->addCruisecontrolBuildChangeUser($relObj->copy());
			}

			foreach($this->getDocmanFileVersions() as $relObj) {
				$copyObj->addDocmanFileVersion($relObj->copy());
			}

			foreach($this->getFilesystems() as $relObj) {
				$copyObj->addFilesystem($relObj->copy());
			}

			foreach($this->getForumMessages() as $relObj) {
				$copyObj->addForumMessage($relObj->copy());
			}

			foreach($this->getForumThreads() as $relObj) {
				$copyObj->addForumThread($relObj->copy());
			}

			foreach($this->getFrsReleases() as $relObj) {
				$copyObj->addFrsRelease($relObj->copy());
			}

			foreach($this->getMailmans() as $relObj) {
				$copyObj->addMailman($relObj->copy());
			}

			foreach($this->getMonitors() as $relObj) {
				$copyObj->addMonitor($relObj->copy());
			}

			foreach($this->getNewss() as $relObj) {
				$copyObj->addNews($relObj->copy());
			}

			foreach($this->getNotificationQueues() as $relObj) {
				$copyObj->addNotificationQueue($relObj->copy());
			}

			foreach($this->getProjectJoinRequests() as $relObj) {
				$copyObj->addProjectJoinRequest($relObj->copy());
			}

			foreach($this->getScmModuleUsers() as $relObj) {
				$copyObj->addScmModuleUser($relObj->copy());
			}

			foreach($this->getScmCommits() as $relObj) {
				$copyObj->addScmCommit($relObj->copy());
			}

			foreach($this->getJabberConnectedUsers() as $relObj) {
				$copyObj->addJabberConnectedUser($relObj->copy());
			}

			foreach($this->getScmUserStatss() as $relObj) {
				$copyObj->addScmUserStats($relObj->copy());
			}

			foreach($this->getSiteAdmins() as $relObj) {
				$copyObj->addSiteAdmin($relObj->copy());
			}

			foreach($this->getSnippets() as $relObj) {
				$copyObj->addSnippet($relObj->copy());
			}

			foreach($this->getSurveyResponses() as $relObj) {
				$copyObj->addSurveyResponse($relObj->copy());
			}

			foreach($this->getTrackerItems() as $relObj) {
				$copyObj->addTrackerItem($relObj->copy());
			}

			foreach($this->getTrackerMyQueues() as $relObj) {
				$copyObj->addTrackerMyQueue($relObj->copy());
			}

			foreach($this->getTrackerItemAssignees() as $relObj) {
				$copyObj->addTrackerItemAssignee($relObj->copy());
			}

			foreach($this->getTrackerItemMessages() as $relObj) {
				$copyObj->addTrackerItemMessage($relObj->copy());
			}

			foreach($this->getTrackerItemTimes() as $relObj) {
				$copyObj->addTrackerItemTime($relObj->copy());
			}

			foreach($this->getTrackerQuerys() as $relObj) {
				$copyObj->addTrackerQuery($relObj->copy());
			}

			foreach($this->getUserPlugins() as $relObj) {
				$copyObj->addUserPlugin($relObj->copy());
			}

			foreach($this->getUserPreferences() as $relObj) {
				$copyObj->addUserPreference($relObj->copy());
			}

			foreach($this->getUsergroupUsersRelatedByUsergroupId() as $relObj) {
				$copyObj->addUsergroupUserRelatedByUsergroupId($relObj->copy());
			}

			foreach($this->getUsergroupUsersRelatedByMemberUserId() as $relObj) {
				$copyObj->addUsergroupUserRelatedByMemberUserId($relObj->copy());
			}

			foreach($this->getUserProjects() as $relObj) {
				$copyObj->addUserProject($relObj->copy());
			}

			foreach($this->getUserSessions() as $relObj) {
				$copyObj->addUserSession($relObj->copy());
			}

			foreach($this->getUserUnixs() as $relObj) {
				$copyObj->addUserUnix($relObj->copy());
			}

			foreach($this->getUserWatchedProjects() as $relObj) {
				$copyObj->addUserWatchedProject($relObj->copy());
			}

			foreach($this->getWikiVersions() as $relObj) {
				$copyObj->addWikiVersion($relObj->copy());
			}

			foreach($this->getMyReportUsers() as $relObj) {
				$copyObj->addMyReportUser($relObj->copy());
			}

			foreach($this->getMyReports() as $relObj) {
				$copyObj->addMyReport($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setUserId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return UserPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UserPeer();
		}
		return self::$peer;
	}

}
